<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Premium_Admin_Conditions_Billing_Address' ) ) {

    class WOOPCD_PartialCOD_Premium_Admin_Conditions_Billing_Address {

        public static function init() {

            add_filter( 'woopcd_partialcod-admin/get-billing_continents-condition-fields', array( new self(), 'get_continents_fields' ), 10, 2 );
        }

        public static function get_continents_fields( $in_fields, $args ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => 'in_list',
                'options' => array(
                    'in_list' => esc_html__( 'Any in the list', 'woopcd-partialcod-pro' ),
                    'none' => esc_html__( 'None in the list', 'woopcd-partialcod-pro' ),
                ),
                'width' => '98%',
                'box_width' => '26%',
            );

            $in_fields[] = array(
                'id' => 'continents',
                'type' => 'select2',
                'multiple' => true,
                'allow_clear' => true,
                'minimum_input_length' => 1,
                'minimum_results_forsearch' => 10,
                'placeholder' => esc_html__( 'Billing Continents...', 'woopcd-partialcod-pro' ),
                'ajax_data' => 'wc:continents',
                'width' => '100%',
                'box_width' => '74%',
            );

            return $in_fields;
        }

    }

    WOOPCD_PartialCOD_Premium_Admin_Conditions_Billing_Address::init();
}
