<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Conditions_Cart_Item_Subtotals' ) ) {

    class WOOPCD_PartialCOD_Admin_Conditions_Cart_Item_Subtotals {

        public static function init() {

            add_filter( 'woopcd_partialcod-admin/get-condition-groups', array( new self(), 'get_groups' ), 80, 2 );

            add_filter( 'woopcd_partialcod-admin/get-cart_item_subtotals-group-conditions', array( new self(), 'get_conditions' ), 10, 2 );

            add_filter( 'woopcd_partialcod-admin/get-cart_subtotal_products-condition-fields', array( new self(), 'get_cart_subtotal_products_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_subtotal_variations-condition-fields', array( new self(), 'get_cart_subtotal_variations_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_subtotal_categories-condition-fields', array( new self(), 'get_cart_subtotal_categories_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_subtotal_tags-condition-fields', array( new self(), 'get_cart_subtotal_tags_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_subtotal_attributes-condition-fields', array( new self(), 'get_cart_subtotal_attributes_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_subtotal_virtuals-condition-fields', array( new self(), 'get_cart_subtotal_virtual_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_subtotal_tax_classes-condition-fields', array( new self(), 'get_cart_subtotal_tax_classes_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_subtotal_shipping_classes-condition-fields', array( new self(), 'get_cart_subtotal_shipping_classes_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_subtotal_metas-condition-fields', array( new self(), 'get_cart_subtotal_metas_fields' ), 10 );
        }

        public static function get_groups( $in_groups, $args ) {

            $in_groups[ 'cart_item_subtotals' ] = esc_html__( 'Cart Item Subtotals', 'woopcd-partialcod-pro' );

            return $in_groups;
        }

        public static function get_conditions( $in_list, $args ) {

            $in_list[ 'cart_subtotal_products' ] = esc_html__( 'Products Subtotal', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_subtotal_variations' ] = esc_html__( 'Variations Subtotal', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_subtotal_categories' ] = esc_html__( 'Categories Subtotal', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_subtotal_tags' ] = esc_html__( 'Tags Subtotal', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_subtotal_attributes' ] = esc_html__( 'Attributes Subtotal', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_subtotal_virtuals' ] = esc_html__( 'Virtual Products Subtotal', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_subtotal_tax_classes' ] = esc_html__( 'Tax Classes Subtotal', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_subtotal_shipping_classes' ] = esc_html__( 'Shipping Classes Subtotal', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_subtotal_metas' ] = esc_html__( 'Product Meta Fields Subtotal', 'woopcd-partialcod-pro' );

            return $in_list;
        }

        public static function get_cart_subtotal_products_fields( $in_fields ) {

            $in_fields[] = array(
                'id' => 'product_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 1,
                'placeholder' => esc_html__('Search products...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'wc:products',
                    'ajax' => true,
                    'value_col' => 'slug',
                    'show_value' => false,
                ),
                'width' => '99%',
                'box_width' => '52%',
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>=',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '33%',
            );

            $in_fields[] = array(
                'id' => 'subtotal',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.00',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '15%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
            );


            return $in_fields;
        }

        public static function get_cart_subtotal_variations_fields( $in_fields ) {
            $in_fields[] = array(
                'id' => 'variation_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 1,
                'placeholder' => esc_html__('Search variations...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'wc:product_variations',
                    'ajax' => true,
                    'value_col' => 'slug',
                    'show_value' => false,
                ),
                'width' => '99%',
                'box_width' => '52%',
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>=',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '33%',
            );

            $in_fields[] = array(
                'id' => 'subtotal',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.00',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '15%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
            );


            return $in_fields;
        }

        public static function get_cart_subtotal_categories_fields( $in_fields ) {

            $in_fields[] = array(
                'id' => 'category_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 1,
                'placeholder' => esc_html__('Search categories...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'categories:product_cat',
                    'ajax' => true,
                    'value_col' => 'slug',
                    'show_value' => false,
                ),
                'width' => '99%',
                'box_width' => '52%',
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>=',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '33%',
            );

            $in_fields[] = array(
                'id' => 'subtotal',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.00',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '15%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
            );


            return $in_fields;
        }

        public static function get_cart_subtotal_tags_fields( $in_fields ) {

            $in_fields[] = array(
                'id' => 'tag_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 1,
                'placeholder' => esc_html__('Search tags...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'categories:product_tag',
                    'ajax' => true,
                    'value_col' => 'slug',
                    'show_value' => false,
                ),
                'width' => '99%',
                'box_width' => '52%',
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>=',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '33%',
            );

            $in_fields[] = array(
                'id' => 'subtotal',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.00',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '15%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
            );


            return $in_fields;
        }

        public static function get_cart_subtotal_attributes_fields( $in_fields ) {
            $in_fields[] = array(
                'id' => 'attribute_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 1,
                'placeholder' => esc_html__('Search attributes...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'wc:attributes',
                    'ajax' => true,
                    'value_col' => 'slug',
                    'show_value' => false,
                ),
                'width' => '99%',
                'box_width' => '52%',
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>=',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '33%',
            );

            $in_fields[] = array(
                'id' => 'subtotal',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.00',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '15%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
            );


            return $in_fields;
        }

        public static function get_cart_subtotal_virtual_fields( $in_fields ) {
            $in_fields[] = array(
                'id' => 'is_virtual',
                'type' => 'select2',
                'default' => 'yes',
                'options' => array(
                    'no' => esc_html__( 'None-virtual products', 'woopcd-partialcod-pro' ),
                    'yes' => esc_html__( 'Virtual products', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '50%',
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>=',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '35%',
            );

            $in_fields[] = array(
                'id' => 'subtotal',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.00',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '15%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
            );


            return $in_fields;
        }

        public static function get_cart_subtotal_tax_classes_fields( $in_fields ) {
            $in_fields[] = array(
                'id' => 'tax_classes',
                'type' => 'select2',
                'multiple' => true,
                'placeholder' => esc_html__( 'Select tax classes...', 'woopcd-partialcod-pro' ),
                'options' => array(
                    '--0' => esc_html__( 'Standard Rate', 'woopcd-partialcod-pro' )
                ),
                'data' => array(
                    'source' => 'wc:tax_classes',
                    'ajax' => false,
                    'value_col' => 'slug',
                ),
                'width' => '99%',
                'box_width' => '52%',
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>=',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '33%',
            );

            $in_fields[] = array(
                'id' => 'subtotal',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.00',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '15%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
            );


            return $in_fields;
        }

        public static function get_cart_subtotal_shipping_classes_fields( $in_fields ) {
            $in_fields[] = array(
                'id' => 'shipping_classes',
                'type' => 'select2',
                'multiple' => true,
                'placeholder' => esc_html__( 'Select shipping classes...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'wc:shipping_classes',
                    'ajax' => false,
                    'value_col' => 'slug',
                ),
                'width' => '99%',
                'box_width' => '52%',
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>=',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '33%',
            );

            $in_fields[] = array(
                'id' => 'subtotal',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.00',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '15%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
            );


            return $in_fields;
        }

        public static function get_cart_subtotal_metas_fields( $in_fields ) {

            $in_fields[] = array(
                'id' => 'meta_key',
                'type' => 'textbox',
                'input_type' => 'text',
                'default' => '',
                'placeholder' => esc_html__( 'Meta field key', 'woopcd-partialcod-pro' ),
                'width' => '98%',
                'box_width' => '26%',
            );

            $in_fields[] = array(
                'id' => 'meta_value',
                'type' => 'textbox',
                'input_type' => 'text',
                'default' => '',
                'placeholder' => esc_html__( 'Meta field value', 'woopcd-partialcod-pro' ),
                'width' => '98%',
                'box_width' => '26%',
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>=',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '33%',
            );

            $in_fields[] = array(
                'id' => 'subtotal',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.00',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '15%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
            );


            return $in_fields;
        }

    }

    WOOPCD_PartialCOD_Admin_Conditions_Cart_Item_Subtotals::init();
}