<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Conditions_Cart_Items' ) ) {

    class WOOPCD_PartialCOD_Admin_Conditions_Cart_Items {

        public static function init() {

            add_filter( 'woopcd_partialcod-admin/get-condition-groups', array( new self(), 'get_groups' ), 70, 2 );

            add_filter( 'woopcd_partialcod-admin/get-cart_items-group-conditions', array( new self(), 'get_conditions' ), 10, 2 );

            add_filter( 'woopcd_partialcod-admin/get-cart_item_products-condition-fields', array( new self(), 'get_cart_item_products_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_item_variations-condition-fields', array( new self(), 'get_cart_item_variations_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_item_categories-condition-fields', array( new self(), 'get_cart_item_categories_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_item_tags-condition-fields', array( new self(), 'get_cart_item_tags_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_item_attributes-condition-fields', array( new self(), 'get_cart_item_attributes_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_item_virtuals-condition-fields', array( new self(), 'get_cart_item_virtuals_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_item_tax_classes-condition-fields', array( new self(), 'get_cart_item_tax_classes_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_item_shipping_classes-condition-fields', array( new self(), 'get_cart_item_shipping_classes_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-cart_item_metas-condition-fields', array( new self(), 'get_cart_item_metas_fields' ), 10 );
        }

        public static function get_groups( $in_groups, $args ) {

            $in_groups[ 'cart_items' ] = esc_html__( 'Items In Cart', 'woopcd-partialcod-pro' );

            return $in_groups;
        }

        public static function get_conditions( $in_list, $args ) {

            $in_list[ 'cart_item_products' ] = esc_html__( 'Products In Cart', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_item_variations' ] = esc_html__( 'Variations In Cart', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_item_categories' ] = esc_html__( 'Categories In Cart', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_item_tags' ] = esc_html__( 'Tags In Cart', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_item_attributes' ] = esc_html__( 'Attributes In Cart', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_item_virtuals' ] = esc_html__( 'Virtual Products In Cart', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_item_tax_classes' ] = esc_html__( 'Tax Classes In Cart', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_item_shipping_classes' ] = esc_html__( 'Shipping Classes In Cart', 'woopcd-partialcod-pro' );
            $in_list[ 'cart_item_metas' ] = esc_html__( 'Product Meta Fields In Cart', 'woopcd-partialcod-pro' );

            return $in_list;
        }

        public static function get_cart_item_products_fields( $in_fields ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => 'in_list',
                'options' => array(
                    'in_list' => esc_html__( 'Any in the list', 'woopcd-partialcod-pro' ),
                    'in_all_list' => esc_html__( 'All in the list', 'woopcd-partialcod-pro' ),
                    'in_list_only' => esc_html__( 'Only in the list', 'woopcd-partialcod-pro' ),
                    'in_all_list_only' => esc_html__( 'Only all in the list', 'woopcd-partialcod-pro' ),
                    'none' => esc_html__( 'None in the list', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '29%',
            );

            $in_fields[] = array(
                'id' => 'product_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 2,
                'placeholder' => esc_html__( 'Search products...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'wc:products',
                    'ajax' => true,
                    'value_col' => 'slug',
                ),
                'width' => '100%',
                'box_width' => '71%',
            );

            return $in_fields;
        }

        public static function get_cart_item_variations_fields( $in_fields ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => 'in_list',
                'options' => array(
                    'in_list' => esc_html__( 'Any in the list', 'woopcd-partialcod-pro' ),
                    'in_all_list' => esc_html__( 'All in the list', 'woopcd-partialcod-pro' ),
                    'in_list_only' => esc_html__( 'Only in the list', 'woopcd-partialcod-pro' ),
                    'in_all_list_only' => esc_html__( 'Only all in the list', 'woopcd-partialcod-pro' ),
                    'none' => esc_html__( 'None in the list', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '29%',
            );

            $in_fields[] = array(
                'id' => 'variation_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 1,
                'placeholder' => esc_html__( 'Search variations...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'wc:product_variations',
                    'ajax' => true,
                    'value_col' => 'slug',
                ),
                'width' => '100%',
                'box_width' => '71%',
            );

            return $in_fields;
        }

        public static function get_cart_item_categories_fields( $in_fields ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => 'in_list',
                'options' => array(
                    'in_list' => esc_html__( 'Any in the list', 'woopcd-partialcod-pro' ),
                    'in_all_list' => esc_html__( 'All in the list', 'woopcd-partialcod-pro' ),
                    'in_list_only' => esc_html__( 'Only in the list', 'woopcd-partialcod-pro' ),
                    'in_all_list_only' => esc_html__( 'Only all in the list', 'woopcd-partialcod-pro' ),
                    'none' => esc_html__( 'None in the list', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '29%',
            );

            $in_fields[] = array(
                'id' => 'category_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 1,
                'placeholder' => esc_html__( 'Search categories...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'categories:product_cat',
                    'ajax' => true,
                    'value_col' => 'slug',
                ),
                'width' => '100%',
                'box_width' => '71%',
            );

            return $in_fields;
        }

        public static function get_cart_item_tags_fields( $in_fields ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => 'in_list',
                'options' => array(
                    'in_list' => esc_html__( 'Any in the list', 'woopcd-partialcod-pro' ),
                    'in_all_list' => esc_html__( 'All in the list', 'woopcd-partialcod-pro' ),
                    'in_list_only' => esc_html__( 'Only in the list', 'woopcd-partialcod-pro' ),
                    'in_all_list_only' => esc_html__( 'Only all in the list', 'woopcd-partialcod-pro' ),
                    'none' => esc_html__( 'None in the list', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '29%',
            );

            $in_fields[] = array(
                'id' => 'tag_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 1,
                'placeholder' => esc_html__( 'Search tags...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'categories:product_tag',
                    'ajax' => true,
                    'value_col' => 'slug',
                ),
                'width' => '100%',
                'box_width' => '71%',
            );

            return $in_fields;
        }

        public static function get_cart_item_attributes_fields( $in_fields ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => 'in_list',
                'options' => array(
                    'in_list' => esc_html__( 'Any in the list', 'woopcd-partialcod-pro' ),
                    'in_all_list' => esc_html__( 'All in the list', 'woopcd-partialcod-pro' ),
                    'in_list_only' => esc_html__( 'Only in the list', 'woopcd-partialcod-pro' ),
                    'in_all_list_only' => esc_html__( 'Only all in the list', 'woopcd-partialcod-pro' ),
                    'none' => esc_html__( 'None in the list', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '29%',
            );

            $in_fields[] = array(
                'id' => 'attribute_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 1,
                'placeholder' => esc_html__( 'Search attributes...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'wc:attributes',
                    'ajax' => true,
                    'value_col' => 'slug',
                ),
                'width' => '100%',
                'box_width' => '71%',
            );

            return $in_fields;
        }

        public static function get_cart_item_virtuals_fields( $in_fields ) {

            $in_fields[] = array(
                'id' => 'is_virtual',
                'type' => 'select2',
                'default' => 'yes',
                'options' => array(
                    'no' => esc_html__( 'No', 'woopcd-partialcod-pro' ),
                    'yes' => esc_html__( 'Yes', 'woopcd-partialcod-pro' ),
                ),
                'width' => '100%',
                'box_width' => '100%',
            );


            return $in_fields;
        }

        public static function get_cart_item_tax_classes_fields( $in_fields ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => 'in_list',
                'options' => array(
                    'in_list' => esc_html__( 'Any in the list', 'woopcd-partialcod-pro' ),
                    'in_all_list' => esc_html__( 'All in the list', 'woopcd-partialcod-pro' ),
                    'in_list_only' => esc_html__( 'Only in the list', 'woopcd-partialcod-pro' ),
                    'in_all_list_only' => esc_html__( 'Only all in the list', 'woopcd-partialcod-pro' ),
                    'none' => esc_html__( 'None in the list', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '29%',
            );

            $in_fields[] = array(
                'id' => 'tax_classes',
                'type' => 'select2',
                'multiple' => true,
                'placeholder' => esc_html__( 'Select tax classes...', 'woopcd-partialcod-pro' ),
                'options' => array(
                    '--0' => esc_html__( 'Standard Rate', 'woopcd-partialcod-pro' )
                ),
                'data' => array(
                    'source' => 'wc:tax_classes',
                    'ajax' => false,
                    'value_col' => 'slug',
                ),
                'width' => '100%',
                'box_width' => '71%',
            );

            return $in_fields;
        }

        public static function get_cart_item_shipping_classes_fields( $in_fields ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => 'in_list',
                'options' => array(
                    'in_list' => esc_html__( 'Any in the list', 'woopcd-partialcod-pro' ),
                    'in_all_list' => esc_html__( 'All in the list', 'woopcd-partialcod-pro' ),
                    'in_list_only' => esc_html__( 'Only in the list', 'woopcd-partialcod-pro' ),
                    'in_all_list_only' => esc_html__( 'Only all in the list', 'woopcd-partialcod-pro' ),
                    'none' => esc_html__( 'None in the list', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '29%',
            );

            $in_fields[] = array(
                'id' => 'shipping_classes',
                'type' => 'select2',
                'multiple' => true,
                'placeholder' => esc_html__( 'Select shipping classes...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'wc:shipping_classes',
                    'ajax' => false,
                    'value_col' => 'slug',
                ),
                'width' => '100%',
                'box_width' => '71%',
            );

            return $in_fields;
        }

        public static function get_cart_item_metas_fields( $in_fields ) {

            $in_fields[] = array(
                'id' => 'meta_key',
                'type' => 'textbox',
                'input_type' => 'text',
                'default' => '',
                'placeholder' => esc_html__( 'Meta field key', 'woopcd-partialcod-pro' ),
                'width' => '98%',
                'box_width' => '40%',
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => 'empty',
                'options' => array(
                    'empty' => esc_html__( 'Empty', 'woopcd-partialcod-pro' ),
                    'contains' => esc_html__( 'Contains', 'woopcd-partialcod-pro' ),
                    'not_contains' => esc_html__( 'Not contains', 'woopcd-partialcod-pro' ),
                    'begins' => esc_html__( 'Begins with', 'woopcd-partialcod-pro' ),
                    'ends' => esc_html__( 'Ends with', 'woopcd-partialcod-pro' ),
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                    'checked' => esc_html__( 'Checked', 'woopcd-partialcod-pro' ),
                ),
                'fold_id' => 'meta_field_compare',
                'width' => '98%',
                'box_width' => '34%',
            );


            $in_fields[] = array(
                'id' => 'meta_value',
                'type' => 'textbox',
                'input_type' => 'text',
                'default' => '',
                'placeholder' => esc_html__( 'Value', 'woopcd-partialcod-pro' ),
                'fold' => array(
                    'target' => 'meta_field_compare',
                    'attribute' => 'value',
                    'value' => array( 'contains', 'not_contains', 'begins', 'ends', '>=', '>', '<=', '<', '==', '!=' ),
                    'oparator' => 'eq',
                    'clear' => true,
                ),
                'width' => '100%',
                'box_width' => '26%',
            );


            $in_fields[] = array(
                'id' => 'yes_no',
                'type' => 'select2',
                'default' => 'no',
                'options' => array(
                    'no' => esc_html__( 'No', 'woopcd-partialcod-pro' ),
                    'yes' => esc_html__( 'Yes', 'woopcd-partialcod-pro' ),
                ),
                'fold' => array(
                    'target' => 'meta_field_compare',
                    'attribute' => 'value',
                    'value' => array( 'empty', 'checked' ),
                    'oparator' => 'eq',
                    'clear' => false,
                ),
                'width' => '100%',
                'box_width' => '26%',
            );



            return $in_fields;
        }

    }

    WOOPCD_PartialCOD_Admin_Conditions_Cart_Items::init();
}