<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Conditions_Purchase_History_Subtotals' ) ) {

    class WOOPCD_PartialCOD_Admin_Conditions_Purchase_History_Subtotals {

        public static function init() {
            add_filter( 'woopcd_partialcod-admin/get-condition-groups', array( new self(), 'get_groups' ), 140, 2 );

            add_filter( 'woopcd_partialcod-admin/get-purchase_history_subtotal-group-conditions', array( new self(), 'get_conditions' ), 10, 2 );

            add_filter( 'woopcd_partialcod-admin/get-purchased_products_subtotal-condition-fields', array( new self(), 'get_purchased_products_subtotal_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-purchased_variations_subtotal-condition-fields', array( new self(), 'get_purchased_variations_subtotal_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-purchased_categories_subtotal-condition-fields', array( new self(), 'get_purchased_categories_subtotal_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-purchased_tags_subtotal-condition-fields', array( new self(), 'get_purchased_tags_subtotal_fields' ), 10 );
            add_filter( 'woopcd_partialcod-admin/get-purchased_attributes_subtotal-condition-fields', array( new self(), 'get_purchased_attributes_subtotal_fields' ), 10 );
        }

        public static function get_groups( $in_groups, $args ) {

            $in_groups[ 'purchase_history_subtotal' ] = esc_html__( 'Purchase History Subtotal', 'woopcd-partialcod-pro' );

            return $in_groups;
        }

        public static function get_conditions( $in_list, $args ) {

            $in_list[ 'purchased_products_subtotal' ] = esc_html__( 'Purchased Products Subtotal', 'woopcd-partialcod-pro' );
            $in_list[ 'purchased_variations_subtotal' ] = esc_html__( 'Purchased Variations Subtotal', 'woopcd-partialcod-pro' );
            $in_list[ 'purchased_categories_subtotal' ] = esc_html__( 'Purchased Categories Subtotal', 'woopcd-partialcod-pro' );
            $in_list[ 'purchased_tags_subtotal' ] = esc_html__( 'Purchased Tags Subtotal', 'woopcd-partialcod-pro' );
            $in_list[ 'purchased_attributes_subtotal' ] = esc_html__( 'Purchased Attributes Subtotal', 'woopcd-partialcod-pro' );

            return $in_list;
        }

        public static function get_purchased_products_subtotal_fields( $in_fields ) {
            $in_fields[] = array(
                'id' => 'date_type',
                'type' => 'select2',
                'default' => 'all_time',
                'options' => array(
                    'all_time' => esc_html__( 'All time', 'woopcd-partialcod-pro' ),
                    'current' => esc_html__( 'Current', 'woopcd-partialcod-pro' ),
                    'hours' => esc_html__( 'Hours', 'woopcd-partialcod-pro' ),
                    'days' => esc_html__( 'Days', 'woopcd-partialcod-pro' ),
                    'weeks' => esc_html__( 'Weeks', 'woopcd-partialcod-pro' ),
                    'months' => esc_html__( 'Months', 'woopcd-partialcod-pro' ),
                    'years' => esc_html__( 'Years', 'woopcd-partialcod-pro' ),
                ),
                'fold_id' => 'date_type',
                'width' => '98%',
                'box_width' => '14%',
            );

            $in_fields[] = array(
                'id' => 'current',
                'type' => 'select2',
                'default' => 'day',
                'options' => array(
                    'day' => esc_html__( 'Day', 'woopcd-partialcod-pro' ),
                    'week' => esc_html__( 'Week', 'woopcd-partialcod-pro' ),
                    'month' => esc_html__( 'Month', 'woopcd-partialcod-pro' ),
                    'year' => esc_html__( 'Year', 'woopcd-partialcod-pro' ),
                ),
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => array( 'current' ),
                    'oparator' => 'eq',
                    'clear' => false,
                ),
                'width' => '98%',
                'box_width' => '14%',
            );

            $in_fields[] = array(
                'id' => 'date_offset',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '1',
                'placeholder' => esc_html__( '0', 'woopcd-partialcod-pro' ),
                'width' => '98%',
                'box_width' => '14%',
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => array( 'hours', 'days', 'weeks', 'months', 'years' ),
                    'oparator' => 'eq',
                    'clear' => false,
                ),
                'attributes' => array(
                    'min' => '0',
                    'step' => '1',
                ),
            );


            $in_fields[] = array(
                'id' => 'all_time_product_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 2,
                'placeholder' => esc_html__( 'Search products...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'wc:products',
                    'ajax' => true,
                    'value_col' => 'slug',
                ),
                'width' => '99%',
                'box_width' => '51%',
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => 'all_time',
                    'oparator' => 'eq',
                    'clear' => false,
                ),
            );

            $in_fields[] = array(
                'id' => 'product_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 2,
                'placeholder' => esc_html__( 'Search products...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'wc:products',
                    'ajax' => true,
                    'value_col' => 'slug',
                ),
                'width' => '99%',
                'box_width' => '37%',
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => 'all_time',
                    'oparator' => 'neq',
                    'clear' => false,
                ),
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '98%',
                'box_width' => '21%',
            );

            $in_fields[] = array(
                'id' => 'subtotal',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.00',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '14%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
            );

            return $in_fields;
        }

        public static function get_purchased_variations_subtotal_fields( $in_fields ) {
            $in_fields[] = array(
                'id' => 'date_type',
                'type' => 'select2',
                'default' => 'all_time',
                'options' => array(
                    'all_time' => esc_html__( 'All time', 'woopcd-partialcod-pro' ),
                    'current' => esc_html__( 'Current', 'woopcd-partialcod-pro' ),
                    'hours' => esc_html__( 'Hours', 'woopcd-partialcod-pro' ),
                    'days' => esc_html__( 'Days', 'woopcd-partialcod-pro' ),
                    'weeks' => esc_html__( 'Weeks', 'woopcd-partialcod-pro' ),
                    'months' => esc_html__( 'Months', 'woopcd-partialcod-pro' ),
                    'years' => esc_html__( 'Years', 'woopcd-partialcod-pro' ),
                ),
                'fold_id' => 'date_type',
                'width' => '98%',
                'box_width' => '14%',
            );

            $in_fields[] = array(
                'id' => 'current',
                'type' => 'select2',
                'default' => 'day',
                'options' => array(
                    'day' => esc_html__( 'Day', 'woopcd-partialcod-pro' ),
                    'week' => esc_html__( 'Week', 'woopcd-partialcod-pro' ),
                    'month' => esc_html__( 'Month', 'woopcd-partialcod-pro' ),
                    'year' => esc_html__( 'Year', 'woopcd-partialcod-pro' ),
                ),
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => array( 'current' ),
                    'oparator' => 'eq',
                    'clear' => false,
                ),
                'width' => '98%',
                'box_width' => '14%',
            );

            $in_fields[] = array(
                'id' => 'date_offset',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '1',
                'placeholder' => esc_html__( '0', 'woopcd-partialcod-pro' ),
                'width' => '98%',
                'box_width' => '14%',
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => array( 'hours', 'days', 'weeks', 'months', 'years' ),
                    'oparator' => 'eq',
                    'clear' => false,
                ),
                'attributes' => array(
                    'min' => '0',
                    'step' => '1',
                ),
            );


            $in_fields[] = array(
                'id' => 'all_time_variation_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 2,
                'placeholder' => esc_html__( 'Search variations...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'wc:product_variations',
                    'ajax' => true,
                    'value_col' => 'slug',
                ),
                'width' => '99%',
                'box_width' => '51%',
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => 'all_time',
                    'oparator' => 'eq',
                    'clear' => false,
                ),
            );

            $in_fields[] = array(
                'id' => 'variation_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 2,
                'placeholder' => esc_html__( 'Search variations...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'wc:product_variations',
                    'ajax' => true,
                    'value_col' => 'slug',
                ),
                'width' => '99%',
                'box_width' => '37%',
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => 'all_time',
                    'oparator' => 'neq',
                    'clear' => false,
                ),
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '98%',
                'box_width' => '21%',
            );

            $in_fields[] = array(
                'id' => 'subtotal',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.00',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '14%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
            );

            return $in_fields;
        }

        public static function get_purchased_categories_subtotal_fields( $in_fields ) {
            $in_fields[] = array(
                'id' => 'date_type',
                'type' => 'select2',
                'default' => 'all_time',
                'options' => array(
                    'all_time' => esc_html__( 'All time', 'woopcd-partialcod-pro' ),
                    'current' => esc_html__( 'Current', 'woopcd-partialcod-pro' ),
                    'hours' => esc_html__( 'Hours', 'woopcd-partialcod-pro' ),
                    'days' => esc_html__( 'Days', 'woopcd-partialcod-pro' ),
                    'weeks' => esc_html__( 'Weeks', 'woopcd-partialcod-pro' ),
                    'months' => esc_html__( 'Months', 'woopcd-partialcod-pro' ),
                    'years' => esc_html__( 'Years', 'woopcd-partialcod-pro' ),
                ),
                'fold_id' => 'date_type',
                'width' => '98%',
                'box_width' => '14%',
            );

            $in_fields[] = array(
                'id' => 'current',
                'type' => 'select2',
                'default' => 'day',
                'options' => array(
                    'day' => esc_html__( 'Day', 'woopcd-partialcod-pro' ),
                    'week' => esc_html__( 'Week', 'woopcd-partialcod-pro' ),
                    'month' => esc_html__( 'Month', 'woopcd-partialcod-pro' ),
                    'year' => esc_html__( 'Year', 'woopcd-partialcod-pro' ),
                ),
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => array( 'current' ),
                    'oparator' => 'eq',
                    'clear' => false,
                ),
                'width' => '98%',
                'box_width' => '14%',
            );

            $in_fields[] = array(
                'id' => 'date_offset',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '1',
                'placeholder' => esc_html__( '0', 'woopcd-partialcod-pro' ),
                'width' => '98%',
                'box_width' => '14%',
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => array( 'hours', 'days', 'weeks', 'months', 'years' ),
                    'oparator' => 'eq',
                    'clear' => false,
                ),
                'attributes' => array(
                    'min' => '0',
                    'step' => '1',
                ),
            );


            $in_fields[] = array(
                'id' => 'all_time_category_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 1,
                'placeholder' => esc_html__( 'Search categories...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'categories:product_cat',
                    'ajax' => true,
                    'value_col' => 'slug',
                ),
                'width' => '99%',
                'box_width' => '51%',
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => 'all_time',
                    'oparator' => 'eq',
                    'clear' => false,
                ),
            );

            $in_fields[] = array(
                'id' => 'category_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 1,
                'placeholder' => esc_html__( 'Search categories...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'categories:product_cat',
                    'ajax' => true,
                    'value_col' => 'slug',
                ),
                'width' => '99%',
                'box_width' => '37%',
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => 'all_time',
                    'oparator' => 'neq',
                    'clear' => false,
                ),
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '98%',
                'box_width' => '21%',
            );

            $in_fields[] = array(
                'id' => 'subtotal',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.00',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '14%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
            );

            return $in_fields;
        }

        public static function get_purchased_tags_subtotal_fields( $in_fields ) {
            $in_fields[] = array(
                'id' => 'date_type',
                'type' => 'select2',
                'default' => 'all_time',
                'options' => array(
                    'all_time' => esc_html__( 'All time', 'woopcd-partialcod-pro' ),
                    'current' => esc_html__( 'Current', 'woopcd-partialcod-pro' ),
                    'hours' => esc_html__( 'Hours', 'woopcd-partialcod-pro' ),
                    'days' => esc_html__( 'Days', 'woopcd-partialcod-pro' ),
                    'weeks' => esc_html__( 'Weeks', 'woopcd-partialcod-pro' ),
                    'months' => esc_html__( 'Months', 'woopcd-partialcod-pro' ),
                    'years' => esc_html__( 'Years', 'woopcd-partialcod-pro' ),
                ),
                'fold_id' => 'date_type',
                'width' => '98%',
                'box_width' => '14%',
            );

            $in_fields[] = array(
                'id' => 'current',
                'type' => 'select2',
                'default' => 'day',
                'options' => array(
                    'day' => esc_html__( 'Day', 'woopcd-partialcod-pro' ),
                    'week' => esc_html__( 'Week', 'woopcd-partialcod-pro' ),
                    'month' => esc_html__( 'Month', 'woopcd-partialcod-pro' ),
                    'year' => esc_html__( 'Year', 'woopcd-partialcod-pro' ),
                ),
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => array( 'current' ),
                    'oparator' => 'eq',
                    'clear' => false,
                ),
                'width' => '98%',
                'box_width' => '14%',
            );

            $in_fields[] = array(
                'id' => 'date_offset',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '1',
                'placeholder' => esc_html__( '0', 'woopcd-partialcod-pro' ),
                'width' => '98%',
                'box_width' => '14%',
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => array( 'hours', 'days', 'weeks', 'months', 'years' ),
                    'oparator' => 'eq',
                    'clear' => false,
                ),
                'attributes' => array(
                    'min' => '0',
                    'step' => '1',
                ),
            );


            $in_fields[] = array(
                'id' => 'all_time_tag_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 1,
                'placeholder' => esc_html__( 'Search tags...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'categories:product_tag',
                    'ajax' => true,
                    'value_col' => 'slug',
                ),
                'width' => '99%',
                'box_width' => '51%',
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => 'all_time',
                    'oparator' => 'eq',
                    'clear' => false,
                ),
            );

            $in_fields[] = array(
                'id' => 'tag_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 1,
                'placeholder' => esc_html__( 'Search tags...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'categories:product_tag',
                    'ajax' => true,
                    'value_col' => 'slug',
                ),
                'width' => '99%',
                'box_width' => '37%',
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => 'all_time',
                    'oparator' => 'neq',
                    'clear' => false,
                ),
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '98%',
                'box_width' => '21%',
            );

            $in_fields[] = array(
                'id' => 'subtotal',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.00',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '14%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
            );

            return $in_fields;
        }

        public static function get_purchased_attributes_subtotal_fields( $in_fields ) {
            $in_fields[] = array(
                'id' => 'date_type',
                'type' => 'select2',
                'default' => 'all_time',
                'options' => array(
                    'all_time' => esc_html__( 'All time', 'woopcd-partialcod-pro' ),
                    'current' => esc_html__( 'Current', 'woopcd-partialcod-pro' ),
                    'hours' => esc_html__( 'Hours', 'woopcd-partialcod-pro' ),
                    'days' => esc_html__( 'Days', 'woopcd-partialcod-pro' ),
                    'weeks' => esc_html__( 'Weeks', 'woopcd-partialcod-pro' ),
                    'months' => esc_html__( 'Months', 'woopcd-partialcod-pro' ),
                    'years' => esc_html__( 'Years', 'woopcd-partialcod-pro' ),
                ),
                'fold_id' => 'date_type',
                'width' => '98%',
                'box_width' => '14%',
            );

            $in_fields[] = array(
                'id' => 'current',
                'type' => 'select2',
                'default' => 'day',
                'options' => array(
                    'day' => esc_html__( 'Day', 'woopcd-partialcod-pro' ),
                    'week' => esc_html__( 'Week', 'woopcd-partialcod-pro' ),
                    'month' => esc_html__( 'Month', 'woopcd-partialcod-pro' ),
                    'year' => esc_html__( 'Year', 'woopcd-partialcod-pro' ),
                ),
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => array( 'current' ),
                    'oparator' => 'eq',
                    'clear' => false,
                ),
                'width' => '98%',
                'box_width' => '14%',
            );

            $in_fields[] = array(
                'id' => 'date_offset',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '1',
                'placeholder' => esc_html__( '0', 'woopcd-partialcod-pro' ),
                'width' => '98%',
                'box_width' => '14%',
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => array( 'hours', 'days', 'weeks', 'months', 'years' ),
                    'oparator' => 'eq',
                    'clear' => false,
                ),
                'attributes' => array(
                    'min' => '0',
                    'step' => '1',
                ),
            );


            $in_fields[] = array(
                'id' => 'all_time_attribute_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 1,
                'placeholder' => esc_html__( 'Search attributes...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'wc:attributes',
                    'ajax' => true,
                    'value_col' => 'slug',
                ),
                'width' => '99%',
                'box_width' => '51%',
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => 'all_time',
                    'oparator' => 'eq',
                    'clear' => false,
                ),
            );

            $in_fields[] = array(
                'id' => 'attribute_slugs',
                'type' => 'select2',
                'multiple' => true,
                'minimum_input_length' => 1,
                'placeholder' => esc_html__( 'Search attributes...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'wc:attributes',
                    'ajax' => true,
                    'value_col' => 'slug',
                ),
                'width' => '99%',
                'box_width' => '37%',
                'fold' => array(
                    'target' => 'date_type',
                    'attribute' => 'value',
                    'value' => 'all_time',
                    'oparator' => 'neq',
                    'clear' => false,
                ),
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '98%',
                'box_width' => '21%',
            );

            $in_fields[] = array(
                'id' => 'subtotal',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.00',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '14%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
            );

            return $in_fields;
        }

    }

    WOOPCD_PartialCOD_Admin_Conditions_Purchase_History_Subtotals::init();
}