<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}


if ( !class_exists( 'WOOPCD_PartialCOD_Premium_Admin_Logic_Types_Conditions' ) ) {

    class WOOPCD_PartialCOD_Premium_Admin_Logic_Types_Conditions {

        public static function init() {
            add_filter( 'woopcd_partialcod-admin/get-amount-type-fields', array( new self(), 'get_condition_fields' ), 71, 2 );
            add_filter( 'woopcd_partialcod-admin/get-rule-panel-conditions-fields', array( new self(), 'get_rule_conditions_title' ), 70, 2 );

            add_filter( 'woopcd_partialcod-admin/process-amount-options', array( new self(), 'process_options' ), 70, 3 );
        }

        public static function get_rule_conditions_title( $in_fields, $args ) {

            $in_fields[] = array(
                'id' => 'match_mode',
                'type' => 'select2',
                'full_width' => true,
                'center_head' => true,
                'title' => esc_html__( 'Shop Conditions', 'woopcd-partialcod-pro' ),
                'desc' => self::get_conditions_desc( $args ),
                'default' => 'match_all',
                'options' => array(
                    'match_all' => esc_html__( 'All conditions should match', 'woopcd-partialcod-pro' ),
                    'match_one' => esc_html__( 'At least one condition should match', 'woopcd-partialcod-pro' ),
                ),
                'width' => '320px',
            );


            return $in_fields;
        }

        public static function get_condition_fields( $in_fields, $args ) {

            foreach ( WOOPCD_PartialCOD_Admin_Logic_Types_Conditions::get_condition_fields( array(), $args ) as $field ) {
                $field[ 'fold' ] = array(
                    'target' => 'set_conditions',
                    'attribute' => 'value',
                    'value' => array( 'yes' ),
                    'oparator' => 'eq',
                    'clear' => false,
                );
                $in_fields[] = $field;
            }

            return $in_fields;
        }

        public static function process_options( $amount, $raw_amount, $args ) {

            if ( $raw_amount[ 'set_conditions' ] == 'yes' && isset( $raw_amount[ 'conditions' ] ) ) {
                $amount[ 'conditions' ] = $raw_amount[ 'conditions' ];
            }

            return $amount;
        }

        private static function get_conditions_desc( $args ) {

            $module_text = esc_html__( 'settings', 'woopcd-partialcod-pro' );

            if ( 'partial-payment' == $args[ 'module' ] ) {

                $module_text = esc_html__( 'partial payment', 'woopcd-partialcod-pro' );
            }

            if ( 'method-options' == $args[ 'module' ] ) {

                $module_text = esc_html__( 'method settings', 'woopcd-partialcod-pro' );
            }

            if ( 'cart-discounts' == $args[ 'module' ] ) {

                $module_text = esc_html__( 'cart discount', 'woopcd-partialcod-pro' );
            }

            if ( 'cart-fees' == $args[ 'module' ] ) {

                $module_text = esc_html__( 'gateway fee', 'woopcd-partialcod-pro' );
            }
            /* translators: 1: module name */
            return sprintf( esc_html__( 'List of conditions in which this %s should apply, empty conditions will apply in all cases', 'woopcd-partialcod-pro' ), $module_text );
        }

    }

    WOOPCD_PartialCOD_Premium_Admin_Logic_Types_Conditions::init();
}

