<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Method_Options_Account_Details' ) ) {

    class WOOPCD_PartialCOD_Admin_Method_Options_Account_Details {

        public static function init() {


            add_filter( 'woopcd_partialcod-admin/method-options/get-bacs-rule-options', array( new self(), 'get_option' ), 20, 2 );
            add_filter( 'woopcd_partialcod-admin/method-options/get-rule-option-account_details-fields', array( new self(), 'get_fields' ), 10, 2 );

            add_filter( 'reon/get-simple-repeater-field-account_details-templates', array( new self(), 'get_account_details_templates' ), 10, 2 );
            add_filter( 'roen/get-simple-repeater-template-account_details-details-fields', array( new self(), 'get_account_details_fields' ), 10, 2 );

            add_filter( 'woopcd_partialcod-admin/process-option-type-account_details', array( new self(), 'process_options' ), 10, 3 );
        }

        public static function get_option( $in_options, $method_id ) {

            $in_options[ 'account_details' ] = array(
                'list_title' => esc_html__( 'Order - Account Details', 'woopcd-partialcod-pro' ),
                'title' => esc_html__( 'Order - Account Details', 'woopcd-partialcod-pro' ),
                'group_id' => 'order',
            );

            return $in_options;
        }

        public static function get_fields( $in_fields, $method_id ) {

            $in_fields[] = array(
                'id' => 'account_details',
                'type' => 'simple-repeater',
                'full_width' => true,
                'center_head' => true,
                'title' => esc_html__( 'Account Details', 'woopcd-partialcod-pro' ),
                'desc' => esc_html__( 'Controls the account information on order details page', 'woopcd-partialcod-pro' ),
                'white_repeater' => true,
                'repeater_size' => 'smaller',
                'buttons_sep' => false,
                'buttons_box_width' => '65px',
                'width' => '100%',
                'default' => array(),
                'css_class' => array( 'partialcod_account_details' ),
                'field_css_class' => array( 'rn-first' ),
                'sortable' => array(
                    'enabled' => true,
                ),
                'template_adder' => array(
                    'position' => 'right',
                    'show_list' => false,
                    'button_text' => esc_html__( 'Add Details', 'woopcd-partialcod-pro' ),
                ),
            );

            return $in_fields;
        }

        public static function get_account_details_templates( $in_templates, $repeater_args ) {

            if ( $repeater_args[ 'screen' ] == 'option-page' && $repeater_args[ 'option_name' ] == WOOPCD_PartialCOD_Admin_Page::get_option_name() ) {
                $in_templates[] = array(
                    'id' => 'details',
                );
            }

            return $in_templates;
        }

        public static function get_account_details_fields( $in_fields, $repeater_args ) {

            $in_fields[] = array(
                'id' => 'account_name',
                'type' => 'textbox',
                'default' => '',
                'placeholder' => esc_html__( 'Account name', 'woopcd-partialcod-pro' ),
                'width' => '98%',
                'box_width' => '16.66%',
            );

            $in_fields[] = array(
                'id' => 'account_number',
                'type' => 'textbox',
                'default' => '',
                'placeholder' => esc_html__( 'Account number', 'woopcd-partialcod-pro' ),
                'width' => '98%',
                'box_width' => '16.66%',
            );

            $in_fields[] = array(
                'id' => 'bank_name',
                'type' => 'textbox',
                'default' => '',
                'placeholder' => esc_html__( 'Bank name', 'woopcd-partialcod-pro' ),
                'width' => '98%',
                'box_width' => '16.66%',
            );

            $in_fields[] = array(
                'id' => 'sort_code',
                'type' => 'textbox',
                'default' => '',
                'placeholder' => esc_html__( 'Sort code', 'woopcd-partialcod-pro' ),
                'width' => '98%',
                'box_width' => '16.66%',
            );

            $in_fields[] = array(
                'id' => 'iban',
                'type' => 'textbox',
                'default' => '',
                'placeholder' => esc_html__( 'IBAN', 'woopcd-partialcod-pro' ),
                'width' => '98%',
                'box_width' => '16.66%',
            );

            $in_fields[] = array(
                'id' => 'bic',
                'type' => 'textbox',
                'default' => '',
                'placeholder' => esc_html__( 'BIC / Swift', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '16.66%',
            );

            return $in_fields;
        }

        public static function process_options( $options, $raw_options, $args = array() ) {

            if ( is_array( $raw_options[ 'account_details' ] ) ) {
                $options[ 'account_details' ] = $raw_options[ 'account_details' ];
            }

            return $options;
        }

    }

    WOOPCD_PartialCOD_Admin_Method_Options_Account_Details::init();
}