<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Method_Options_Button_Text' ) ) {

    class WOOPCD_PartialCOD_Admin_Method_Options_Button_Text {

        public static function init() {
            add_filter( 'woopcd_partialcod-admin/method-options/get-rule-options', array( new self(), 'get_option' ), 60, 2 );
            add_filter( 'woopcd_partialcod-admin/method-options/get-rule-option-order_button_text-fields', array( new self(), 'get_fields' ), 10, 2 );

            add_filter( 'woopcd_partialcod-admin/process-option-type-order_button_text', array( new self(), 'process_options' ), 10, 3 );
        }

        public static function get_option( $in_options, $method_id ) {

            $in_options[ 'order_button_text' ] = array(
                'list_title' => esc_html__( 'Checkout - Button Text', 'woopcd-partialcod-pro' ),
                'title' => esc_html__( 'Checkout - Button Text', 'woopcd-partialcod-pro' ),
                'group_id' => 'checkout',
                'tooltip' => esc_html__( 'Controls payment method order button text on checkout page', 'woopcd-partialcod-pro' ),
            );

            return $in_options;
        }

        public static function get_fields( $in_fields, $method_id ) {

            $method = WOOPCD_PartialCOD_Admin_Page::get_payment_method( $method_id );

            $button_text = $method[ 'order_button_text' ];
            if ( $button_text == '' ) {
                $button_text = esc_html__( 'Place Order', 'woopcd-partialcod-pro' );
            }

            $in_fields[] = array(
                'id' => 'any_ids',
                'type' => 'columns-field',
                'columns' => 1,
                'merge_fields' => false,
                'field_css_class' => array( 'rn-first' ),
                'fields' => array(
                    array(
                        'id' => 'order_button_text',
                        'type' => 'textbox',
                        'column_size' => 1,
                        'default' => '',
                        'placeholder' => $button_text,
                        'width' => '100%',
                    ),
                ),
            );

            return $in_fields;
        }

        public static function process_options( $options, $raw_options, $args = array() ) {

            if ( !empty( $raw_options[ 'order_button_text' ] ) ) {
                $options[ 'order_button_text' ] = $raw_options[ 'order_button_text' ];
            }

            return $options;
        }

    }

    WOOPCD_PartialCOD_Admin_Method_Options_Button_Text::init();
}


