<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Method_Options_Description' ) ) {

    class WOOPCD_PartialCOD_Admin_Method_Options_Description {

        public static function init() {

            add_filter( 'woopcd_partialcod-admin/method-options/get-rule-options', array( new self(), 'get_option' ), 40, 2 );
            add_filter( 'woopcd_partialcod-admin/method-options/get-rule-option-description-fields', array( new self(), 'get_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/process-option-type-description', array( new self(), 'process_options' ), 10, 3 );
        }

        public static function get_option( $in_options, $method_id ) {

            $in_options[ 'description' ] = array(
                'list_title' => esc_html__( 'Checkout - Description', 'woopcd-partialcod-pro' ),
                'title' => esc_html__( 'Checkout - Description', 'woopcd-partialcod-pro' ),
                'group_id' => 'checkout',
                'tooltip' => esc_html__( 'Controls payment method description on checkout page', 'woopcd-partialcod-pro' ),
            );
            return $in_options;
        }

        public static function get_fields( $in_fields, $method_id ) {
            $in_fields[] = array(
                'id' => 'any_ids',
                'type' => 'columns-field',
                'columns' => 1,
                'merge_fields' => false,
                'field_css_class' => array( 'rn-first' ),
                'fields' => array(
                    array(
                        'id' => 'desc',
                        'type' => 'textarea',
                        'column_size' => 1,
                        'default' => '',
                        'placeholder' => esc_html__( 'Descriptions....', 'woopcd-partialcod-pro' ),
                        'width' => '100%',
                    ),
                ),
            );
            return $in_fields;
        }

        public static function process_options( $options, $raw_options, $args = array() ) {

            if ( !empty( $raw_options[ 'desc' ] ) ) {
                $options[ 'desc' ] = $raw_options[ 'desc' ];
            }

            return $options;
        }

    }

    WOOPCD_PartialCOD_Admin_Method_Options_Description::init();
}

