<?php

if (!class_exists('Reon')) {
    return;
}

if (!class_exists('WOOPCD_PartialCOD_Admin_Method_Options_Icon_Url')) {

    class WOOPCD_PartialCOD_Admin_Method_Options_Icon_Url {

        public static function init() {
            add_filter('woopcd_partialcod-admin/method-options/get-rule-options', array(new self(), 'get_option'), 50, 2);
            add_filter('woopcd_partialcod-admin/method-options/get-rule-option-icon_url-fields', array(new self(), 'get_fields'), 10, 2);
            add_filter('woopcd_partialcod-admin/process-option-type-icon_url', array(new self(), 'process_options'), 10, 3);
            
        }

        public static function get_option($in_options, $method_id) {

            $in_options['icon_url'] = array(
                'list_title' => esc_html__('Checkout - Icon Url', 'woopcd-partialcod-pro'),
                'title' => esc_html__('Checkout - Icon Url', 'woopcd-partialcod-pro'),
                'group_id' => 'checkout',
                'tooltip' => esc_html__('Controls payment method icon url on checkout page', 'woopcd-partialcod-pro'),
            );
            
            return $in_options;
        }

        public static function get_fields($in_fields, $method_id) {
            
            $method = WOOPCD_PartialCOD_Admin_Page::get_payment_method($method_id);

            $icon_url = $method['icon'];
            if ($icon_url == '') {
                $icon_url = esc_html__('Icon url', 'woopcd-partialcod-pro');
            }

            $in_fields[] = array(
                'id' => 'any_ids',
                'type' => 'columns-field',
                'columns' => 1,
                'merge_fields' => false,
                'field_css_class' => array( 'rn-first' ),
                'fields' => array(
                    array(
                        'id' => 'icon_url',
                        'type' => 'textbox',
                        'column_size' => 1,
                        'default' => '',
                        'placeholder' => $icon_url,
                        'width' => '100%',
                    ),
                ),
            );
            return $in_fields;
        }

        public static function process_options($options, $raw_options, $args = array()) {
           
            if (!empty($raw_options['icon_url'])) {
                $options['icon_url'] = $raw_options['icon_url'];
            }
           
            return $options;
        }
        
    }

    WOOPCD_PartialCOD_Admin_Method_Options_Icon_Url::init();
}


