<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Method_Options_Instructions' ) ) {

    class WOOPCD_PartialCOD_Admin_Method_Options_Instructions {

        public static function init() {

            add_filter( 'woopcd_partialcod-admin/method-options/get-rule-option-groups', array( new self(), 'get_groups' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/method-options/get-rule-options', array( new self(), 'get_option' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/method-options/get-rule-option-instructions-fields', array( new self(), 'get_fields' ), 10, 2 );

            add_filter( 'woopcd_partialcod-admin/process-option-type-instructions', array( new self(), 'process_options' ), 10, 3 );
        }

        public static function get_groups( $in_groups, $method_id ) {
            $in_groups[ 'order' ] = esc_html__( 'Order Settings', 'woopcd-partialcod-pro' );
            return $in_groups;
        }

        public static function get_option( $in_options, $method_id ) {

            $in_options[ 'instructions' ] = array(
                'list_title' => esc_html__( 'Order - Instructions', 'woopcd-partialcod-pro' ),
                'title' => esc_html__( 'Order - Instructions', 'woopcd-partialcod-pro' ),
                'group_id' => 'order',
            );

            return $in_options;
        }

        public static function get_fields( $in_fields, $method_id ) {

            $in_fields[] = array(
                'id' => 'any_ids',
                'type' => 'columns-field',
                'columns' => 1,
                'merge_fields' => false,
                'field_css_class' => array( 'rn-first' ),
                'fields' => array(
                    array(
                        'id' => 'instructions',
                        'type' => 'textarea',
                        'column_size' => 1,
                        'column_title' => esc_html__( 'Intructions', 'woopcd-partialcod-pro' ),
                        'tooltip' => esc_html__( 'Controls the instructions on order details page', 'woopcd-partialcod-pro' ),
                        'default' => '',
                        'placeholder' => esc_html__( 'Intructions....', 'woopcd-partialcod-pro' ),
                        'width' => '100%',
                    ),
                ),
            );

            return $in_fields;
        }

        public static function process_options( $options, $raw_options, $args = array() ) {

            if ( !empty( $raw_options[ 'instructions' ] ) ) {
                $options[ 'instructions' ] = $raw_options[ 'instructions' ];
            }

            return $options;
        }

    }

    WOOPCD_PartialCOD_Admin_Method_Options_Instructions::init();
}