<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Method_Options_Restriction' ) ) {

    class WOOPCD_PartialCOD_Admin_Method_Options_Restriction {

        public static function init() {
            add_filter( 'woopcd_partialcod-admin/method-options/get-rule-options', array( new self(), 'get_option' ), 20, 2 );
            add_filter( 'woopcd_partialcod-admin/method-options/get-rule-option-restriction-fields', array( new self(), 'get_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/process-option-type-restriction', array( new self(), 'process_options' ), 10, 3 );
        }

        public static function get_option( $in_options, $method_id ) {

            $in_options[ 'restriction' ] = array(
                'list_title' => esc_html__( 'Checkout - Restriction', 'woopcd-partialcod-pro' ),
                'title' => esc_html__( 'Checkout - Restriction', 'woopcd-partialcod-pro' ),
                'group_id' => 'checkout',
                'tooltip' => esc_html__( 'Controls payment method availability on checkout page', 'woopcd-partialcod-pro' ),
            );
            return $in_options;
        }

        public static function get_fields( $in_fields, $method_id ) {
            $in_fields[] = array(
                'id' => 'any_ids',
                'type' => 'columns-field',
                'columns' => 1,
                'merge_fields' => false,
                'field_css_class' => array( 'rn-first' ),
                'fields' => array(
                    array(
                        'id' => 'enabled',
                        'type' => 'select2',
                        'column_size' => 1,
                        'default' => 'yes',
                        'options' => array(
                            'yes' => esc_html__( 'Is Available', 'woopcd-partialcod-pro' ),
                            'no' => esc_html__( 'Is Restricted', 'woopcd-partialcod-pro' ),
                        ),
                        'width' => '100%',
                        'fold_id' => 'enabled'
                    ),
                ),
            );

            $in_fields[] = array(
                'id' => 'any_ids',
                'type' => 'columns-field',
                'columns' => 1,
                'merge_fields' => false,
                'fields' => array(
                    array(
                        'id' => 'message',
                        'type' => 'textarea',
                        'column_size' => 1,
                        'default' => '',
                        'placeholder' => esc_html__( 'Restriction message....', 'woopcd-partialcod-pro' ),
                        'width' => '100%',
                    ),
                ),
                'fold' => array(
                    'target' => 'enabled',
                    'attribute' => 'value',
                    'value' => array( 'no' ),
                    'oparator' => 'eq',
                    'clear' => false,
                ),
            );

            return $in_fields;
        }

        public static function process_options( $options, $raw_options, $args = array() ) {

            $options[ 'enabled' ] = 'yes';

            if ( isset( $raw_options[ 'enabled' ] ) ) {
                $options[ 'enabled' ] = $raw_options[ 'enabled' ];
            }

            if ( $options[ 'enabled' ] == 'no' ) {

                if ( !empty( $raw_options[ 'message' ] ) ) {
                    $options[ 'message' ] = $raw_options[ 'message' ];
                }
            }


            return $options;
        }

    }

    WOOPCD_PartialCOD_Admin_Method_Options_Restriction::init();
}


