<?php

if (!class_exists('Reon')) {
    return;
}

if (!class_exists('WOOPCD_PartialCOD_Admin_Method_Options_Title')) {

    class WOOPCD_PartialCOD_Admin_Method_Options_Title {

        public static function init() {
            add_filter('woopcd_partialcod-admin/method-options/get-rule-options', array(new self(), 'get_option'), 30, 2);
            add_filter('woopcd_partialcod-admin/method-options/get-rule-option-title-fields', array(new self(), 'get_fields'), 10, 2);
            add_filter('woopcd_partialcod-admin/process-option-type-title', array(new self(), 'process_options'), 10, 3);
        }

        public static function get_option($in_options, $method_id) {

            $in_options[ 'title' ] = array(
                'list_title' => esc_html__( 'Checkout - Title', 'woopcd-partialcod-pro' ),
                'title' => esc_html__( 'Checkout - Title', 'woopcd-partialcod-pro' ),
                'group_id' => 'checkout',
                'tooltip' => esc_html__( 'Controls payment method title on checkout page', 'woopcd-partialcod-pro' ),
            );
            
            return $in_options;
        }

        public static function get_fields($in_fields, $method_id) {

            $method = WOOPCD_PartialCOD_Admin_Page::get_payment_method($method_id);

            $method_title = $method['title'];

            $in_fields[] = array(
                'id' => 'any_ids',
                'type' => 'columns-field',
                'columns' => 1,
                'merge_fields' => false,
                'field_css_class' => array( 'rn-first' ),
                'fields' => array(
                    array(
                        'id' => 'title',
                        'type' => 'textbox',
                        'column_size' => 1,
                        'default' => '',
                        'placeholder' => $method_title,
                        'width' => '100%',
                    ),
                ),
            );
            return $in_fields;
        }
        
        public static function process_options($options, $raw_options, $args = array()) {

            if (!empty($raw_options['title'])) {
                $options['title'] = $raw_options['title'];
            }

            return $options;
        }

    }

    WOOPCD_PartialCOD_Admin_Method_Options_Title::init();
}


