<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Order_Activity_Trigger_Cron_Scheduler' ) ) {

    class WOOPCD_PartialCOD_Admin_Order_Activity_Trigger_Cron_Scheduler {

        public static function init() {

            add_filter( 'woopcd_partialcod-admin/order-activities/get-rule-panel-option-fields', array( new self(), 'get_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/order-activities/get-trigger-types', array( new self(), 'get_trigger_type' ), 10, 2 );
        }

        public static function get_trigger_type( $in_types, $args = array() ) {
            $in_types[ 'cron_schedulers' ] = esc_html__( 'Cron Tasks', 'woopcd-partialcod-pro' );
            return $in_types;
        }

        public static function get_fields( $in_fields, $method_id ) {

            $in_flds = array();

            foreach ( $in_fields as $in_field ) {

                if ( isset( $in_field[ 'id' ] ) && 'countdown_timer' == $in_field[ 'id' ] ) {
                    $in_flds[] = array(
                        'id' => $method_id . 'any_idsa',
                        'type' => 'columns-field',
                        'columns' => 3,
                        'merge_fields' => false,
                        'fold' => array(
                            'target' => 'activities_trigger',
                            'attribute' => 'value',
                            'value' => 'cron_schedulers',
                            'oparator' => 'eq',
                            'clear' => false,
                        ),
                        'fields' => array(
                            array(
                                'id' => 'cron_scheduler_ids',
                                'type' => 'select2',
                                'column_size' => 2,
                                'column_title' => esc_html__( 'Cron Tasks', 'woopcd-partialcod-pro' ),
                                'tooltip' => esc_html__( 'Use this option to control which cron jobs should trigger this activity', 'woopcd-partialcod-pro' ),
                                'data' => 'partialcod:cron_jobs',
                                'placeholder' => esc_html__( 'Select cron tasks...', 'woopcd-partialcod-pro' ),
                                'multiple' => true,
                                'width' => '100%',
                            ),
                            array(
                                'id' => 'cron_compare',
                                'type' => 'select2',
                                'column_size' => 1,
                                'column_title' => esc_html__( 'Equals To', 'woopcd-partialcod-pro' ),
                                'tooltip' => esc_html__( 'Controls how the cron tasks should be included', 'woopcd-partialcod-pro' ),
                                'default' => 'in_list',
                                'options' => array(
                                    'in_list' => esc_html__( 'Any in the list', 'woopcd-partialcod-pro' ),
                                    'none' => esc_html__( 'Any NOT in the list', 'woopcd-partialcod-pro' ),
                                ),
                                'width' => '100%',
                            ),
                        )
                    );
                }

                $in_flds[] = $in_field;
            }



            return $in_flds;
        }

    }

    WOOPCD_PartialCOD_Admin_Order_Activity_Trigger_Cron_Scheduler::init();
}

