<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}


if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Order_Activity_Types' ) ) {
    WOOPCD_PartialCOD_Main::required_paths( dirname( __FILE__ ), array( 'order-activity-types.php' ) );

    class WOOPCD_PartialCOD_Admin_Order_Activity_Types {

        public static function get_order_activity_groups( $method_id ) {
            return apply_filters( 'woopcd_partialcod-admin/order-activities/get-' . $method_id . '-activity-groups', apply_filters( 'woopcd_partialcod-admin/order-activities/get-activity-groups', array(), $method_id ), $method_id );
        }

        public static function get_order_activity_types( $method_id ) {

            $activity_types = apply_filters( 'woopcd_partialcod-admin/order-activities/get-' . $method_id . '-activity-types', apply_filters( 'woopcd_partialcod-admin/order-activities/get-activity-types', array(), $method_id ), $method_id );
            $options = array();

            foreach ( $activity_types as $key => $activity_type ) {

                if ( !isset( $activity_type[ 'list_title' ] ) ) {
                    $activity_type[ 'list_title' ] = $activity_type[ 'title' ];
                }

                $options[ $key ] = array(
                    'id' => $key,
                    'list_label' => $activity_type[ 'list_title' ],
                    'head' => array(
                        'title' => $activity_type[ 'title' ],
                    ),
                );

                if ( isset( $activity_type[ 'group_id' ] ) ) {
                    $options[ $key ][ 'group_id' ] = $activity_type[ 'group_id' ];
                }

                if ( isset( $activity_type[ 'tooltip' ] ) ) {
                    $options[ $key ][ 'head' ][ 'tooltip' ] = $activity_type[ 'tooltip' ];
                }
            }

            return $options;
        }

        public static function get_order_activity_type_fields( $activity_type, $method_id ) {
            $in_fields = array();
            $in_fields[] = array(
                'id' => 'activity_id',
                'type' => 'autoid',
                'autoid' => 'partialcod',
            );
            return apply_filters( 'woopcd_partialcod-admin/order-activities/get-activity-' . $activity_type . '-fields', $in_fields, $method_id );
        }

    }

}