<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Order_Conditions_GeoLocation' ) ) {

    class WOOPCD_PartialCOD_Admin_Order_Conditions_GeoLocation {

        public static function init() {

            add_filter( 'woopcd_partialcod-admin/get-order-condition-groups', array( new self(), 'get_groups' ), 10, 2 );

            add_filter( 'woopcd_partialcod-admin/get-order-geo_locations-group-conditions', array( new self(), 'get_conditions' ), 10, 2 );
         
            add_filter( 'woopcd_partialcod-admin/get-order-geo_countries-condition-fields', array( new self(), 'get_countries_fields' ), 10, 2 );
        }

        public static function get_groups( $in_groups, $args ) {
            $in_groups[ 'geo_locations' ] = esc_html__( 'GeoIP Locations', 'woopcd-partialcod-pro' );
            return $in_groups;
        }

        public static function get_conditions( $in_list, $args ) {
            $in_list[ 'geo_countries' ] = esc_html__( 'GeoIP Countries', 'woopcd-partialcod-pro' );
            return $in_list;
        }
        
        public static function get_countries_fields( $in_fields, $args ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => 'in_list',
                'options' => array(
                    'in_list' => esc_html__( 'Any in the list', 'woopcd-partialcod-pro' ),
                    'none' => esc_html__( 'None in the list', 'woopcd-partialcod-pro' ),
                ),
                'width' => '98%',
                'box_width' => '26%',
            );

            $in_fields[] = array(
                'id' => 'countries',
                'type' => 'select2',
                'multiple' => true,
                'allow_clear' => true,
                'minimum_input_length' => 2,
                'minimum_results_forsearch' => 10,
                'placeholder' => esc_html__( 'GeoIP Countries...', 'woopcd-partialcod-pro' ),
                'ajax_data' => 'wc:countries',
                'width' => '100%',
                'box_width' => '74%',
            );

            return $in_fields;
        }


    }

    WOOPCD_PartialCOD_Admin_Order_Conditions_GeoLocation::init();
}

