<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Order_Conditions_Order_Totals' ) ) {

    class WOOPCD_PartialCOD_Admin_Order_Conditions_Order_Totals {

        private static $types_prefix = 'order_totals_';

        public static function init() {

            add_filter( 'woopcd_partialcod-admin/get-order-condition-groups', array( new self(), 'get_groups' ), 60 );

            add_filter( 'woopcd_partialcod-admin/get-order-order_totals-group-conditions', array( new self(), 'get_conditions' ), 10, 2 );



            foreach ( array_keys( self::get_option() ) as $option_id ) {
                add_filter( 'woopcd_partialcod-admin/get-order-' . self::$types_prefix . $option_id . '-condition-fields', array( new self(), 'get_totals_fields' ), 10, 2 );
            }

        }

        public static function get_groups( $in_groups ) {

            $in_groups[ 'order_totals' ] = esc_html__( 'Order Totals', 'woopcd-partialcod-pro' );
            return $in_groups;
        }

        public static function get_conditions( $in_list, $args ) {

            foreach ( self::get_option() as $option_id => $option ) {
                $in_list[ self::$types_prefix . $option_id ] = $option;
            }

            return $in_list;
        }

        public static function get_totals_fields( $in_fields, $args ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>=',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '99%',
                'box_width' => '50%',
            );

            $in_fields[] = array(
                'id' => 'totals',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.00',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '50%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
            );
            return $in_fields;
        }

        private static function get_option() {
            global $woopcd_partialcod;

            if ( isset( $woopcd_partialcod[ 'activity_order_totals' ] ) ) {

                $options = array();

                foreach ( $woopcd_partialcod[ 'activity_order_totals' ] as $cart_totals ) {

                    $options[ $cart_totals[ 'option_id' ] ] = $cart_totals[ 'title' ];
                }

                return $options;
            }

            return array(
                '2234343' => esc_html__( 'Subtotal', 'woopcd-partialcod-pro' ),
            );
        }

    }

    WOOPCD_PartialCOD_Admin_Order_Conditions_Order_Totals::init();
}


