<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}


if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Payment_Amount_Type_Cart_Totals' ) ) {

    class WOOPCD_PartialCOD_Admin_Payment_Amount_Type_Cart_Totals {

        private static $types_prefix = 'cart_totals_';

        public static function init() {
       
            add_filter( 'woopcd_partialcod-admin/get-payment-amount-type-groups', array( new self(), 'get_groups' ), 20, 2 );

            add_filter( 'woopcd_partialcod-admin/get-payment-amount-types-cart_totals', array( new self(), 'get_types' ), 10, 2 );
        }

        public static function get_groups( $in_groups, $args ) {

            $in_groups[ 'cart_totals' ] = esc_html__( 'Cart Totals', 'woopcd-partialcod-pro' );

            return $in_groups;
        }

        public static function get_types( $in_types = array(), $args = array() ) {

            foreach ( self::get_option() as $key => $option ) {
                $in_types[ self::$types_prefix . $key ] = $option;
            }
            
            return $in_types;
            
        }

        private static function get_option() {
            global $woopcd_partialcod;

            if ( isset( $woopcd_partialcod[ 'riskfree_cart_totals' ] ) ) {

                $options = array();

                foreach ( $woopcd_partialcod[ 'riskfree_cart_totals' ] as $cart_totals ) {

                    $options[ $cart_totals[ 'option_id' ] ] = $cart_totals[ 'title' ];
                }

                return $options;
            }

            return array(
                '2234343' => esc_html__( 'Subtotal including tax', 'woopcd-partialcod-pro' ),
                '2234344' => esc_html__( 'Subtotal excluding tax', 'woopcd-partialcod-pro' )
            );
        }

    }

    WOOPCD_PartialCOD_Admin_Payment_Amount_Type_Cart_Totals::init();
}