<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}


if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Payment_Amount_Type_Products' ) ) {

    class WOOPCD_PartialCOD_Admin_Payment_Amount_Type_Products {

        public static function init() {
            add_filter( 'woopcd_partialcod-admin/get-payment-amount-type-groups', array( new self(), 'get_groups' ), 30, 2 );

            add_filter( 'woopcd_partialcod-admin/get-payment-amount-types-products', array( new self(), 'get_types' ), 10, 2 );

            add_filter( 'woopcd_partialcod-admin/get-payment-amount-required-ids', array( new self(), 'get_amount_required_ids' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-payment-item-based-on-required-ids', array( new self(), 'get_item_based_on_required_ids' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/partial-payment/get-products-required-ids', array( new self(), 'get_products_required_ids' ), 10, 2 );

            add_filter( 'woopcd_partialcod-admin/process-payment-amount-type-fixed_products-options', array( new self(), 'process_fixed_products_options' ), 10, 3 );
            add_filter( 'woopcd_partialcod-admin/process-payment-amount-type-per_products-options', array( new self(), 'process_per_products_options' ), 10, 3 );
        }

        public static function get_groups( $in_groups, $args ) {

            $in_groups[ 'products' ] = esc_html__( 'Product Totals', 'woopcd-partialcod-pro' );

            return $in_groups;
        }

        public static function get_types( $in_types = array(), $args = array() ) {

            $in_types[ 'fixed_products' ] = esc_html__( 'Products totals', 'woopcd-partialcod-pro' );
            $in_types[ 'per_products' ] = esc_html__( 'Products percentage totals', 'woopcd-partialcod-pro' );

            return $in_types;
        }

        public static function get_amount_required_ids( $in_ids, $args ) {
            $in_ids[] = 'per_products';
            return $in_ids;
        }

        public static function get_item_based_on_required_ids( $in_ids, $args ) {

            $in_ids[] = 'fixed_products';
            $in_ids[] = 'per_products';
            return $in_ids;
        }

        public static function get_products_required_ids( $in_ids, $args ) {

            $in_ids[] = 'fixed_products';
            $in_ids[] = 'per_products';

            return $in_ids;
        }

        public static function process_fixed_products_options( $amount, $raw_amount, $args ) {


            if ( isset( $raw_amount[ 'item_based_on' ] ) ) {
                $amount[ 'item_based_on' ] = $raw_amount[ 'item_based_on' ];
            }

            return $amount;
        }
        
        public static function process_per_products_options( $amount, $raw_amount, $args ) {

            $amount[ 'amount' ] = 0;

            if ( isset( $raw_amount[ 'amount' ] ) && is_numeric( $raw_amount[ 'amount' ] ) ) {
                $amount[ 'amount' ] = $raw_amount[ 'amount' ];
            }

            if ( isset( $raw_amount[ 'item_based_on' ] ) ) {
                $amount[ 'item_based_on' ] = $raw_amount[ 'item_based_on' ];
            }

            return $amount;
        }

    }

    WOOPCD_PartialCOD_Admin_Payment_Amount_Type_Products::init();
}