<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}


if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Payment_Amount_Type_Specifics' ) ) {

    class WOOPCD_PartialCOD_Admin_Payment_Amount_Type_Specifics {

        public static function init() {
            add_filter( 'woopcd_partialcod-admin/get-payment-amount-type-groups', array( new self(), 'get_groups' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-payment-amount-types-specifics', array( new self(), 'get_types' ), 20, 2 );

            add_filter( 'woopcd_partialcod-admin/get-payment-amount-required-ids', array( new self(), 'get_amount_required_ids' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-payment-based-on-required-ids', array( new self(), 'get_based_on_required_ids' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/partial-payment/get-products-required-ids', array( new self(), 'get_products_required_ids' ), 10, 2 );

            add_filter( 'woopcd_partialcod-admin/process-payment-amount-type-fixed_amount-options', array( new self(), 'process_fixed_amount_options' ), 10, 3 );
            add_filter( 'woopcd_partialcod-admin/process-payment-amount-type-fixed_amount_item-options', array( new self(), 'process_fixed_amount_options' ), 10, 3 );
            add_filter( 'woopcd_partialcod-admin/process-payment-amount-type-per_amount-options', array( new self(), 'process_per_amount_options' ), 10, 3 );
        }

        public static function get_groups( $in_groups, $args ) {

            $in_groups[ 'specifics' ] = esc_html__( 'Specific Amounts', 'woopcd-partialcod-pro' );

            return $in_groups;
        }

        public static function get_types( $in_types = array(), $args = array() ) {
            
            $in_types[ 'fixed_amount' ] = esc_html__( 'Fixed amount', 'woopcd-partialcod-pro' );
            
            $in_types[ 'fixed_amount_item' ] = esc_html__( 'Fixed amount per item', 'woopcd-partialcod-pro' );
            
            $in_types[ 'per_amount' ] = esc_html__( 'Percentage amount', 'woopcd-partialcod-pro' );
            
            return $in_types;
        }

        public static function get_amount_required_ids( $in_ids, $args ) {
            
            $in_ids[] = 'fixed_amount';
            $in_ids[] = 'fixed_amount_item';
            $in_ids[] = 'per_amount';
            
            return $in_ids;
        }

        public static function get_based_on_required_ids( $in_ids, $args ) {
            
            $in_ids[] = 'per_amount';
            
            return $in_ids;
        }
        
        public static function get_products_required_ids( $in_ids, $args ) {

            $in_ids[] = 'fixed_amount_item';
           
            return $in_ids;
        }

        public static function process_fixed_amount_options( $amount, $raw_amount, $args ) {

            $amount[ 'amount' ] = 0;

            if ( isset( $raw_amount[ 'amount' ] ) && is_numeric( $raw_amount[ 'amount' ] ) ) {
                
                $amount[ 'amount' ] = $raw_amount[ 'amount' ];
            }

            return $amount;
        }
        
        public static function process_fixed_amount_item_options( $amount, $raw_amount, $args ) {

            $amount[ 'amount' ] = 0;

            if ( isset( $raw_amount[ 'amount' ] ) && is_numeric( $raw_amount[ 'amount' ] ) ) {
                
                $amount[ 'amount' ] = $raw_amount[ 'amount' ];
            }
            
            return $amount;
        }

        public static function process_per_amount_options( $amount, $raw_amount, $args ) {

            $amount[ 'amount' ] = 0;

            if ( isset( $raw_amount[ 'amount' ] ) && is_numeric( $raw_amount[ 'amount' ] ) ) {
                
                $amount[ 'amount' ] = $raw_amount[ 'amount' ];
            }


            $amount[ 'based_on' ] = 2234343;

            if ( isset( $raw_amount[ 'based_on' ] ) && !empty( $raw_amount[ 'based_on' ] ) ) {
                
                $amount[ 'based_on' ] = $raw_amount[ 'based_on' ];
            }

            return $amount;
        }

    }

    WOOPCD_PartialCOD_Admin_Payment_Amount_Type_Specifics::init();
}

