<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Product_Filter_Type_Properties' ) ) {

    class WOOPCD_PartialCOD_Admin_Product_Filter_Type_Properties {

        public static function init() {

            add_filter( 'woopcd_partialcod-admin/get-product-filter-groups', array( new self(), 'get_groups' ), 40, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_properties-group-product-filters', array( new self(), 'get_filters' ), 10, 2 );

            add_filter( 'woopcd_partialcod-admin/get-item_is_virtual-product-filter-fields', array( new self(), 'get_is_yes_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_is_downloadable-product-filter-fields', array( new self(), 'get_is_yes_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_is_featured-product-filter-fields', array( new self(), 'get_is_yes_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_sales_total-product-filter-fields', array( new self(), 'get_total_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_is_on_sale-product-filter-fields', array( new self(), 'get_is_yes_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_stock_status-product-filter-fields', array( new self(), 'get_stock_status_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_stock_quantity-product-filter-fields', array( new self(), 'get_total_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_shipping_class-product-filter-fields', array( new self(), 'get_shipping_class_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_is_taxable-product-filter-fields', array( new self(), 'get_is_yes_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_tax_class-product-filter-fields', array( new self(), 'get_tax_class_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_weight-product-filter-fields', array( new self(), 'get_weight_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_length-product-filter-fields', array( new self(), 'get_dimension_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_width-product-filter-fields', array( new self(), 'get_dimension_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_height-product-filter-fields', array( new self(), 'get_dimension_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_surface_area-product-filter-fields', array( new self(), 'get_dimension_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_volume-product-filter-fields', array( new self(), 'get_dimension_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_meta-product-filter-fields', array( new self(), 'get_meta_fields' ), 10, 2 );
        }

        public static function get_groups( $in_groups, $args ) {

            $in_groups[ 'item_properties' ] = esc_html__( 'Product Properties', 'woopcd-partialcod-pro' );

            return $in_groups;
        }

        public static function get_filters( $in_list, $args ) {

            $weight_unit = get_option( 'woocommerce_weight_unit' );
            $dimension_unit = get_option( 'woocommerce_dimension_unit' );


            $in_list[ 'item_is_virtual' ] = esc_html__( 'Product Is Virtual', 'woopcd-partialcod-pro' );
            $in_list[ 'item_is_downloadable' ] = esc_html__( 'Product Is Downloadable', 'woopcd-partialcod-pro' );
            $in_list[ 'item_is_featured' ] = esc_html__( 'Product Is Featured', 'woopcd-partialcod-pro' );
            $in_list[ 'item_sales_total' ] = esc_html__( 'Product Total Number Of Sales', 'woopcd-partialcod-pro' );
            $in_list[ 'item_is_on_sale' ] = esc_html__( 'Product Is On Sale', 'woopcd-partialcod-pro' );
            $in_list[ 'item_stock_status' ] = esc_html__( 'Product Stock Status', 'woopcd-partialcod-pro' );
            $in_list[ 'item_stock_quantity' ] = esc_html__( 'Product Stock Quantity', 'woopcd-partialcod-pro' );
            $in_list[ 'item_shipping_class' ] = esc_html__( 'Product Shipping Class', 'woopcd-partialcod-pro' );
            $in_list[ 'item_is_taxable' ] = esc_html__( 'Product Is Taxable', 'woopcd-partialcod-pro' );
            $in_list[ 'item_tax_class' ] = esc_html__( 'Product Tax Class', 'woopcd-partialcod-pro' );
            $in_list[ 'item_weight' ] = str_replace( '[0]', $weight_unit, esc_html__( 'Product Weight ([0])', 'woopcd-partialcod-pro' ) );
            $in_list[ 'item_length' ] = str_replace( '[0]', $dimension_unit, esc_html__( 'Product Length ([0])', 'woopcd-partialcod-pro' ) );
            $in_list[ 'item_width' ] = str_replace( '[0]', $dimension_unit, esc_html__( 'Product Width ([0])', 'woopcd-partialcod-pro' ) );
            $in_list[ 'item_height' ] = str_replace( '[0]', $dimension_unit, esc_html__( 'Product Height ([0])', 'woopcd-partialcod-pro' ) );
            $in_list[ 'item_surface_area' ] = esc_html__( 'Product Surface Area', 'woopcd-partialcod-pro' );
            $in_list[ 'item_volume' ] = esc_html__( 'Product Volume', 'woopcd-partialcod-pro' );
            $in_list[ 'item_meta' ] = esc_html__( 'Product Meta Field', 'woopcd-partialcod-pro' );

            return $in_list;
        }

        public static function get_is_yes_fields( $in_fields, $args ) {

            $in_fields[] = array(
                'id' => 'is_yes',
                'type' => 'select2',
                'default' => 'yes',
                'options' => array(
                    'no' => esc_html__( 'No', 'woopcd-partialcod-pro' ),
                    'yes' => esc_html__( 'Yes', 'woopcd-partialcod-pro' ),
                ),
                'width' => '100%',
                'box_width' => '81%',
            );


            return $in_fields;
        }
      
        public static function get_total_fields( $in_fields, $args ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>=',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '98%',
                'box_width' => '35%',
            );

            $in_fields[] = array(
                'id' => 'totals',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '1',
                'placeholder' => esc_html__( '0', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '55%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '1',
                ),
                'width' => '100%',
                'box_width' => '46%',
            );

            return $in_fields;
        }
   
        public static function get_stock_status_fields( $in_fields, $args ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => 'in_list',
                'options' => array(
                    'in_list' => esc_html__( 'Any in the list', 'woopcd-partialcod-pro' ),
                    'none' => esc_html__( 'None in the list', 'woopcd-partialcod-pro' ),
                ),
                'width' => '98%',
                'box_width' => '25%',
            );

            $in_fields[] = array(
                'id' => 'stock_statuses',
                'type' => 'select2',
                'multiple' => true,
                'placeholder' => esc_html__( 'Stock status...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'options' => wc_get_product_stock_status_options(),
                'width' => '100%',
                'box_width' => '56%',
            );


            return $in_fields;
        }

        public static function get_shipping_class_fields( $in_fields, $args ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => 'in_list',
                'options' => array(
                    'in_list' => esc_html__( 'Any in the list', 'woopcd-partialcod-pro' ),
                    'none' => esc_html__( 'None in the list', 'woopcd-partialcod-pro' ),
                ),
                'width' => '98%',
                'box_width' => '25%',
            );

            $in_fields[] = array(
                'id' => 'shipping_class_slugs',
                'type' => 'select2',
                'multiple' => true,
                'placeholder' => esc_html__( 'Select shipping classes...', 'woopcd-partialcod-pro' ),
                'allow_clear' => true,
                'minimum_results_forsearch' => 10,
                'data' => array(
                    'source' => 'wc:shipping_classes',
                    'ajax' => false,
                    'value_col' => 'slug',
                ),
                'width' => '100%',
                'box_width' => '56%',
            );

            return $in_fields;
        }

        public static function get_tax_class_fields( $in_fields, $args ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => 'in_list',
                'options' => array(
                    'in_list' => esc_html__( 'Any in the list', 'woopcd-partialcod-pro' ),
                    'none' => esc_html__( 'None in the list', 'woopcd-partialcod-pro' ),
                ),
                'width' => '98%',
                'box_width' => '25%',
            );

            $in_fields[] = array(
                'id' => 'tax_class_slugs',
                'type' => 'select2',
                'multiple' => true,
                'placeholder' => esc_html__( 'Select tax classes...', 'woopcd-partialcod-pro' ),
                'options' => array(
                    '--0' => esc_html__( 'Standard Rate', 'woopcd-partialcod-pro' )
                ),
                'data' => array(
                    'source' => 'wc:tax_classes',
                    'ajax' => false,
                    'value_col' => 'slug',
                ),
                'width' => '100%',
                'box_width' => '56%',
            );

            return $in_fields;
        }

        public static function get_weight_fields( $in_fields, $args ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>=',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '98%',
                'box_width' => '35%',
            );

            $in_fields[] = array(
                'id' => 'weight',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.5',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '55%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
                'width' => '100%',
                'box_width' => '46%',
            );

            return $in_fields;
        }

        public static function get_dimension_fields( $in_fields, $args ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>=',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '98%',
                'box_width' => '35%',
            );

            $in_fields[] = array(
                'id' => 'dimension',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '1',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '55%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
                'width' => '100%',
                'box_width' => '46%',
            );

            return $in_fields;
        }

        public static function get_meta_fields( $in_fields, $args ) {

            $in_fields[] = array(
                'id' => 'meta_key',
                'type' => 'textbox',
                'input_type' => 'text',
                'default' => '',
                'placeholder' => esc_html__( 'Meta field key', 'woopcd-partialcod-pro' ),
                'width' => '98%',
                'box_width' => '33%',
            );

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => 'empty',
                'options' => array(
                    'empty' => esc_html__( 'Empty', 'woopcd-partialcod-pro' ),
                    'contains' => esc_html__( 'Contains', 'woopcd-partialcod-pro' ),
                    'not_contains' => esc_html__( 'Not contains', 'woopcd-partialcod-pro' ),
                    'begins' => esc_html__( 'Begins with', 'woopcd-partialcod-pro' ),
                    'ends' => esc_html__( 'Ends with', 'woopcd-partialcod-pro' ),
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                    'checked' => esc_html__( 'Checked', 'woopcd-partialcod-pro' ),
                ),
                'fold_id' => 'meta_field_compare',
                'width' => '98%',
                'box_width' => '31%',
            );

            $in_fields[] = array(
                'id' => 'meta_value',
                'type' => 'textbox',
                'input_type' => 'text',
                'default' => '',
                'placeholder' => esc_html__( 'Value', 'woopcd-partialcod-pro' ),
                'fold' => array(
                    'target' => 'meta_field_compare',
                    'attribute' => 'value',
                    'value' => array( 'contains', 'not_contains', 'begins', 'ends', '>=', '>', '<=', '<', '==', '!=' ),
                    'oparator' => 'eq',
                    'clear' => true,
                ),
                'width' => '100%',
                'box_width' => '17%',
            );

            $in_fields[] = array(
                'id' => 'yes_no',
                'type' => 'select2',
                'default' => '>=',
                'options' => array(
                    'no' => esc_html__( 'No', 'woopcd-partialcod-pro' ),
                    'yes' => esc_html__( 'Yes', 'woopcd-partialcod-pro' ),
                ),
                'fold' => array(
                    'target' => 'meta_field_compare',
                    'attribute' => 'value',
                    'value' => array( 'empty', 'checked' ),
                    'oparator' => 'eq',
                    'clear' => false,
                ),
                'width' => '100%',
                'box_width' => '17%',
            );

            return $in_fields;
        }

    }

    WOOPCD_PartialCOD_Admin_Product_Filter_Type_Properties::init();
}