<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Admin_Product_Filter_Type_Subtotals' ) ) {

    class WOOPCD_PartialCOD_Admin_Product_Filter_Type_Subtotals {

        public static function init() {

            add_filter( 'woopcd_partialcod-admin/get-product-filter-groups', array( new self(), 'get_groups' ), 30, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_subtotals-group-product-filters', array( new self(), 'get_filters' ), 10, 2 );

            add_filter( 'woopcd_partialcod-admin/get-item_subtotal-product-filter-fields', array( new self(), 'get_subtotal_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_subtotal_ex_tax-product-filter-fields', array( new self(), 'get_subtotal_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_d_subtotal-product-filter-fields', array( new self(), 'get_subtotal_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/get-item_d_subtotal_ex_tax-product-filter-fields', array( new self(), 'get_subtotal_fields' ), 10, 2 );
        }

        public static function get_groups( $in_groups, $args ) {

            $in_groups[ 'item_subtotals' ] = esc_html__( 'Product Subtotals', 'woopcd-partialcod-pro' );

            return $in_groups;
        }

        public static function get_filters( $in_list, $args ) {

            $in_list[ 'item_subtotal' ] = esc_html__( 'Product Subtotal', 'woopcd-partialcod-pro' );
            $in_list[ 'item_subtotal_ex_tax' ] = esc_html__( 'Product Subtotal (excl. tax)', 'woopcd-partialcod-pro' );
            $in_list[ 'item_d_subtotal' ] = esc_html__( 'Discounted Subtotal', 'woopcd-partialcod-pro' );
            $in_list[ 'item_d_subtotal_ex_tax' ] = esc_html__( 'Discounted Subtotal (excl. tax)', 'woopcd-partialcod-pro' );

            return $in_list;
        }

        public static function get_subtotal_fields( $in_fields, $args ) {

            $in_fields[] = array(
                'id' => 'compare',
                'type' => 'select2',
                'default' => '>=',
                'options' => array(
                    '>=' => esc_html__( 'More than or equal to', 'woopcd-partialcod-pro' ),
                    '>' => esc_html__( 'More than', 'woopcd-partialcod-pro' ),
                    '<=' => esc_html__( 'Less than or equal to', 'woopcd-partialcod-pro' ),
                    '<' => esc_html__( 'Less than', 'woopcd-partialcod-pro' ),
                    '==' => esc_html__( 'Equal to', 'woopcd-partialcod-pro' ),
                    '!=' => esc_html__( 'Not equal to', 'woopcd-partialcod-pro' ),
                ),
                'width' => '98%',
                'box_width' => '35%',
            );

            $in_fields[] = array(
                'id' => 'subtotal',
                'type' => 'textbox',
                'input_type' => 'number',
                'default' => '0.01',
                'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                'width' => '100%',
                'box_width' => '55%',
                'attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                ),
                'width' => '100%',
                'box_width' => '46%',
            );

            return $in_fields;
        }

    }

    WOOPCD_PartialCOD_Admin_Product_Filter_Type_Subtotals::init();
}