<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Premium_Admin_Fee_Rule_Panel_Fees' ) ) {

    class WOOPCD_PartialCOD_Premium_Admin_Fee_Rule_Panel_Fees {

        public static function init() {
            add_filter( 'woopcd_partialcod-admin/get-amount-type-fields', array( new self(), 'get_conditions_title' ), 70, 2 );
            add_filter( 'woopcd_partialcod-admin/get-amount-box-fields', array( new self(), 'get_amount_box_fields' ), 999, 2 );
        }

        public static function get_conditions_title( $in_fields, $args ) {

            if ( $args[ 'module' ] != 'cart-fees' ) {
                return $in_fields;
            }

            $in_fields[] = array(
                'id' => 'any_id',
                'type' => 'paneltitle',
                'full_width' => true,
                'center_head' => true,
                'title' => esc_html__( 'Conditions', 'woopcd-partialcod-pro' ),
                'desc' => esc_html__( 'List of conditions in which this fee amount should apply, all specified conditions must match', 'woopcd-partialcod-pro' ),
                'field_css_class' => array( 'partialcod_logic_title' ),
                'last' => true,
                'fold' => array(
                    'target' => 'set_conditions',
                    'attribute' => 'value',
                    'value' => array( 'yes' ),
                    'oparator' => 'eq',
                    'clear' => false,
                ),
            );


            return $in_fields;
        }

        public static function get_amount_box_fields( $in_fields, $args ) {

            $in_fields[] = array(
                'id' => 'item_base_on',
                'type' => 'select2',
                'column_size' => 4,
                'column_title' => esc_html__( 'Based On', 'woopcd-partialcod-pro' ),
                'tooltip' => esc_html__( 'Controls amount based on item subtotals', 'woopcd-partialcod-pro' ),
                'default' => 'incl_tax',
                'options' => array(
                    'incl_tax' => esc_html__( 'Item subtotal including tax', 'woopcd-partialcod-pro' ),
                    'excl_tax' => esc_html__( 'Item subtotal excluding tax', 'woopcd-partialcod-pro' ),
                    'incl_tax_after' => esc_html__( 'Item subtotal including tax (after discounts)', 'woopcd-partialcod-pro' ),
                    'excl_tax_after' => esc_html__( 'Item subtotal excluding tax (after discounts)', 'woopcd-partialcod-pro' ),
                ),
                'width' => '100%',
                'fold' => array(
                    'target' => 'fee_type',
                    'attribute' => 'value',
                    'value' => WOOPCD_PartialCOD_Premium_Admin_Amount_Types::get_item_based_on_required_ids( $args ),
                    'oparator' => 'eq',
                    'clear' => false,
                ),
            );

            return $in_fields;
        }

    }

    WOOPCD_PartialCOD_Premium_Admin_Fee_Rule_Panel_Fees::init();
}