<?php

if (!class_exists('Reon')) {
    return;
}

if (!class_exists('WOOPCD_PartialCOD_Premium_Admin_Rules_Page')) {
    WOOPCD_PartialCOD_Main::required_paths(dirname(__FILE__), array('method-options-section.php'));

    class WOOPCD_PartialCOD_Premium_Admin_Rules_Page {

        public static function init() {
            add_filter('woopcd_partialcod-admin/method-options/get-rules-apply-methods', array(new self(), 'get_rules_apply_method'), 10);
            add_filter('woopcd_partialcod-admin/method-options/get-rules-modes', array(new self(), 'get_rule_modes'), 10);
        }

        public static function get_rules_apply_method($in_apply_methods) {
            $in_apply_methods['first'] = esc_html__('Apply first valid settings', 'woopcd-partialcod-pro');
            $in_apply_methods['last'] = esc_html__('Apply last valid settings', 'woopcd-partialcod-pro');
            return $in_apply_methods;
        }

        public static function get_rule_modes($in_rule_modes) {
            $in_rule_modes['only_this'] = esc_html__('Apply only this settings', 'woopcd-partialcod-pro');
            $in_rule_modes['if_others'] = esc_html__('Apply if other settings are valid', 'woopcd-partialcod-pro');
            $in_rule_modes['if_no_others'] = esc_html__('Apply if no other valid settings', 'woopcd-partialcod-pro');
            return $in_rule_modes;
        }

    }

}