<?php

if (!class_exists('Reon')) {
    return;
}

if (!class_exists('WOOPCD_PartialCOD_Admin_Order_Activity_Rule_Panel_Options')) {

    class WOOPCD_PartialCOD_Admin_Order_Activity_Rule_Panel_Options {

        public static function init() {

            add_filter('woopcd_partialcod-admin/order-activities/get-rule-panel-options-fields', array(new self(), 'get_Panel_fields'), 10, 2);
            add_filter('woopcd_partialcod-admin/order-activities/get-rule-panels', array(new self(), 'get_Panel'), 20, 2);
            add_filter('reon/get-repeater-field-order_activities-templates', array(new self(), 'get_order_activity_templates'), 10, 2);
            add_filter('reon/get-repeater-field-order_activities-template-groups', array(new self(), 'get_order_activity_template_groups'), 10, 2);
        }

        public static function get_Panel($in_fields, $method_id) {

            $in_fields[] = array(
                'id' => 'any_id',
                'type' => 'panel',
                'full_width' => true,
                'center_head' => true,
                'white_panel' => false,
                'panel_size' => 'smaller',
                'width' => '100%',
                'merge_fields' => false,
                'css_class' => 'partialcod_gateway_panel_options',
                'field_css_class' => array('partialcod_gateway_panel_options_field'),
                'last' => true,
                'fields' => apply_filters('woopcd_partialcod-admin/order-activities/get-' . $method_id . '-rule-panel-options-fields', apply_filters('woopcd_partialcod-admin/order-activities/get-rule-panel-options-fields', array(), $method_id), $method_id),
            );

            return $in_fields;
        }

        public static function get_Panel_fields($in_fields, $method_id) {

            $in_fields[] = array(
                'id' => 'any_id',
                'type' => 'panel',
                'full_width' => true,
                'center_head' => true,
                'white_panel' => true,
                'panel_size' => 'smaller',
                'width' => '100%',
                'last' => true,
                'css_class' => 'partialcod_gateway_options_title',
                'fields' => array(
                    array(
                        'id' => 'any_id',
                        'type' => 'paneltitle',
                        'full_width' => true,
                        'center_head' => true,
                        'title' => esc_html__('Order Autopilots', 'woopcd-partialcod-pro'),
                        'desc' => esc_html__('List of autopilots to apply, empty list not apply any autopilot', 'woopcd-partialcod-pro'),
                    )
                ),
            );


            $in_fields[] = array(
                'id' => 'activities',
                'filter_id' => 'order_activities',
                'field_args' => $method_id,
                'type' => 'repeater',
                'white_repeater' => true,
                'repeater_size' => 'smaller',
                'collapsible' => false,
                'accordions' => false,
                'buttons_sep' => false,
                'delete_button' => true,
                'clone_button' => false,
                'section_type_id' => 'activity_type',
                'css_class' => 'partialcod_gateway_options',
                'field_css_class' => array('partialcod_gateway_options_field'),
                'width' => '100%',
                'auto_expand' => array(
                    'all_section' => true,
                    'new_section' => true,
                    'default_section' => true,
                ),
                'sortable' => array(
                    'enabled' => true,
                ),
                'template_adder' => array(
                    'position' => 'right',
                    'show_list' => true,
                    'list_icon' => 'fa fa-list',
                    'list_width' => '230px',
                    'button_text' => esc_html__('Add Autopilot', 'woopcd-partialcod-pro'),
                ),
            );

            return $in_fields;
        }

        public static function get_order_activity_templates($in_templates, $repeater_args) {

            if ($repeater_args['screen'] == 'option-page' && $repeater_args['option_name'] == WOOPCD_PartialCOD_Admin_Page::get_option_name()) {

                $method_id = $repeater_args['field_args'];


                $options = WOOPCD_PartialCOD_Admin_Order_Activity_Types::get_order_activity_types($method_id);


                foreach ($options as $key => $option) {
                    $in_templates[] = $option;
                    add_filter('roen/get-repeater-template-order_activities-' . $key . '-fields', array(new self(), 'get_order_activity_fields'), 10, 2);
                }
            }

            return $in_templates;
        }

        public static function get_order_activity_template_groups($in_groups, $repeater_args) {

            if ($repeater_args['screen'] == 'option-page' && $repeater_args['option_name'] == WOOPCD_PartialCOD_Admin_Page::get_option_name()) {

                $method_id = $repeater_args['field_args'];

                $in_groups = WOOPCD_PartialCOD_Admin_Order_Activity_Types::get_order_activity_groups($method_id);
            }


            return $in_groups;
        }

        public static function get_order_activity_fields($in_fields, $repeater_args) {

            $method_id = $repeater_args['field_args'];
            $activity_type = $repeater_args['id'];

            return WOOPCD_PartialCOD_Admin_Order_Activity_Types::get_order_activity_type_fields($activity_type, $method_id);
        }

    }

    WOOPCD_PartialCOD_Admin_Order_Activity_Rule_Panel_Options::init();
}
