<?php

if (!class_exists('Reon')) {
    return;
}

if (!class_exists('WOOPCD_PartialCOD_Admin_Order_Activity_Rule_Panel')) {

    class WOOPCD_PartialCOD_Admin_Order_Activity_Rule_Panel {

        public static function init() {
            add_filter('woopcd_partialcod-admin/order-activities/get-rule-panels', array(new self(), 'get_Panel'), 10, 2);
            add_filter('woopcd_partialcod-admin/order-activities/get-rule-panel-fields', array(new self(), 'get_Panel_fields'), 10, 2);
        }

        public static function get_Panel($in_fields, $method_id) {

            $in_fields[] = array(
                'id' => 'rule_id',
                'type' => 'autoid',
                'autoid' => 'partialcod',
            );


            $in_fields[] = array(
                'id' => 'any_id',
                'type' => 'panel',
                'full_width' => true,
                'center_head' => true,
                'white_panel' => true,
                'panel_size' => 'smaller',
                'width' => '100%',
                'merge_fields' => false,
                'last' => true,
                'fields' => apply_filters('woopcd_partialcod-admin/order-activities/get-' . $method_id . '-rule-panel-fields', apply_filters('woopcd_partialcod-admin/order-activities/get-rule-panel-fields', array(), $method_id), $method_id),
            );

            return $in_fields;
        }

        public static function get_Panel_fields($in_fields, $method_id) {

            $args = array(
                'module' => 'order-activities',
                'method_id' => $method_id
            );

            $in_fields[] = array(
                'id' => 'any_ids',
                'type' => 'columns-field',
                'columns' => 2,
                'merge_fields' => false,
                'fields' => array(
                    array(
                        'id' => 'activities_trigger',
                        'type' => 'select2',
                        'column_size' => 1,
                        'column_title' => esc_html__('Autopilots Trigger', 'woopcd-partialcod-pro'),
                        'tooltip' => esc_html__('Triggers the order autopilots in this rule', 'woopcd-partialcod-pro'),
                        'default' => apply_filters('woopcd_partialcod-admin/order-activities/get-trigger-types-default', 'on_order_created', $args),
                        'options' => apply_filters('woopcd_partialcod-admin/order-activities/get-trigger-types', array(), $args),
                        'width' => '100%',
                        'fold_id'=>'activities_trigger',
                    ),
                    array(
                        'id' => 'admin_note',
                        'type' => 'textbox',
                        'tooltip' => esc_html__('Adds a private note for reference purposes', 'woopcd-partialcod-pro'),
                        'column_size' => 1,
                        'column_title' => esc_html__('Admin Note', 'woopcd-partialcod-pro'),
                        'default' => '',
                        'placeholder' => esc_html__('Type here...', 'woopcd-partialcod-pro'),
                        'width' => '100%',
                    ),
                ),
            );

            $in_fields[] = array(
                'id' => 'countdown_timer',
                'type' => 'columns-field',
                'columns' => 3,
                'merge_fields' => false,
                'fields' => array(
                    array(
                        'id' => 'delay_activities',
                        'type' => 'select2',
                        'column_size' => 1,
                        'column_title' => esc_html__('Delay Autopilots', 'woopcd-partialcod-pro'),
                        'tooltip' => esc_html__('Delays the autopilots based on timer', 'woopcd-partialcod-pro'),
                        'default' => 'no',
                        'options' => array(
                            'no' => esc_html__('No', 'woopcd-partialcod-pro'),
                            'yes' => esc_html__('Yes', 'woopcd-partialcod-pro'),
                        ),
                        'width' => '100%',
                        'fold_id' => 'delay_activities',
                    ),
                    array(
                        'id' => 'timer_mode',
                        'type' => 'select2',
                        'column_size' => 1,
                        'column_title' => esc_html__('Timer Mode', 'woopcd-partialcod-pro'),
                        'tooltip' => esc_html__('Controls the activities timer mode', 'woopcd-partialcod-pro'),
                        'default' => 'no',
                        'options' => array(                            
                            'minutes' => esc_html__('Minutes', 'woopcd-partialcod-pro'),
                            'hours' => esc_html__('Hours', 'woopcd-partialcod-pro'),
                            'days' => esc_html__('Days', 'woopcd-partialcod-pro'),
                            'weeks' => esc_html__('Weeks', 'woopcd-partialcod-pro'),
                            'months' => esc_html__('Months', 'woopcd-partialcod-pro'),
                        ),
                        'width' => '100%',
                        'fold' => array(
                            'target' => 'delay_activities',
                            'attribute' => 'value',
                            'value' => 'no',
                            'oparator' => 'neq',
                            'clear' => false,
                        ),
                    ),
                    array(
                        'id' => 'timer',
                        'type' => 'textbox',
                        'input_type' => 'number',
                        'column_size' => 1,
                        'column_title' => esc_html__('Timer', 'woopcd-partialcod-pro'),
                        'tooltip' => esc_html__('Controls the activities timer', 'woopcd-partialcod-pro'),
                        'default' => '1',
                        'placeholder' => esc_html__('00', 'woopcd-partialcod-pro'),
                        'attributes' => array(
                            'min' => '1',
                            'step' => '1',
                        ),
                        'width' => '100%',
                        'fold' => array(
                            'target' => 'delay_activities',
                            'attribute' => 'value',
                            'value' => 'no',
                            'oparator' => 'neq',
                            'clear' => false,
                        ),
                    ),
                ),
            );


            return apply_filters('woopcd_partialcod-admin/order-activities/get-' . $method_id . '-rule-panel-option-fields', apply_filters('woopcd_partialcod-admin/order-activities/get-rule-panel-option-fields', $in_fields, $method_id), $method_id);
        }

    }

    WOOPCD_PartialCOD_Admin_Order_Activity_Rule_Panel::init();
}