<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Admin_RiskFree_Rule_Panel_Amounts' ) ) {

    class WOOPCD_PartialCOD_Admin_RiskFree_Rule_Panel_Amounts {

        public static function init() {
            add_filter( 'woopcd_partialcod-admin/partial-payment/get-rule-panel-amounts-fields', array( new self(), 'get_Panel_fields' ), 10, 2 );
            add_filter( 'woopcd_partialcod-admin/partial-payment/get-rule-panels', array( new self(), 'get_Panel' ), 20, 2 );
            add_filter( 'reon/get-repeater-field-payment_amounts-templates', array( new self(), 'get_option_templates' ), 10, 2 );
            add_filter( 'roen/get-repeater-template-payment_amounts-payment_amount-fields', array( new self(), 'get_payment_fields' ), 10, 2 );
        }

        public static function get_Panel( $in_fields, $method_id ) {

            $in_fields[] = array(
                'id' => 'any_id',
                'type' => 'panel',
                'full_width' => true,
                'center_head' => true,
                'white_panel' => false,
                'panel_size' => 'smaller',
                'width' => '100%',
                'merge_fields' => false,
                'css_class' => 'partialcod_panel_calcs',
                'field_css_class' => array( 'partialcod_panel_calcs_field' ),
                'last' => true,
                'fields' => apply_filters( 'woopcd_partialcod-admin/partial-payment/get-' . $method_id . '-rule-panel-amounts-fields', apply_filters( 'woopcd_partialcod-admin/partial-payment/get-rule-panel-amounts-fields', array(), $method_id ), $method_id ),
            );

            return $in_fields;
        }

        public static function get_Panel_fields( $in_fields, $method_id ) {

            $in_fields[] = array(
                'id' => 'any_id',
                'type' => 'panel',
                'full_width' => true,
                'center_head' => true,
                'white_panel' => true,
                'panel_size' => 'smaller',
                'width' => '100%',
                'last' => true,
                'css_class' => 'partialcod_calcs_title',
                'fields' => array(
                    array(
                        'id' => 'any_id',
                        'type' => 'paneltitle',
                        'full_width' => true,
                        'center_head' => true,
                        'title' => esc_html__( 'Payment Amounts', 'woopcd-partialcod-pro' ),
                        'desc' => esc_html__( 'List of amounts to apply, empty list will apply zero amount', 'woopcd-partialcod-pro' ),
                    )
                ),
            );
            $in_fields[] = array(
                'id' => 'payment_amounts',
                'filter_id' => 'payment_amounts',
                'field_args' => $method_id,
                'type' => 'repeater',
                'white_repeater' => true,
                'repeater_size' => 'smaller',
                'collapsible' => false,
                'accordions' => false,
                'buttons_sep' => false,
                'delete_button' => true,
                'clone_button' => false,
                'css_class' => 'partialcod_calcs',
                'field_css_class' => array( 'partialcod_calcs_field' ),
                'width' => '100%',
                'auto_expand' => array(
                    'all_section' => true,
                    'new_section' => true,
                    'default_section' => true,
                    'cloned_section' => true,
                ),
                'sortable' => array(
                    'enabled' => true,
                ),
                'template_adder' => array(
                    'position' => 'right',
                    'button_text' => esc_html__( 'Add Amount', 'woopcd-partialcod-pro' ),
                ),
            );

            return $in_fields;
        }

        public static function get_option_templates( $in_templates, $repeater_args ) {

            if ( $repeater_args[ 'screen' ] == 'option-page' && $repeater_args[ 'option_name' ] == WOOPCD_PartialCOD_Admin_Page::get_option_name() ) {

                $in_templates[] = array(
                    'id' => 'payment_amount',
                    'head' => array(
                        'title' => '',
                        'defaut_title' => 'Partial Payment',
                        'title_field' => 'amount_type',
                    )
                );
            }

            return $in_templates;
        }

        public static function get_payment_fields( $in_fields, $repeater_args ) {

            $method_id = $repeater_args[ 'field_args' ];

            $args = array(
                'module' => 'partial-payment',
                'method_id' => $method_id,
                'fold_id' => 'amount_type',
            );





            $amount_types = WOOPCD_PartialCOD_Admin_Payment_Amount_Types::get_types( $args );





            $in_fields[] = array(
                'id' => 'any_ids',
                'type' => 'columns-field',
                'columns' => 5,
                'merge_fields' => false,
                'fields' => array(
                    array(
                        'id' => 'amount_type',
                        'type' => 'select2',
                        'column_size' => 2,
                        'column_title' => esc_html__( 'Amount Type', 'woopcd-partialcod-pro' ),
                        'tooltip' => esc_html__( 'Controls payment amount type', 'woopcd-partialcod-pro' ),
                        'default' => apply_filters( 'woopcd_partialcod-admin/get-payment-amount-types-default', 'fixed_amount', $args ),
                        'options' => $amount_types,
                        'attributes' => array(
                            'data-repeater-title' => 'payment_amounts',
                        ),
                        'width' => '100%',
                        'fold_id' => 'amount_type',
                    ),
                    array(
                        'id' => 'amount',
                        'type' => 'textbox',
                        'input_type' => 'number',
                        'tooltip' => esc_html__( 'Controls the amount to apply, based on amount type', 'woopcd-partialcod-pro' ),
                        'column_size' => 1,
                        'column_title' => esc_html__( 'Amount', 'woopcd-partialcod-pro' ),
                        'default' => '0.00',
                        'placeholder' => esc_html__( '0.00', 'woopcd-partialcod-pro' ),
                        'width' => '100%',
                        'attributes' => array(
                            'min' => '0',
                            'step' => '0.01',
                        ),
                        'fold' => array(
                            'target' => 'amount_type',
                            'attribute' => 'value',
                            'value' => WOOPCD_PartialCOD_Admin_Payment_Amount_Types::get_amount_required_ids( $args ),
                            'oparator' => 'eq',
                            'clear' => true,
                        ),
                    ),
                    array(
                        'id' => 'based_on',
                        'type' => 'select2',
                        'column_size' => 2,
                        'column_title' => esc_html__( 'Based On', 'woopcd-partialcod-pro' ),
                        'tooltip' => esc_html__( 'Controls amount based on cart subtotals', 'woopcd-partialcod-pro' ),
                        'default' => '2234343',
                        'data' => 'partialcod:riskfree_carttotals',
                        'width' => '100%',
                        'fold' => array(
                            'target' => 'amount_type',
                            'attribute' => 'value',
                            'value' => WOOPCD_PartialCOD_Admin_Payment_Amount_Types::get_based_on_required_ids( $args ),
                            'oparator' => 'eq',
                            'clear' => true,
                            'empty' => '2234343',
                        ),
                    ),
                    array(
                        'id' => 'item_based_on',
                        'type' => 'select2',
                        'column_size' => 4,
                        'column_title' => esc_html__( 'Based On', 'woopcd-partialcod-pro' ),
                        'tooltip' => esc_html__( 'Controls amount based on item subtotals', 'woopcd-partialcod-pro' ),
                        'default' => 'incl_tax',
                        'options' => array(
                            'incl_tax' => esc_html__( 'Item subtotal including tax' ),
                            'excl_tax' => esc_html__( 'Item subtotal excluding tax' ),
                            'incl_tax_after' => esc_html__( 'Item subtotal including tax (after discounts)' ),
                            'excl_tax_after' => esc_html__( 'Item subtotal excluding tax (after discounts)' ),
                        ),
                        'width' => '100%',
                        'fold' => array(
                            'target' => 'amount_type',
                            'attribute' => 'value',
                            'value' => WOOPCD_PartialCOD_Admin_Payment_Amount_Types::get_item_based_on_required_ids( $args ),
                            'oparator' => 'eq',
                            'clear' => false,
                        ),
                    ),
                ),
            );


            foreach ( WOOPCD_PartialCOD_Admin_Payment_Amount_Types::get_type_fields( 'amount_type', $args ) as $type_field ) {
                $in_fields[] = $type_field;
            }

            $in_fields = WOOPCD_PartialCOD_Admin_Payment_Amount_Types::get_other_fields( $in_fields, $args );

            return $in_fields;
        }

    }

    WOOPCD_PartialCOD_Admin_RiskFree_Rule_Panel_Amounts::init();
}