<?php

if (!class_exists('Reon')) {
    return;
}

if (!class_exists('WOOPCD_PartialCOD_Admin_RiskFree_Rule_Panel_Options')) {

    class WOOPCD_PartialCOD_Admin_RiskFree_Rule_Panel_Options {

        public static function init() {
            add_filter('woopcd_partialcod-admin/partial-payment/get-rule-panel-option-fields', array(new self(), 'get_fields'), 10, 2);
        }

        public static function get_fields($in_fields, $method_id) {

            $in_fields[] = array(
                'id' => 'any_ids',
                'type' => 'columns-field',
                'columns' => 5,
                'merge_fields' => false,
                'fields' => array(
                    array(
                        'id' => 'admin_note',
                        'type' => 'textbox',
                        'tooltip' => esc_html__('Adds a private note for reference purposes', 'woopcd-partialcod-pro'),
                        'column_size' => 2,
                        'column_title' => esc_html__('Admin Note', 'woopcd-partialcod-pro'),
                        'default' => '',
                        'placeholder' => esc_html__('Type here...', 'woopcd-partialcod-pro'),
                        'width' => '100%',
                    ),
                    array(
                        'id' => 'allow_methods',
                        'type' => 'select2',
                        'column_size' => 3,
                        'column_title' => esc_html__('Allowed Payment Methods', 'woopcd-partialcod-pro'),
                        'tooltip' => esc_html__('Controls which other payment methods should available with this partial payment rule', 'woopcd-partialcod-pro'),
                        'default' => '',
                        'placeholder' => esc_html__('Select payment methods', 'woopcd-partialcod-pro'),
                        'multiple' => true,
                        'options' => self::get_other_methods(),
                        'width' => '100%',
                    ),
                ),
            );

            $in_fields[] = array(
                'id' => 'any_ids',
                'type' => 'columns-field',                
                'columns' => 1,
                'merge_fields' => false,
                'fields' => array(
                    array(
                        'id' => 'desc',
                        'type' => 'textbox',
                        'sanitize_type' => 'partialcod_kses_post',
                        'tooltip' => esc_html__('Controls partial payment transaction details, try {{partial_amount}}, {{remaining_amount}} and {{order_totals}}', 'woopcd-partialcod-pro'),
                        'column_size' => 1,
                        'column_title' => esc_html__('Description', 'woopcd-partialcod-pro'),
                        'default' => '',
                        'placeholder' => esc_html__('Type here...', 'woopcd-partialcod-pro'),
                        'width' => '100%',
                    ),
                ),
            );

            return $in_fields;
        }

        private static function get_other_methods() {
            $methods = array();
            foreach (WOOPCD_PartialCOD_Admin_Page::get_all_payment_methods() as $key => $method) {
                if (!WOOPCD_PartialCOD_Main::is_risky_method($key)) {
                    $methods[$key] = $method['method_title'];
                }
            }
            return $methods;
        }

    }

    WOOPCD_PartialCOD_Admin_RiskFree_Rule_Panel_Options::init();
}