<?php

if (!class_exists('Reon')) {
    return;
}

if (!class_exists('WOOPCD_PartialCOD_Premium_Admin_Page')) {

    require_once dirname(__FILE__) . '/method-options-section/method-options-section.php';
    require_once dirname(__FILE__) . '/risk-free-section/risk-free-section.php';
    require_once dirname(__FILE__) . '/cart-discounts-section/cart-discounts-section.php';
    require_once dirname(__FILE__) . '/cart-fees-section/cart-fees-section.php';    
    require_once dirname(__FILE__) . '/order-activities-section/order-activities-section.php';
    require_once dirname(__FILE__) . '/settings-section/settings-section.php';

    class WOOPCD_PartialCOD_Premium_Admin_Page {

        public static function init() {
            WOOPCD_PartialCOD_Premium_Admin_Rules_Page::init();
            WOOPCD_PartialCOD_Premium_Admin_Risk_Free_Rules_Page::init();
            WOOPCD_PartialCOD_Premium_Admin_Discount_Rules_Page::init();
            WOOPCD_PartialCOD_Premium_Admin_Fee_Rules_Page::init();
            WOOPCD_PartialCOD_Premium_Admin_Order_Activity_Rules_Page::init();
            
            add_filter( 'plugin_action_links_' . plugin_basename( WOOPCD_PARTIALCOD_PREMIUM_FILE ), array( new self(), 'get_plugin_links' ), 10, 1 );
        }
        
        public static function get_plugin_links( $links ) {

            $doc_link = '<a href="' . esc_url( 'https://zencrew.freshdesk.com/support/solutions/51000070103' ) . '">' . esc_html__( 'Documentation', 'woopcd-partialcod-pro' ) . '</a>';

            array_unshift( $links, $doc_link );

            $settings_url = admin_url( 'admin.php?page=partialcod-settings' );

            $settings_link = '<a href="' . esc_url( $settings_url ) . '">' . esc_html__( 'Settings', 'woopcd-partialcod-pro' ) . '</a>';

            array_unshift( $links, $settings_link );

            return $links;
        }

    }

    WOOPCD_PartialCOD_Premium_Admin_Page::init();
}