<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Premium_Admin_Order_Activity_Settings' ) ) {

    class WOOPCD_PartialCOD_Premium_Admin_Order_Activity_Settings {

        public static function init() {
            $option_name = WOOPCD_PartialCOD_Admin_Page::get_option_name();

            add_filter( 'woopcd_partialcod-admin/get-settings-section-fields', array( new self, 'get_fields' ), 50 );

            add_filter( 'reon/get-repeater-field-order_cron_sechduler-templates', array( new self(), 'get_cron_scheduler_templates' ), 10, 2 );
            add_filter( 'roen/get-repeater-template-order_cron_sechduler-cron_default-fields', array( new self(), 'get_cron_scheduler_template_fields' ), 10, 2 );
            add_filter( 'roen/get-repeater-template-order_cron_sechduler-cron_option-fields', array( new self(), 'get_cron_scheduler_template_fields' ), 10, 2 );

            add_filter( 'reon/get-simple-repeater-field-activity_order_totals-templates', array( new self(), 'get_order_total_option_templates' ), 10, 2 );
            add_filter( 'roen/get-simple-repeater-template-activity_order_totals-calc_default-fields', array( new self(), 'get_order_total_template_fields' ), 10, 2 );
            add_filter( 'roen/get-simple-repeater-template-activity_order_totals-calc_option-fields', array( new self(), 'get_order_total_template_fields' ), 10, 2 );

            add_filter( 'woopcd_partialcod-admin/get-data-list-cron_jobs', array( new self(), 'get_cron_jobs_data_list' ), 10, 2 );

            add_filter( 'reon/process-save-options-' . $option_name, array( new self(), 'clear_transient' ), 10 );
        }

        public static function get_fields( $in_fields ) {



            $in_fields[] = array(
                'id' => 'any_idwws',
                'type' => 'panel',
                'last' => true,
                'white_panel' => false,
                'panel_size' => 'smaller',
                'width' => '100%',
                'merge_fields' => false,
                'fields' => self::get_settings_fields( array() ),
            );


            return $in_fields;
        }

        public static function get_cron_scheduler_templates( $in_templates, $repeater_args ) {
            if ( $repeater_args[ 'screen' ] == 'option-page' && $repeater_args[ 'option_name' ] == WOOPCD_PartialCOD_Admin_Page::get_option_name() ) {


                $in_templates[] = array(
                    'id' => 'cron_default',
                    'head' => array(
                        'title' => '',
                        'defaut_title' => esc_html__( 'Cron Task', 'woopcd-partialcod-pro' ),
                        'title_field' => 'admin_note',
                        'subtitle_field' => 'intervals',
                    ),
                    'empy_button' => true,
                );

                $in_templates[] = array(
                    'id' => 'cron_option',
                    'head' => array(
                        'title' => '',
                        'defaut_title' => esc_html__( 'Cron Task', 'woopcd-partialcod-pro' ),
                        'title_field' => 'admin_note',
                        'subtitle_field' => 'intervals',
                    ),
                );
            }

            return $in_templates;
        }

        public static function get_cron_scheduler_template_fields( $in_fields, $repeater_args ) {
            if ( $repeater_args[ 'screen' ] == 'option-page' && $repeater_args[ 'option_name' ] == WOOPCD_PartialCOD_Admin_Page::get_option_name() ) {

                $in_fields[] = array(
                    'id' => 'option_id',
                    'type' => 'autoid',
                    'autoid' => 'partialcod',
                );




                $in_fields[] = array(
                    'id' => 'any_ids',
                    'type' => 'columns-field',
                    'columns' => 5,
                    'title' => esc_html__( 'Cron Tasks Settings', 'woopcd-partialcod-pro' ),
                    'desc' => esc_html__( 'Use these settings to control the cron task schedules', 'woopcd-partialcod-pro' ),
                    'full_width' => true,
                    'center_head' => true,
                    'merge_fields' => false,
                    'fields' => array(
                        array(
                            'id' => 'admin_note',
                            'type' => 'textbox',
                            'tooltip' => esc_html__( 'Adds a private note for reference purposes', 'woopcd-partialcod-pro' ),
                            'column_size' => 2,
                            'column_title' => esc_html__( 'Admin Note', 'woopcd-partialcod-pro' ),
                            'default' => '',
                            'placeholder' => esc_html__( 'Type here...', 'woopcd-partialcod-pro' ),
                            'width' => '100%',
                        ),
                        array(
                            'id' => 'intervals',
                            'type' => 'select2',
                            'column_size' => 1,
                            'column_title' => esc_html__( 'Cron Intervals', 'woopcd-partialcod-pro' ),
                            'tooltip' => esc_html__( 'Determines how often to run the cron task', 'woopcd-partialcod-pro' ),
                            'data' => 'partialcod:schedule_intervals',
                            'width' => '100%',
                            'fold_id' => 'intervals',
                        ),
                        array(
                            'id' => 'start_date',
                            'type' => 'date',
                            'tooltip' => esc_html__( 'Determines when to start the cron task', 'woopcd-partialcod-pro' ),
                            'column_size' => 1,
                            'column_title' => esc_html__( 'Start Date', 'woopcd-partialcod-pro' ),
                            'default' => '',
                            'date_format' => 'yy-mm-dd',
                            'placeholder' => esc_html__( 'yy-mm-dd', 'woopcd-partialcod-pro' ),
                            'number_of_months' => 1,
                            'show_button_panel' => false,
                            'change_month' => true,
                            'change_year' => true,
                            'first_day' => 0,
                            'width' => '100%',
                            'fold' => array(
                                'target' => 'intervals',
                                'attribute' => 'value',
                                'value' => '',
                                'oparator' => 'neq',
                                'clear' => false,
                            ),
                        ),
                        array(
                            'id' => 'start_time',
                            'type' => 'time',
                            'tooltip' => esc_html__( 'Determines when to start the cron task', 'woopcd-partialcod-pro' ),
                            'column_size' => 1,
                            'column_title' => esc_html__( 'Start Time', 'woopcd-partialcod-pro' ),
                            'default' => '',
                            'time_format' => 'HH:mm:ss',
                            'one_line' => true,
                            'placeholder' => esc_html__( '00:00:00', 'woopcd-partialcod-pro' ),
                            'width' => '100%',
                            'fold' => array(
                                'target' => 'intervals',
                                'attribute' => 'value',
                                'value' => '',
                                'oparator' => 'neq',
                                'clear' => false,
                            ),
                        ),
                    ),
                );

                $in_fields[] = array(
                    'id' => 'any_ids',
                    'type' => 'columns-field',
                    'columns' => 3,
                    'title' => esc_html__( 'Database Query Settings', 'woopcd-partialcod-pro' ),
                    'desc' => esc_html__( 'Use these settings to control the customer orders to include in the cron task', 'woopcd-partialcod-pro' ),
                    'full_width' => true,
                    'center_head' => true,
                    'merge_fields' => false,
                    'fold' => array(
                        'target' => 'intervals',
                        'attribute' => 'value',
                        'value' => '',
                        'oparator' => 'neq',
                        'clear' => false,
                    ),
                    'fields' => array(
                        array(
                            'id' => 'query_from_mode',
                            'type' => 'select2',
                            'column_size' => 1,
                            'column_title' => esc_html__( 'Orders From', 'woopcd-partialcod-pro' ),
                            'tooltip' => esc_html__( 'Use this option to control the customer orders to include based on date and time', 'woopcd-partialcod-pro' ),
                            'default' => '',
                            'options' => array(
                                '' => esc_html__( 'All time', 'woopcd-partialcod-pro' ),
                                'date' => esc_html__( 'Date', 'woopcd-partialcod-pro' ),
                                'timespan' => esc_html__( 'Time-span', 'woopcd-partialcod-pro' ),
                            ),
                            'width' => '100%',
                            'fold_id' => 'order_date_type',
                        ),
                        array(
                            'id' => 'query_timespan_mode',
                            'type' => 'select2',
                            'column_size' => 1,
                            'column_title' => esc_html__( 'Time-Span Mode', 'woopcd-partialcod-pro' ),
                            'tooltip' => esc_html__( 'Use this option to control the customer orders to include based on time-span', 'woopcd-partialcod-pro' ),
                            'default' => 'hours',
                            'options' => array(
                                'minutes' => esc_html__( 'Minutes', 'woopcd-partialcod-pro' ),
                                'hours' => esc_html__( 'Hours', 'woopcd-partialcod-pro' ),
                                'days' => esc_html__( 'Days', 'woopcd-partialcod-pro' ),
                                'weeks' => esc_html__( 'Weeks', 'woopcd-partialcod-pro' ),
                                'months' => esc_html__( 'Months', 'woopcd-partialcod-pro' ),
                                'years' => esc_html__( 'Years', 'woopcd-partialcod-pro' ),
                            ),
                            'width' => '100%',
                            'fold' => array(
                                'target' => 'order_date_type',
                                'attribute' => 'value',
                                'value' => 'timespan',
                                'oparator' => 'eq',
                                'clear' => false,
                            ),
                        ),
                        array(
                            'id' => 'query_timespan',
                            'type' => 'textbox',
                            'column_size' => 1,
                            'column_title' => esc_html__( 'Time-Span', 'woopcd-partialcod-pro' ),
                            'tooltip' => esc_html__( 'Use this option to control the customer orders to include based on time-span', 'woopcd-partialcod-pro' ),
                            'input_type' => 'number',
                            'default' => '12',
                            'placeholder' => esc_html__( '0', 'woopcd-partialcod-pro' ),
                            'width' => '100%',
                            'attributes' => array(
                                'min' => '1',
                                'step' => '1',
                            ),
                            'fold' => array(
                                'target' => 'order_date_type',
                                'attribute' => 'value',
                                'value' => 'timespan',
                                'oparator' => 'eq',
                                'clear' => false,
                            ),
                        ),
                        array(
                            'id' => 'query_date',
                            'type' => 'date',
                            'tooltip' => esc_html__( 'Use this option to control the customer orders to include based on date', 'woopcd-partialcod-pro' ),
                            'column_size' => 1,
                            'column_title' => esc_html__( 'Date', 'woopcd-partialcod-pro' ),
                            'default' => '',
                            'date_format' => 'yy-mm-dd',
                            'placeholder' => esc_html__( 'yy-mm-dd', 'woopcd-partialcod-pro' ),
                            'number_of_months' => 1,
                            'show_button_panel' => false,
                            'change_month' => true,
                            'change_year' => true,
                            'first_day' => 0,
                            'width' => '100%',
                            'fold' => array(
                                'target' => 'order_date_type',
                                'attribute' => 'value',
                                'value' => 'date',
                                'oparator' => 'eq',
                                'clear' => false,
                            ),
                        ),
                    ),
                );



                $in_fields[] = array(
                    'id' => 'any_ids',
                    'type' => 'columns-field',
                    'columns' => 2,
                    'merge_fields' => false,
                    'fold' => array(
                        'target' => 'intervals',
                        'attribute' => 'value',
                        'value' => '',
                        'oparator' => 'neq',
                        'clear' => false,
                    ),
                    'fields' => array(
                        array(
                            'id' => 'query_status',
                            'type' => 'select2',
                            'column_size' => 1,
                            'column_title' => esc_html__( 'Order Status', 'woopcd-partialcod-pro' ),
                            'tooltip' => esc_html__( 'Use this option to control the customer orders to include based on order status', 'woopcd-partialcod-pro' ),
                            'data' => 'partialcod:wc_order_statuses',
                            'placeholder' => esc_html__( 'Select...', 'woopcd-partialcod-pro' ),
                            'multiple' => true,
                            'width' => '100%',
                        ),
                        array(
                            'id' => 'query_payment_methods',
                            'type' => 'select2',
                            'column_size' => 1,
                            'column_title' => esc_html__( 'Payment Methods', 'woopcd-partialcod-pro' ),
                            'tooltip' => esc_html__( 'Use this option to control the customer orders to include based on order payment methods', 'woopcd-partialcod-pro' ),
                            'data' => 'partialcod:payment_methods',
                            'placeholder' => esc_html__( 'Select...', 'woopcd-partialcod-pro' ),
                            'multiple' => true,
                            'width' => '100%',
                        ),
                    )
                );

                $in_fields[] = array(
                    'id' => 'any_ids',
                    'type' => 'columns-field',
                    'columns' => 11,
                    'merge_fields' => false,
                    'fold' => array(
                        'target' => 'intervals',
                        'attribute' => 'value',
                        'value' => '',
                        'oparator' => 'neq',
                        'clear' => false,
                    ),
                    'fields' => array(
                        array(
                            'id' => 'query_custom_meta_key',
                            'type' => 'textbox',
                            'column_size' => 2,
                            'column_title' => esc_html__( 'Meta Key', 'woopcd-partialcod-pro' ),
                            'tooltip' => esc_html__( 'Use this option to limit the number of customer orders from database', 'woopcd-partialcod-pro' ),
                            'default' => '',
                            'placeholder' => esc_html__( 'Meta key', 'woopcd-partialcod-pro' ),
                            'width' => '100%',
                        ),
                        array(
                            'id' => 'query_custom_meta_value',
                            'type' => 'textbox',
                            'column_size' => 2,
                            'column_title' => esc_html__( 'Meta Value', 'woopcd-partialcod-pro' ),
                            'tooltip' => esc_html__( 'Use this option to limit the number of customer orders from database', 'woopcd-partialcod-pro' ),
                            'default' => '',
                            'placeholder' => esc_html__( 'Meta value', 'woopcd-partialcod-pro' ),
                            'width' => '100%',
                        ),
                        array(
                            'id' => 'query_limit',
                            'type' => 'textbox',
                            'column_size' => 1,
                            'column_title' => esc_html__( 'Limit', 'woopcd-partialcod-pro' ),
                            'tooltip' => esc_html__( 'Use this option to limit the number of customer orders from database', 'woopcd-partialcod-pro' ),
                            'input_type' => 'number',
                            'default' => '100',
                            'placeholder' => esc_html__( '0', 'woopcd-partialcod-pro' ),
                            'width' => '100%',
                            'attributes' => array(
                                'min' => '1',
                                'step' => '1',
                            ),
                        ),
                        array(
                            'id' => 'query_sort',
                            'type' => 'select2',
                            'column_size' => 2,
                            'column_title' => esc_html__( 'Sort Type', 'woopcd-partialcod-pro' ),
                            'tooltip' => esc_html__( 'Use this option to sort the customer orders from database', 'woopcd-partialcod-pro' ),
                            'default' => 'ASC',
                            'options' => array(
                                'ASC' => esc_html__( 'Ascending order', 'woopcd-partialcod-pro' ),
                                'DESC' => esc_html__( 'Descending order', 'woopcd-partialcod-pro' ),
                            ),
                            'width' => '100%',
                        ),
                        array(
                            'id' => 'batch_size',
                            'type' => 'textbox',
                            'column_size' => 2,
                            'column_title' => esc_html__( 'Batch Size', 'woopcd-partialcod-pro' ),
                            'tooltip' => esc_html__( 'Use this option to limit the customer orders per task run', 'woopcd-partialcod-pro' ),
                            'input_type' => 'number',
                            'default' => '10',
                            'placeholder' => esc_html__( '0', 'woopcd-partialcod-pro' ),
                            'width' => '100%',
                            'attributes' => array(
                                'min' => '1',
                                'step' => '1',
                            ),
                        ),
                        array(
                            'id' => 'batch_intervals',
                            'type' => 'textbox',
                            'column_size' => 2,
                            'column_title' => esc_html__( 'Batch Interval', 'woopcd-partialcod-pro' ),
                            'tooltip' => esc_html__( 'Use this option to control the task run intervals in seconds', 'woopcd-partialcod-pro' ),
                            'input_type' => 'number',
                            'default' => '2',
                            'placeholder' => esc_html__( '0', 'woopcd-partialcod-pro' ),
                            'width' => '100%',
                            'attributes' => array(
                                'min' => '1',
                                'step' => '1',
                            ),
                        ),
                    ),
                );
            }

            return $in_fields;
        }

        public static function get_order_total_option_templates( $in_templates, $repeater_args ) {
            if ( $repeater_args[ 'screen' ] == 'option-page' && $repeater_args[ 'option_name' ] == WOOPCD_PartialCOD_Admin_Page::get_option_name() ) {


                $in_templates[] = array(
                    'id' => 'calc_default',
                    'empy_button' => true,
                );

                $in_templates[] = array(
                    'id' => 'calc_option',
                );
            }

            return $in_templates;
        }

        public static function get_order_total_template_fields( $in_fields, $repeater_args ) {
            if ( $repeater_args[ 'screen' ] == 'option-page' && $repeater_args[ 'option_name' ] == WOOPCD_PartialCOD_Admin_Page::get_option_name() ) {

                $in_fields[] = array(
                    'id' => 'option_id',
                    'type' => 'autoid',
                    'autoid' => 'partialcod',
                );

                $in_fields[] = array(
                    'id' => 'title',
                    'type' => 'textbox',
                    'default' => esc_html__( 'Cart subtotal', 'woopcd-partialcod-pro' ),
                    'placeholder' => esc_html__( 'Title here...', 'woopcd-partialcod-pro' ),
                    'width' => '98%',
                    'box_width' => '36%',
                );


                $in_fields[] = array(
                    'id' => 'include',
                    'type' => 'select2',
                    'multiple' => true,
                    'default' => array( 'subtotal' ),
                    'options' => self::get_calc_options(),
                    'width' => '100%',
                    'box_width' => '64%',
                );
            }
            return $in_fields;
        }

        public static function get_calc_options() {

            $options = array();

            $options[ 'subtotal' ] = esc_html__( 'Add subtotal', 'woopcd-partialcod-pro' );
            $options[ 'dicounts' ] = esc_html__( 'Add coupon dicounts', 'woopcd-partialcod-pro' );
            $options[ 'dicounts_taxes' ] = esc_html__( 'Add coupon dicounts taxes', 'woopcd-partialcod-pro' );
            $options[ 'n_dicounts' ] = esc_html__( 'Subtract dicounts coupons', 'woopcd-partialcod-pro' );
            $options[ 'n_dicounts_taxes' ] = esc_html__( 'Subtract dicounts coupon taxes', 'woopcd-partialcod-pro' );
            $options[ 'fees' ] = esc_html__( 'Add fees', 'woopcd-partialcod-pro' );
            $options[ 'fee_taxes' ] = esc_html__( 'Add fee taxes', 'woopcd-partialcod-pro' );
            $options[ 'shipping_cost' ] = esc_html__( 'Add shipping cost', 'woopcd-partialcod-pro' );
            $options[ 'shipping_cost_tax' ] = esc_html__( 'Add shipping cost tax', 'woopcd-partialcod-pro' );
            $options[ 'total' ] = esc_html__( 'Add order totals', 'woopcd-partialcod-pro' );
            $options[ 'total_tax' ] = esc_html__( 'Add order totals tax', 'woopcd-partialcod-pro' );
            $options[ 'total_shipping_refunded' ] = esc_html__( 'Add shipping refunded', 'woopcd-partialcod-pro' );
            $options[ 'total_refunded' ] = esc_html__( 'Add total refunded', 'woopcd-partialcod-pro' );
            $options[ 'total_tax_refunded' ] = esc_html__( 'Add total refunded tax', 'woopcd-partialcod-pro' );
            $options[ 'n_total_shipping_refunded' ] = esc_html__( 'Subtract shipping refunded', 'woopcd-partialcod-pro' );
            $options[ 'n_total_refunded' ] = esc_html__( 'Subtract total refunded', 'woopcd-partialcod-pro' );
            $options[ 'n_total_tax_refunded' ] = esc_html__( 'Subtract total refunded tax', 'woopcd-partialcod-pro' );


            return apply_filters( 'woopcd_partialcod-admin/order-activities/get-order-totals-options', $options );
        }

        public static function get_cron_jobs_data_list( $result, $data_args ) {

            global $woopcd_partialcod;

            $options = array();
            if ( isset( $woopcd_partialcod[ 'order_cron_sechduler' ] ) ) {
                $options = $woopcd_partialcod[ 'order_cron_sechduler' ];
            } else {
                $options = self::get_default_cron_options();
            }

            foreach ( $options as $option ) {
                if ( isset( $option[ 'admin_note' ] ) && '' != $option[ 'admin_note' ] ) {
                    $result[ $option[ 'option_id' ] ] = $option[ 'admin_note' ];
                } else {
                    $result[ $option[ 'option_id' ] ] = esc_html__( 'Cron Scheduler', 'woopcd-partialcod-pro' );
                }
            }

            return $result;
        }

        public static function clear_transient( $options ) {
            delete_transient( 'wp_partialcod_cron_scheduler_next' );
            delete_transient( 'wp_partialcod_cron_scheduler_active' );
            return $options;
        }

        private static function get_settings_fields( $in_fields ) {

            $allowed_html = array(
                'a' => array(
                    'id' => true,
                    'href' => true,
                    'target' => true,
                ),
                'br' => array(),
            );

            $in_fields[] = array(
                'id' => 'any_idssasss',
                'type' => 'paneltitle',
                'full_width' => true,
                'center_head' => true,
                'title' => esc_html__( 'Orders Cron Tasks', 'woopcd-partialcod-pro' ),
                'desc' => wp_kses( __( 'Order autopilots can be triggered from cron tasks, use these settings to create those cron tasks.</ br> You can also use <a href="https://wordpress.org/plugins/wp-crontrol/" target="_blank">WP Crontrol</a> to view/manage the cron tasks', 'woopcd-partialcod-pro' ), $allowed_html ),
            );


            $in_fields[] = array(
                'id' => 'order_cron_sechduler',
                'type' => 'repeater',
                'white_repeater' => true,
                'repeater_size' => 'smaller',
                'accordions' => true,
                'buttons_sep' => false,
                'delete_button' => true,
                'clone_button' => false,
                'width' => '100%',
                'default' => self::get_default_cron_options(),
                'static_template' => 'cron_default',
                'section_type_id' => 'cron_option_type',
                'auto_expand' => array(
                    'new_section' => true,
                    'cloned_section' => false,
                ),
                'sortable' => array(
                    'enabled' => true,
                ),
                'template_adder' => array(
                    'position' => 'right',
                    'show_list' => false,
                    'button_text' => esc_html__( 'Add Cron Task', 'woopcd-partialcod-pro' ),
                ),
            );


            $in_fields[] = array(
                'id' => 'any_idssa',
                'type' => 'paneltitle',
                'full_width' => true,
                'center_head' => true,
                'title' => esc_html__( 'Order Totals Calculations', 'woopcd-partialcod-pro' ),
                'desc' => esc_html__( 'Use these settings to control what are included in the "order totals" conditions', 'woopcd-partialcod-pro' ),
            );


            $in_fields[] = array(
                'id' => 'activity_order_totals',
                'type' => 'simple-repeater',
                'full_width' => true,
                'center_head' => true,
                'white_repeater' => true,
                'repeater_size' => 'smaller',
                'buttons_sep' => false,
                'buttons_box_width' => '65px',
                'width' => '100%',
                'default' => self::get_default_order_totals_options(),
                'static_template' => 'calc_default',
                'section_type_id' => 'calc_option_type',
                'sortable' => array(
                    'enabled' => false,
                ),
                'template_adder' => array(
                    'position' => 'right',
                    'show_list' => false,
                    'button_text' => esc_html__( 'Add Option', 'woopcd-partialcod-pro' ),
                ),
            );



            return $in_fields;
        }

        private static function get_default_cron_options() {
            return array(
                array(
                    'cron_option_type' => 'cron_default',
                    'option_id' => '2234343',
                ),
            );
        }

        private static function get_default_order_totals_options() {
            return array(
                array(
                    'calc_option_type' => 'calc_default',
                    'title' => esc_html__( 'Subtotal', 'woopcd-partialcod-pro' ),
                    'include' => array( 'subtotal', 'subtotal_tax' ),
                    'option_id' => '2234343',
                ),
            );
        }

    }

    WOOPCD_PartialCOD_Premium_Admin_Order_Activity_Settings::init();
}