<?php

if ( !class_exists( 'Reon' ) ) {
    return;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Premium_Admin_RiskFree_Settings' ) ) {

    class WOOPCD_PartialCOD_Premium_Admin_RiskFree_Settings {

        public static function init() {
            add_filter( 'woopcd_partialcod-admin/get-settings-section-fields', array( new self, 'get_fields' ), 20 );
            add_filter( 'reon/get-simple-repeater-field-riskfree_cart_totals-templates', array( new self(), 'get_option_templates' ), 10, 2 );

            add_filter( 'roen/get-simple-repeater-template-riskfree_cart_totals-calc_default-fields', array( new self(), 'get_template_fields' ), 10, 2 );
            add_filter( 'roen/get-simple-repeater-template-riskfree_cart_totals-calc_option-fields', array( new self(), 'get_template_fields' ), 10, 2 );

            add_filter( 'woopcd_partialcod-admin/get-data-list-riskfree_carttotals', array( new self(), 'get_data_list' ), 10, 2 );
        }

        public static function get_fields( $in_fields ) {



            $in_fields[] = array(
                'id' => 'any_id',
                'type' => 'panel',
                'last' => true,
                'white_panel' => false,
                'panel_size' => 'smaller',
                'width' => '100%',
                'merge_fields' => false,
                'fields' => self::get_settings_fields( array() ),
            );


            return $in_fields;
        }

        public static function get_option_templates( $in_templates, $repeater_args ) {
            if ( $repeater_args[ 'screen' ] == 'option-page' && $repeater_args[ 'option_name' ] == WOOPCD_PartialCOD_Admin_Page::get_option_name() ) {


                $in_templates[] = array(
                    'id' => 'calc_default',
                    'empy_button' => true,
                );

                $in_templates[] = array(
                    'id' => 'calc_option',
                );
            }

            return $in_templates;
        }

        public static function get_template_fields( $in_fields, $repeater_args ) {
            if ( $repeater_args[ 'screen' ] == 'option-page' && $repeater_args[ 'option_name' ] == WOOPCD_PartialCOD_Admin_Page::get_option_name() ) {

                $in_fields[] = array(
                    'id' => 'option_id',
                    'type' => 'autoid',
                    'autoid' => 'partialcod',
                );

                $in_fields[] = array(
                    'id' => 'title',
                    'type' => 'textbox',
                    'default' => esc_html__( 'Cart subtotal', 'woopcd-partialcod-pro' ),
                    'placeholder' => esc_html__( 'Title here...', 'woopcd-partialcod-pro' ),
                    'width' => '98%',
                    'box_width' => '36%',
                );


                $in_fields[] = array(
                    'id' => 'include',
                    'type' => 'select2',
                    'multiple' => true,
                    'default' => array( 'subtotal' ),
                    'options' => self::get_calc_options(),
                    'width' => '100%',
                    'box_width' => '64%',
                );
            }
            return $in_fields;
        }

        public static function get_calc_options() {

            $options = array();

            $options[ 'subtotal' ] = esc_html__( 'Add subtotal', 'woopcd-partialcod-pro' );
            $options[ 'subtotal_tax' ] = esc_html__( 'Add subtotal tax', 'woopcd-partialcod-pro' );
            $options[ 'coupons' ] = esc_html__( 'Add coupons', 'woopcd-partialcod-pro' );
            $options[ 'coupons_taxes' ] = esc_html__( 'Add coupon taxes', 'woopcd-partialcod-pro' );
            $options[ 'n_coupons' ] = esc_html__( 'Subtract coupons', 'woopcd-partialcod-pro' );
            $options[ 'n_coupons_taxes' ] = esc_html__( 'Subtract coupon taxes', 'woopcd-partialcod-pro' );
            $options[ 'fees' ] = esc_html__( 'Add fees', 'woopcd-partialcod-pro' );
            $options[ 'fee_taxes' ] = esc_html__( 'Add fee taxes', 'woopcd-partialcod-pro' );
            $options[ 'shipping_cost' ] = esc_html__( 'Add shipping cost', 'woopcd-partialcod-pro' );
            $options[ 'shipping_cost_tax' ] = esc_html__( 'Add shipping cost tax', 'woopcd-partialcod-pro' );

            return apply_filters( 'woopcd_partialcod-admin/partial-payment/get-cart-totals-options', $options );
        }

        public static function get_data_list( $result, $data_args ) {

            global $woopcd_partialcod;


            $options = array();
            if ( isset( $woopcd_partialcod[ 'riskfree_cart_totals' ] ) ) {
                $options = $woopcd_partialcod[ 'riskfree_cart_totals' ];
            } else {
                $options = self::get_default_options();
            }

            foreach ( $options as $option ) {
                $result[ $option[ 'option_id' ] ] = $option[ 'title' ];
            }

            return $result;
        }

        private static function get_default_options() {
            return array(
                array(
                    'calc_option_type' => 'calc_default',
                    'title' => esc_html__( 'Subtotal including tax', 'woopcd-partialcod-pro' ),
                    'include' => array( 'subtotal', 'subtotal_tax' ),
                    'option_id' => '2234343',
                ),
                array(
                    'calc_option_type' => 'calc_option',
                    'title' => esc_html__( 'Subtotal excluding tax', 'woopcd-partialcod-pro' ),
                    'include' => array( 'subtotal' ),
                    'option_id' => '2234344',
                ),
            );
        }

        private static function get_settings_fields( $in_fields ) {


            $in_fields[] = array(
                'id' => 'any_idssa',
                'type' => 'paneltitle',
                'full_width' => true,
                'center_head' => true,
                'title' => esc_html__( 'Partial Payment Settings', 'woopcd-partialcod-pro' ),
                'desc' => esc_html__( 'Use these settings to control partial payments basic settings', 'woopcd-partialcod-pro' ),
            );


            $in_fields[] = array(
                'id' => 'riskfree_settings',
                'type' => 'columns-field',
                'columns' => 4,
                'merge_fields' => true,
                'fields' => array(
                    array(
                        'id' => 'enable_on_cart',
                        'type' => 'select2',
                        'column_size' => 1,
                        'tooltip' => esc_html__( 'Enables partial payments on cart page', 'woopcd-partialcod-pro' ),
                        'column_title' => esc_html__( 'Enable On Cart Page', 'woopcd-partialcod-pro' ),
                        'default' => array( 'no' ),
                        'options' => array(
                            'no' => esc_html__( 'No', 'woopcd-partialcod-pro' ),
                            'yes' => esc_html__( 'Yes', 'woopcd-partialcod-pro' ),
                        ),
                        'width' => '100%',
                    ),
                    array(
                        'id' => 'enable_on_my_account',
                        'type' => 'select2',
                        'column_size' => 1,
                        'tooltip' => esc_html__( 'Enables partial payments on "My Account" page', 'woopcd-partialcod-pro' ),
                        'column_title' => esc_html__( 'Enable On "My Account" Page', 'woopcd-partialcod-pro' ),
                        'default' => array( 'yes_only' ),
                        'options' => array(
                            'no' => esc_html__( 'No', 'woopcd-partialcod-pro' ),
                            'yes_only' => esc_html__( 'Yes, add details only', 'woopcd-partialcod-pro' ),
                            'yes' => esc_html__( 'Yes, adjust total + add details', 'woopcd-partialcod-pro' ),
                        ),
                        'width' => '100%',
                    ),
                    array(
                        'id' => 'enable_on_email',
                        'type' => 'select2',
                        'column_size' => 1,
                        'tooltip' => esc_html__( 'Enables partial payments in order emails', 'woopcd-partialcod-pro' ),
                        'column_title' => esc_html__( 'Enable In Emails', 'woopcd-partialcod-pro' ),
                        'default' => array( 'yes_only' ),
                        'options' => array(
                            'no' => esc_html__( 'No', 'woopcd-partialcod-pro' ),
                            'yes_only' => esc_html__( 'Yes, add details only', 'woopcd-partialcod-pro' ),
                            'yes' => esc_html__( 'Yes, adjust total + add details', 'woopcd-partialcod-pro' ),
                        ),
                        'width' => '100%',
                    ),
                    array(
                        'id' => 'enable_on_rest_api',
                        'type' => 'select2',
                        'column_size' => 1,
                        'tooltip' => esc_html__( 'Enables partial payments in REST API', 'woopcd-partialcod-pro' ),
                        'column_title' => esc_html__( 'Enable In REST API', 'woopcd-partialcod-pro' ),
                        'default' => array( 'yes_only' ),
                        'options' => array(
                            'no' => esc_html__( 'No', 'woopcd-partialcod-pro' ),
                            'yes_only' => esc_html__( 'Yes, add details only', 'woopcd-partialcod-pro' ),
                            'yes' => esc_html__( 'Yes, adjust total + add details', 'woopcd-partialcod-pro' ),
                        ),
                        'width' => '100%',
                    ),
                ),
            );



            $in_fields[] = array(
                'id' => 'riskfree_text',
                'type' => 'columns-field',
                'columns' => 3,
                'merge_fields' => true,
                'fields' => array(
                    array(
                        'id' => 'advance_pay',
                        'type' => 'textbox',
                        'tooltip' => esc_html__( 'Controls partial payment text on cart, checkout, my account and/or emails', 'woopcd-partialcod-pro' ),
                        'column_size' => 1,
                        'column_title' => esc_html__( 'Partial Payment Text', 'woopcd-partialcod-pro' ),
                        'default' => esc_html__( 'Partial Payment', 'woopcd-partialcod-pro' ),
                        'placeholder' => esc_html__( 'Type here...', 'woopcd-partialcod-pro' ),
                        'width' => '100%',
                    ),
                    array(
                        'id' => 'advance_method',
                        'type' => 'textbox',
                        'tooltip' => esc_html__( 'Controls partial payment method text on order received, my account and/or order emails', 'woopcd-partialcod-pro' ),
                        'column_size' => 1,
                        'column_title' => esc_html__( 'Partial Payment Method Text', 'woopcd-partialcod-pro' ),
                        'default' => esc_html__( 'Partial Payment Method', 'woopcd-partialcod-pro' ),
                        'placeholder' => esc_html__( 'Type here...', 'woopcd-partialcod-pro' ),
                        'width' => '100%',
                    ),
                    array(
                        'id' => 'delivery_pay',
                        'type' => 'textbox',
                        'tooltip' => esc_html__( 'Controls remaining amount text on cart, checkout, my account and/or emails', 'woopcd-partialcod-pro' ),
                        'column_size' => 1,
                        'column_title' => esc_html__( 'Remaining Amount Text', 'woopcd-partialcod-pro' ),
                        'default' => esc_html__( 'Remaining Amount (i.e amount to be paid)', 'woopcd-partialcod-pro' ),
                        'placeholder' => esc_html__( 'Type here...', 'woopcd-partialcod-pro' ),
                        'width' => '100%',
                    ),
                ),
            );




            $in_fields[] = array(
                'id' => 'riskfree_checkbox',
                'type' => 'columns-field',
                'columns' => 5,
                'merge_fields' => true,
                'fields' => array(
                    array(
                        'id' => 'enabled',
                        'type' => 'select2',
                        'column_size' => 2,
                        'tooltip' => esc_html__( 'Enables partial payment method`s checkbox customization', 'woopcd-partialcod-pro' ),
                        'column_title' => esc_html__( 'Customize Checkbox', 'woopcd-partialcod-pro' ),
                        'default' => array( 'no' ),
                        'options' => array(
                            'no' => esc_html__( 'No', 'woopcd-partialcod-pro' ),
                            'yes' => esc_html__( 'Yes', 'woopcd-partialcod-pro' ),
                        ),
                        'width' => '100%',
                        'fold_id' => 'customize_checkbox',
                    ),
                    array(
                        'id' => 'color',
                        'type' => 'colorpicker',
                        'tooltip' => esc_html__( 'Controls partial payment checkbox color', 'woopcd-partialcod-pro' ),
                        'column_size' => 1,
                        'column_title' => esc_html__( 'Color', 'woopcd-partialcod-pro' ),
                        'default' => '#fff',
                        'buton_text' => esc_html__( 'Pick color', 'woopcd-partialcod-pro' ),
                        'width' => '100%',
                        'fold' => array(
                            'target' => 'customize_checkbox',
                            'attribute' => 'value',
                            'value' => array( 'yes' ),
                            'oparator' => 'eq',
                            'clear' => false,
                        ),
                    ),
                    array(
                        'id' => 'border_color',
                        'type' => 'colorpicker',
                        'tooltip' => esc_html__( 'Controls partial payment checkbox border color', 'woopcd-partialcod-pro' ),
                        'column_size' => 1,
                        'column_title' => esc_html__( 'Border Color', 'woopcd-partialcod-pro' ),
                        'default' => '#6d6d6d',
                        'buton_text' => esc_html__( 'Pick color', 'woopcd-partialcod-pro' ),
                        'width' => '100%',
                        'fold' => array(
                            'target' => 'customize_checkbox',
                            'attribute' => 'value',
                            'value' => array( 'yes' ),
                            'oparator' => 'eq',
                            'clear' => false,
                        ),
                    ),
                    array(
                        'id' => 'bg_color',
                        'type' => 'colorpicker',
                        'tooltip' => esc_html__( 'Controls partial payment checkbox background color', 'woopcd-partialcod-pro' ),
                        'column_size' => 1,
                        'column_title' => esc_html__( 'Background Color', 'woopcd-partialcod-pro' ),
                        'default' => '#6d6d6d',
                        'buton_text' => esc_html__( 'Pick color', 'woopcd-partialcod-pro' ),
                        'width' => '100%',
                        'fold' => array(
                            'target' => 'customize_checkbox',
                            'attribute' => 'value',
                            'value' => array( 'yes' ),
                            'oparator' => 'eq',
                            'clear' => false,
                        ),
                    ),
                ),
            );



            $in_fields[] = array(
                'id' => 'any_idssa',
                'type' => 'paneltitle',
                'full_width' => true,
                'center_head' => true,
                'title' => esc_html__( 'Cart Totals Calculations', 'woopcd-partialcod-pro' ),
                'desc' => esc_html__( 'Use these settings to control what are included in the "based on" cart percentage totals &amp; the "cart totals" conditions', 'woopcd-partialcod-pro' ),
            );


            $in_fields[] = array(
                'id' => 'riskfree_cart_totals',
                'type' => 'simple-repeater',
                'full_width' => true,
                'center_head' => true,
                'white_repeater' => true,
                'repeater_size' => 'smaller',
                'buttons_sep' => false,
                'buttons_box_width' => '65px',
                'width' => '100%',
                'default' => self::get_default_options(),
                'static_template' => 'calc_default',
                'section_type_id' => 'calc_option_type',
                'sortable' => array(
                    'enabled' => false,
                ),
                'template_adder' => array(
                    'position' => 'right',
                    'show_list' => false,
                    'button_text' => esc_html__( 'Add Option', 'woopcd-partialcod-pro' ),
                ),
            );


            return $in_fields;
        }

    }

    WOOPCD_PartialCOD_Premium_Admin_RiskFree_Settings::init();
}