<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Polylang_Partial_COD' ) ) {

    class WOOPCD_PartialCOD_Polylang_Partial_COD {

        public function __construct() {

            add_filter( 'woopcd_partialcod/get-partial-payment-data', array( $this, 'tranlate_riskfree_data' ), 10 );
        }

        public function tranlate_riskfree_data( $riskfree_data ) {

            if ( !count( $riskfree_data ) ) {

                return $riskfree_data;
            }

            $keys = array_keys( $riskfree_data );

            foreach ( $keys as $key ) {

                $riskfree_data[ $key ] = $this->tranlate_data( $riskfree_data[ $key ] );
            }

            return $riskfree_data;
        }

        private function tranlate_data( $data ) {

            if ( !isset( $data[ 'desc' ] ) ) {

                return $data;
            }

            if ( !isset( $data[ 'method_id' ] ) ) {

                return $data;
            }

            $method_id = $data[ 'method_id' ];

            $prefix = $this->get_prefix( $method_id, $data[ 'rule_id' ] );

            $string_id = $prefix . 'desc';

            $data[ 'desc' ] = WOOPCD_PartialCOD_Polylang::get_translated_string( $data[ 'desc' ], $string_id );

            return $data;
        }

        public function get_strings( $options, $method_id ) {

            $option_strings = array();

            $method_key = $method_id . '_riskfree_rules';

            if ( !isset( $options[ $method_key ] ) ) {

                return $option_strings;
            }

            foreach ( $options[ $method_key ] as $partial_cod_options ) {

                $rule_id = $partial_cod_options[ 'rule_id' ];

                $prefix = $this->get_prefix( $method_id, $rule_id );

                $option_strings[ $prefix . 'desc' ] = array(
                    'value' => $partial_cod_options[ 'desc' ],
                    'is_multiline' => true
                );
            }

            return $option_strings;
        }

        private function get_prefix( $method_id, $rule_id ) {

            return 'woopcd_' . $method_id . '_partial_' . $rule_id . '_';
        }

    }

}