<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_WOOCS_Partial_COD' ) ) {

    class WOOPCD_PartialCOD_WOOCS_Partial_COD {

        public function __construct() {

            add_filter( 'woopcd_partialcod/get-partial-payment-data', array( $this, 'get_data' ), 10 );
        }

        public function get_data( $data ) {

            $converter = $this->get_converter();

            $keys = array_keys( $data );

            foreach ( $keys as $key ) {

                if ( !isset( $data[ $key ][ 'totals' ] ) ) {

                    continue;
                }

                $data[ $key ][ 'totals' ] = $converter->convert_amount( $data[ $key ][ 'totals' ] );
                $data[ $key ][ 'total_tax' ] = $converter->convert_amount( $data[ $key ][ 'total_tax' ] );
                $data[ $key ][ 'advance_pay' ] = $converter->convert_amount( $data[ $key ][ 'advance_pay' ] );
                $data[ $key ][ 'delivery_pay' ] = $converter->convert_amount( $data[ $key ][ 'delivery_pay' ] );
            }

            return $data;
        }

        private function get_converter() {

            return WOOPCD_PartialCOD_WOOCS::get_instance();
        }

    }

    new WOOPCD_PartialCOD_WOOCS_Partial_COD();
}
