<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_WPML_Settings' ) ) {

    class WOOPCD_PartialCOD_WPML_Settings {

        public function __construct() {

            add_filter( 'woopcd_partialcod/get-advance-payment-info', array( $this, 'tranlate_info' ), 10 );
        }

        public function tranlate_info( $advanc_info ) {

            $prefix = $this->get_prefix();

            if ( isset( $advanc_info[ 'advance_pay_text' ] ) ) {

                $advance_pay_text_string_id = $prefix . 'advance_pay';

                $advanc_info[ 'advance_pay_text' ] = WOOPCD_PartialCOD_WPML::get_translated_string( $advanc_info[ 'advance_pay_text' ], $advance_pay_text_string_id );
            }
            
            if ( isset( $advanc_info[ 'advance_method_text' ] ) ) {

                $advance_method_text_string_id = $prefix . 'advance_method';

                $advanc_info[ 'advance_method_text' ] = WOOPCD_PartialCOD_WPML::get_translated_string( $advanc_info[ 'advance_method_text' ], $advance_method_text_string_id );
            }

            if ( isset( $advanc_info[ 'delivery_pay_text' ] ) ) {

                $delivery_pay_text_string_id = $prefix . 'delivery_pay';

                $advanc_info[ 'delivery_pay_text' ] = WOOPCD_PartialCOD_WPML::get_translated_string( $advanc_info[ 'delivery_pay_text' ], $delivery_pay_text_string_id );
            }

            return $advanc_info;
        }

        public function get_strings( $options ) {

            $option_strings = array();

            if ( !isset( $options[ 'riskfree_text' ] ) ) {

                return $option_strings;
            }

            $text_option = $options[ 'riskfree_text' ];

            $prefix = $this->get_prefix();

            $option_strings[ $prefix . 'advance_pay' ] = array(
                'value' => $text_option[ 'advance_pay' ],
                'is_multiline' => true
            );

            $option_strings[ $prefix . 'advance_method' ] = array(
                'value' => $text_option[ 'advance_method' ],
                'is_multiline' => true
            );

            $option_strings[ $prefix . 'delivery_pay' ] = array(
                'value' => $text_option[ 'delivery_pay' ],
                'is_multiline' => true
            );

            return $option_strings;
        }

        private function get_prefix() {

            return 'woopcd_';
        }

    }

}
