<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Premium_Main' ) ) {
    
    require_once dirname( __FILE__ ) . '/public/partialcod-ajax.php';

    class WOOPCD_PartialCOD_Premium_Main {

        public static function init() {

            if ( !defined( 'WOOPCD_PARTIALCOD_PRO_ASSETS_URL' ) ) {

                define( 'WOOPCD_PARTIALCOD_PRO_ASSETS_URL', plugins_url( 'assets/', __FILE__ ) );
            }

            if ( is_admin() ) {
                
                add_action( 'reon/init', array( new self(), 'load_admin_page' ) );
                add_action( 'admin_enqueue_scripts', array( new self(), 'enqueue_admin_scripts' ), 20 );
            } else {
                add_action( 'wp_enqueue_scripts', array( new self(), 'enqueue_public_scripts' ), 9999 );
            }

            add_action( 'init', array( new self(), 'init_public' ) );

            require_once dirname( __FILE__ ) . '/compatibility/compatibility.php';
        }

        public static function load_admin_page() {

            require_once (dirname( __FILE__ ) . '/admin/admin.php');
        }

        public static function init_public() {

            require_once dirname( __FILE__ ) . '/public/partialcod.php';
        }

        public static function enqueue_admin_scripts() {

            //FreshDesk Help
            if ( isset( $_GET[ 'page' ] ) && $_GET[ 'page' ] == WOOPCD_PartialCOD_Admin_Page::get_page_slug() ) {

                self::enqueue_freshdesk_widget( '51000000763' );
            }
        }

        public static function enqueue_public_scripts() {
            
            wp_enqueue_style( 'partialcod-pro-public-styles', WOOPCD_PARTIALCOD_PRO_ASSETS_URL . 'public-styles.min.css', array(), '1.0', 'all' );
            wp_enqueue_script( 'partialcod-pro-public-scripts', WOOPCD_PARTIALCOD_PRO_ASSETS_URL . 'public-scripts.min.js', array( 'partialcod-public-scripts' ), '1.0', true );


            //CheckBox CSS

            $riskfree_checkbox = WOOPCD_PartialCOD::get_option( 'riskfree_checkbox', array( 'enabled' => 'no' ) );

            $custmize_rf_checkbox = false;
            
            if ( 'yes' == $riskfree_checkbox[ 'enabled' ] ) {

                $rf_custom_css = '.rf_custom_box label .rf_span{
                    background-color: ' . esc_attr( $riskfree_checkbox[ 'bg_color' ] ) . ';
                    border:1px solid ' . esc_attr( $riskfree_checkbox[ 'border_color' ] ) . ';

                }
                .rf_custom_box label .rf_span:before{
                    border-color:' . esc_attr( $riskfree_checkbox[ 'color' ] ) . ';
                }
                ';
                
                wp_add_inline_style( 'partialcod-pro-public-styles', $rf_custom_css );
            }
        }

        private static function enqueue_freshdesk_widget( $widget_id ) {

            $freshdesk_script = 'window.fwSettings={'
                    . " 'widget_id':" . $widget_id . " };"
                    . '!function(){if("function"!=typeof window.FreshworksWidget){var n=function(){n.q.push(arguments)};n.q=[],window.FreshworksWidget=n}}() ';

            wp_enqueue_script( 'freshdesk', 'https://aus-widget.freshworks.com/widgets/' . $widget_id . '.js', array(), false, true );
            wp_add_inline_script( 'freshdesk', $freshdesk_script, 'before' );
        }

    }

}
