<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Cart_Total_Types_Cart_Discounts' ) ) {

    class WOOPCD_PartialCOD_Cart_Total_Types_Cart_Discounts {

        public function calc_totals( $totals, $option, $cart_data ) {

            $discount_totals = $this->get_discount_totals( $cart_data );

            if ( 'partialcod_discounts' == $option ) {
                $totals += $discount_totals[ 'total' ];
            }
            if ( 'partialcod_discount_taxes' == $option ) {
                $totals += $discount_totals[ 'total_tax' ];
            }

            if ( 'n_partialcod_discounts' == $option ) {
                $totals -= $discount_totals[ 'total' ];
            }

            if ( 'n_partialcod_discount_taxes' == $option ) {
                $totals -= $discount_totals[ 'total_tax' ];
            }

            return $totals;
        }

        private function get_discount_totals( $cart_data ) {
            $discount_totals = array(
                'total' => 0,
                'total_tax' => 0
            );

            if ( !isset( $cart_data[ 'discounts' ] ) ) {
                return $discount_totals;
            }

            foreach ( $cart_data[ 'discounts' ] as $discount ) {

                $discount_totals[ 'total' ] += $discount[ 'amount' ];
                $discount_totals[ 'total_tax' ] += $discount[ 'amount_tax' ];
            }

            return $discount_totals;
        }

    }

}