<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Cart_Total_Types_Cart_Fees' ) ) {

    class WOOPCD_PartialCOD_Cart_Total_Types_Cart_Fees {

        public function calc_totals( $totals, $option, $cart_data ) {

            $fee_totals = $this->get_fee_totals( $cart_data );

            if ( 'partialcod_fees' == $option ) {
                $totals += $fee_totals[ 'total' ];
            }
            if ( 'partialcod_fee_taxes' == $option ) {
                $totals += $fee_totals[ 'total_tax' ];
            }


            return $totals;
        }

        private function get_fee_totals( $cart_data ) {

            $fee_totals = array(
                'total' => 0,
                'total_tax' => 0
            );

         

            if ( !isset( $cart_data[ 'fees' ] ) ) {
                return $fee_totals;
            }



            foreach ( $cart_data[ 'fees' ] as $fee ) {

                $fee_totals[ 'total' ] += $fee[ 'amount' ];
                $fee_totals[ 'total_tax' ] += $fee[ 'amount_tax' ];
            }

            return $fee_totals;
        }

    }

}