<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Cart_Total_Types_Coupons' ) ) {

    class WOOPCD_PartialCOD_Cart_Total_Types_Coupons {

        public function calc_totals( $totals, $option, $cart_data ) {

            if ( 'coupons' == $option ) {
                $totals += $this->get_coupons_total( $cart_data );
            }
            
            if ( 'coupons_taxes' == $option ) {
                $totals += $this->get_coupons_total_tax( $cart_data );
            }

            if ( 'n_coupons' == $option ) {
                $totals -= $this->get_coupons_total( $cart_data );
            }
            
            if ( 'n_coupons_taxes' == $option ) {
                $totals -= $this->get_coupons_total_tax( $cart_data );
            }


           

            return $totals;
        }

        private function get_coupons_total( $cart_data ) {
           
            $coupons_totals = $this->get_coupon_totals( $cart_data );
            return $coupons_totals[ 'total' ];
        }

        private function get_coupons_total_tax( $cart_data ) {
           
            $coupons_totals = $this->get_coupon_totals( $cart_data );
            return $coupons_totals[ 'total_tax' ];
        }

        private function get_coupon_totals( $cart_data ) {
            $partialcod_coupons = array();
            if ( isset( $cart_data[ 'wc' ][ 'partialcod_coupons' ] ) ) {
                $partialcod_coupons = $cart_data[ 'wc' ][ 'partialcod_coupons' ];
            }
            $coupons_totals = array(
                'total' => 0,
                'total_tax' => 0
            );

            if ( !isset( $cart_data[ 'wc' ][ 'applied_coupons' ] ) ) {
                return $coupons_totals;
            }

            foreach ( $cart_data[ 'wc' ][ 'applied_coupons' ] as $coupon ) {
                if ( !in_array( $coupon[ 'coupon_code' ], $partialcod_coupons ) ) {

                    $coupons_totals[ 'total' ] += $coupon[ 'discount_totals' ];
                    $coupons_totals[ 'total_tax' ] += $coupon[ 'discount_tax_totals' ];
                }
            }

            return $coupons_totals;
        }

    }

}