<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Cart_Total_Types_Fees' ) ) {

    class WOOPCD_PartialCOD_Cart_Total_Types_Fees {

        public function calc_totals( $totals, $option, $cart_data ) {

            $fee_totals = $this->get_fee_data( $cart_data );

            if ( 'fees' == $option ) {
                $totals += $fee_totals[ 'total' ];
            }

            if ( 'fee_taxes' == $option ) {
                $totals += $fee_totals[ 'total_tax' ];
            }

            return $totals;
        }

        private function get_fee_data( $cart_data ) {
            $fee_totals = array(
                'total' => $cart_data[ 'wc' ][ 'totals' ][ 'fee_total' ],
                'total_tax' => $cart_data[ 'wc' ][ 'totals' ][ 'fee_tax' ],
            );


            foreach ( $cart_data[ 'wc' ][ 'external_fees' ] as $fee ) {
                $fee_totals[ 'total' ] += $fee[ 'total' ];
                $fee_totals[ 'total_tax' ] += $fee[ 'tax' ];
            }

            if ( $fee_totals[ 'total' ] < 0 ) {
                $fee_totals = array(
                    'total' => 0,
                    'total_tax' => 0,
                );
            }
            return $fee_totals;
        }

    }

}