<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Cart_Total_Types_Shipping' ) ) {

    class WOOPCD_PartialCOD_Cart_Total_Types_Shipping {

        public function calc_totals( $totals, $option, $cart_data ) {
            $shipping_totals = $this->get_shipping_totals( $cart_data );
            if ( 'shipping_cost' == $option ) {
                $totals += $shipping_totals['total'];
            }
            if ( 'shipping_cost_tax' == $option ) {
               $totals += $shipping_totals['total_tax']; 
            }

            return $totals;
        }

        private function get_shipping_totals( $cart_data ) {

            $shipping_totals = array(
                'total' => 0,
                'total_tax' => 0
            );

            if ( !isset( $cart_data[ 'wc' ][ 'shipping_rates' ] ) ) {
                return $shipping_totals;
            }

            foreach ( $cart_data[ 'wc' ][ 'shipping_rates' ] as $shipping_total ) {

                $shipping_totals[ 'total' ] += $shipping_total[ 'cost' ];
                $shipping_totals[ 'total_tax' ] += $shipping_total[ 'shipping_tax' ];
            }

            return $shipping_totals;
        }

    }

}
