<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Premium_Cart_Total_Types' ) ) {
    WOOPCD_PartialCOD_Main::required_paths( dirname( __FILE__ ), array( 'cart-total-types.php' ) );

    class WOOPCD_PartialCOD_Premium_Cart_Total_Types {

        public function get_totals( $totals, $option, $cart_data ) {

            switch ( $option ) {
                case 'coupons':
                case 'coupons_taxes':
                case 'n_coupons':
                case 'n_coupons_taxes':

                    $coupons_totals = new WOOPCD_PartialCOD_Cart_Total_Types_Coupons();
                    $totals = $coupons_totals->calc_totals( $totals, $option, $cart_data );

                    break;
                case 'fees':
                case 'fee_taxes':

                    $fee_totals = new WOOPCD_PartialCOD_Cart_Total_Types_Fees();
                    $totals = $fee_totals->calc_totals( $totals, $option, $cart_data );

                    break;
                case 'shipping_cost':
                case 'shipping_cost_tax':

                    $shipping_cost = new WOOPCD_PartialCOD_Cart_Total_Types_Shipping();
                    $totals = $shipping_cost->calc_totals( $totals, $option, $cart_data );

                    break;
                case 'partialcod_discounts':
                case 'partialcod_discount_taxes':
                case 'n_partialcod_discounts':
                case 'n_partialcod_discount_taxes':

                    $cart_discounts = new WOOPCD_PartialCOD_Cart_Total_Types_Cart_Discounts();
                    $totals = $cart_discounts->calc_totals( $totals, $option, $cart_data );

                    break;
                case 'partialcod_fees':
                case 'partialcod_fee_taxes':

                    $cart_fees = new WOOPCD_PartialCOD_Cart_Total_Types_Cart_Fees();
                    $totals = $cart_fees->calc_totals( $totals, $option, $cart_data );                    
                    
                    break;
                default:

                    break;
            }

            return $totals;
        }

    }

}