<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Conditions_GeoLocation' ) ) {

    class WOOPCD_PartialCOD_Conditions_GeoLocation {

        public function __construct() {
            add_filter( 'woopcd_partialcod/validate-geo_continents-condition', array( $this, 'validate_continent' ), 10 );
            add_filter( 'woopcd_partialcod/validate-geo_countries-condition', array( $this, 'validate_countries' ), 10 );
        }

        public function validate_continent( $condition ) {

            if ( !isset( $condition[ 'continents' ] ) ) {
                return false;
            }

            $rule_continents = $condition[ 'continents' ];

            $rule_compare = $condition[ 'compare' ];

            if ( !is_array( $rule_continents ) ) {
                return false;
            }

            $ip_address = WC_Geolocation::get_ip_address();

            $geo_location = WC_Geolocation::geolocate_ip( $ip_address );

            if ( !isset( $geo_location[ 'country' ] ) || empty( $geo_location[ 'country' ] ) ) {
                return false;
            }

            $wc_Countries = new WC_Countries();

            $continent = $wc_Countries->get_continent_code_for_country( $geo_location[ 'country' ] );

            return WOOPCD_PartialCOD_Validation_Util::validate_value_list( $continent, $rule_continents, $rule_compare );
        }

        public function validate_countries( $condition ) {

            if ( !isset( $condition[ 'countries' ] ) ) {
                return false;
            }

            $rule_countries = $condition[ 'countries' ];

            $rule_compare = $condition[ 'compare' ];

            if ( !is_array( $rule_countries ) ) {
                return false;
            }


            $ip_address = WC_Geolocation::get_ip_address();


            $geo_location = WC_Geolocation::geolocate_ip( $ip_address );

            if ( !isset( $geo_location[ 'country' ] ) || empty( $geo_location[ 'country' ] ) ) {
                return false;
            }

            $country = $geo_location[ 'country' ];

            return WOOPCD_PartialCOD_Validation_Util::validate_value_list( $country, $rule_countries, $rule_compare );
        }

    }

    new WOOPCD_PartialCOD_Conditions_GeoLocation();
}