<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}


if ( !class_exists( 'WOOPCD_PartialCOD_Premium_Conditions_Shipping_Address' ) ) {

    class WOOPCD_PartialCOD_Premium_Conditions_Shipping_Address {

        public function __construct() {

            add_filter( 'woopcd_partialcod/validate-shipping_continents-condition', array( $this, 'validate_continents' ), 10 );
        }

        public function validate_continents( $condition ) {

            $rule_continents = $condition[ 'continents' ];

            $rule_compare = $condition[ 'compare' ];

            if ( !is_array( $rule_continents ) ) {
                return false;
            }

            $wc_Countries = new WC_Countries();

            $continent = $wc_Countries->get_continent_code_for_country( WC()->customer->get_shipping_country() );

            return WOOPCD_PartialCOD_Validation_Util::validate_value_list( $continent, $rule_continents, $rule_compare );
        }

    }

    new WOOPCD_PartialCOD_Premium_Conditions_Shipping_Address();
}