<?php

if (!defined('ABSPATH')) {
    exit;
}


if (!class_exists('WOOPCD_PartialCOD_Premium_Method_Options_Engine')) {

    class WOOPCD_PartialCOD_Premium_Method_Options_Engine {

        private static $instance = null;

        private static function get_instance() {
            if (null == self::$instance) {
                self::$instance = new self();
            }
            return self::$instance;
        }

        public static function can_apply_rule($rule_head, $cart_data) {

            $prev_rules = self::get_instance()->get_prev_rule_keys($cart_data, $rule_head['method_id']);

            $found_options = count($prev_rules) > 0;


            if ('if_others' == $rule_head['apply_mode'] && !$found_options) {
                return false;
            }

            if ('if_no_others' == $rule_head['apply_mode'] && $found_options) {
                return false;
            }

            if ('first' == $rule_head['settings']['mode'] && $found_options) {
                return false;
            }


            return true;
        }

        public static function add_rule_options($cart_data, $rule_options, $rule_head) {


            $s_mode = $rule_head['settings']['mode'];

            // add last valid rules or only rule if valid
            if ('last' == $s_mode || 'only_this' == $rule_head['apply_mode']) {
                $cart_data = self::get_instance()->force_options_rule($cart_data, $rule_options, $rule_head);
                
                return $cart_data;
            }

            // add rule as usual
            $cart_data['options'][$rule_head['rule_id']] = $rule_options;

            return $cart_data;
        }

        private function force_options_rule($cart_data, $rule_options, $rule_head) {

            // remove rule's previous method options
            $keys = $this->get_prev_rule_keys($cart_data, $rule_head['method_id']);

            foreach ($keys as $key) {
                unset($cart_data['options'][$key]);
            }


            $cart_data['options'][$rule_head['rule_id']] = $rule_options;

            return $cart_data;
        }

        private function get_prev_rule_keys($cart_data, $method_id) {
            $rule_keys = array();
            if (isset($cart_data['options'])) {

                foreach ($cart_data['options'] as $key => $options) {
                    foreach ($options as $option) {
                        if ($method_id == $option['method_id']) {
                            $rule_keys[] = $key;
                            break;
                        }
                    }
                }
            }

            return $rule_keys;
        }

        
    }

}
