<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Method_Options_Account_Details' ) ) {

    class WOOPCD_PartialCOD_Method_Options_Account_Details {

        public function __construct() {

            add_filter( 'woopcd_partialcod/get-account_details-options', array( $this, 'get_option' ), 1, 3 );
            add_filter( 'woopcd_partialcod/apply-account_details-method-option', array( $this, 'apply_option' ), 1, 2 );
        }

        public function get_option( $option, $option_args, $cart_data ) {

            if ( isset( $option_args[ 'account_details' ] ) ) {
                $option[ 'account_details' ] = $option_args[ 'account_details' ];
            }

            return $option;
        }

        public function apply_option( $method, $option ) {

            if ( isset( $option[ 'account_details' ] ) ) {
                $method->account_details = $option[ 'account_details' ];
            }

            return $method;
        }

    }

    new WOOPCD_PartialCOD_Method_Options_Account_Details();
}
