<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Premium_Option_Types_Checkout_All' ) ) {

    class WOOPCD_PartialCOD_Premium_Option_Types_Checkout_All {

        public function __construct() {
            add_filter( 'woopcd_partialcod/get-all-options', array( $this, 'get_option' ), 1, 3 );
            add_filter( 'woopcd_partialcod/apply-all-method-option', array( $this, 'apply_option' ), 1, 2 );
        }

        public static function get_option( $option, $option_args, $cart_data ) {

            if ( isset( $option_args[ 'order_button_text' ] ) ) {
                $option[ 'order_button_text' ] = $option_args[ 'order_button_text' ];
            }

            if ( isset( $option_args[ 'icon_url' ] ) ) {
                $option[ 'icon_url' ] = $option_args[ 'icon_url' ];
            }

            return $option;
        }

        public function apply_option( $method, $option ) {

            if ( isset( $option[ 'order_button_text' ] ) ) {
                $method->order_button_text = $option[ 'order_button_text' ];
            }

            if ( isset( $option[ 'icon_url' ] ) ) {
                $method->icon = $option[ 'icon_url' ];
            }

            return $method;
        }

    }

    new WOOPCD_PartialCOD_Premium_Option_Types_Checkout_All();
}