<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Option_Types_Description' ) ) {

    class WOOPCD_PartialCOD_Option_Types_Description {

        public function __construct() {

            add_filter( 'woopcd_partialcod/get-description-options', array( $this, 'get_option' ), 1, 3 );
            add_filter( 'woopcd_partialcod/apply-description-method-option', array( $this, 'apply_option' ), 1, 2 );
        }

        public function get_option( $option, $option_args, $cart_data ) {

            if ( isset( $option_args[ 'desc' ] ) ) {
                $option[ 'desc' ] = $option_args[ 'desc' ];
            }

            return $option;
        }

        public function apply_option( $method, $option ) {

            if ( isset( $option[ 'desc' ] ) ) {
                $method->description = $option[ 'desc' ];
            }

            return $method;
        }

    }

    new WOOPCD_PartialCOD_Option_Types_Description();
}

