<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Option_Types_Instructions' ) ) {

    class WOOPCD_PartialCOD_Option_Types_Instructions {

        public function __construct() {

            add_filter( 'woopcd_partialcod/get-instructions-options', array( $this, 'get_option' ), 1, 3 );
            add_filter( 'woopcd_partialcod/apply-instructions-method-option', array( $this, 'apply_option' ), 1, 2 );
        }

        public function get_option( $option, $option_args, $cart_data ) {

            if ( isset( $option_args[ 'instructions' ] ) ) {
                $option[ 'instructions' ] = $option_args[ 'instructions' ];
            }

            return $option;
        }

        public function apply_option( $method, $option ) {

            if ( isset( $option[ 'instructions' ] ) ) {
                $method->instructions = $option[ 'instructions' ];
            }

            return $method;
        }

    }

    new WOOPCD_PartialCOD_Option_Types_Instructions();
}
