<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Order_Activity_Trigger_Cron_Scheduler' ) ) {

    class WOOPCD_PartialCOD_Order_Activity_Trigger_Cron_Scheduler {

        public function __construct() {
            if ( WOOPCD_PartialCOD_Order_Activity_Trigger_Types::get_trigger_type_is_active( 'cron_schedulers' ) ) {
                add_action( 'woopcd_partialcod/cron-trigger', array( $this, 'trigger_activities' ), 10, 2 );
            }

            add_filter( 'woopcd_partialcod/order-activities/can-trigger-cron_schedulers-activities', array( $this, 'can_trigger_activities' ), 10, 2 );
        }

        public function trigger_activities( $order_id, $scheduler_id ) {

            $args = array(
                'trigger' => 'cron_schedulers',
                'scheduler_id' => $scheduler_id,
            );

            do_action( 'woopcd_partialcod/trigger-order-activities', $order_id, $args );
        }

        public function can_trigger_activities( $source, $rule ) {

            if ( !isset( $source[ 'scheduler_id' ] ) ) {
                return false;
            }

            if ( !isset( $rule[ 'cron_scheduler_ids' ] ) ) {
                return false;
            }

            $scheduler_id = $source[ 'scheduler_id' ];

            $cron_scheduler_ids = $rule[ 'cron_scheduler_ids' ];

            if ( !is_array( $cron_scheduler_ids ) ) {
                return false;
            }

            $cron_compare = $rule[ 'cron_compare' ];

            return WOOPCD_PartialCOD_Validation_Util::validate_value_list( $scheduler_id, $cron_scheduler_ids, $cron_compare );
        }

    }

    new WOOPCD_PartialCOD_Order_Activity_Trigger_Cron_Scheduler();
}