<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Order_Activity_Trigger_Order_Refunded' ) ) {

    class WOOPCD_PartialCOD_Order_Activity_Trigger_Order_Refunded {

        public function __construct() {
            if ( WOOPCD_PartialCOD_Order_Activity_Trigger_Types::get_trigger_type_is_active( 'order_refunded' ) ) {
                add_action( 'woocommerce_order_refunded', array( $this, 'trigger_activities' ), 10, 2 );
            }

            if ( WOOPCD_PartialCOD_Order_Activity_Trigger_Types::get_trigger_type_is_active( 'order_partially_refunded' ) ) {
                add_action( 'woocommerce_order_partially_refunded', array( $this, 'trigger_activities_partial' ), 10, 2 );
            }

            if ( WOOPCD_PartialCOD_Order_Activity_Trigger_Types::get_trigger_type_is_active( 'order_fully_refunded' ) ) {
                add_action( 'woocommerce_order_fully_refunded', array( $this, 'trigger_activities_fully' ), 10, 2 );
            }
        }

        public function trigger_activities( $order_id, $refunds_id ) {
            $args = array(
                'trigger' => 'order_refunded',
                'refunds_id' => $refunds_id,
            );

            do_action( 'woopcd_partialcod/trigger-order-activities', $order_id, $args );
        }

        public function trigger_activities_partial( $order_id, $refunds_id ) {
           $args = array(
                'trigger' => 'order_partially_refunded',
                'refunds_id' => $refunds_id,
            );
           do_action( 'woopcd_partialcod/trigger-order-activities', $order_id, $args );
        }

        public function trigger_activities_fully( $order_id, $refunds_id ) {
           $args = array(
                'trigger' => 'order_fully_refunded',
                'refunds_id' => $refunds_id,
            ); 
           do_action( 'woopcd_partialcod/trigger-order-activities', $order_id, $args );
        }

    }

    new WOOPCD_PartialCOD_Order_Activity_Trigger_Order_Refunded();
}