<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Order_Activity_Trigger_Status_Changed' ) ) {

    class WOOPCD_PartialCOD_Order_Activity_Trigger_Status_Changed {

        public function __construct() {
            if ( WOOPCD_PartialCOD_Order_Activity_Trigger_Types::get_trigger_type_is_active( 'status_changed' ) ) {
                add_action( 'woocommerce_order_status_changed', array( $this, 'trigger_activities' ), 10, 4 );
            }
        }

        public function trigger_activities( $order_id, $from, $to, $order ) {
            $args = array(
                'trigger' => 'status_changed',
                'from' => $from,
                'to' => $to,
            );

            remove_action( 'woocommerce_order_status_changed', array( $this, 'trigger_activities' ), 10 );

            do_action( 'woopcd_partialcod/trigger-order-activities', $order_id, $args );

            add_action( 'woocommerce_order_status_changed', array( $this, 'trigger_activities' ), 10, 4 );
        }

    }

    new WOOPCD_PartialCOD_Order_Activity_Trigger_Status_Changed();
}