<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Order_Activity_Trigger_Types' ) ) {


    class WOOPCD_PartialCOD_Order_Activity_Trigger_Types {

        public static function get_trigger_type_is_active( $trigger_type ) {
            return in_array( $trigger_type, self::get_active_trigger_types() );
        }

        private static function get_active_trigger_types() {

            $trigger_types = get_transient( 'woopcd_partialcod_active_trigger_types' );

            if ( $trigger_types ) {
                return $trigger_types;
            }

            $trigger_types = array();


            $method_ids = WOOPCD_PartialCOD_Cart::get_method_ids();

            $order_activities_enabled = false;
            foreach ( $method_ids as $method_id ) {
                $settings = WOOPCD_PartialCOD::get_option( $method_id . '_order_activity_rules_settings', array( 'mode' => 'no' ) );
                if ( 'no' != $settings[ 'mode' ] ) {
                    $order_activities_enabled = true;
                    break;
                }
            }


            if ( !$order_activities_enabled ) {
                set_transient( 'woopcd_partialcod_active_trigger_types', $trigger_types, HOUR_IN_SECONDS * 12 );
                return $trigger_types;
            }

            foreach ( $method_ids as $method_id ) {
                $rules = WOOPCD_PartialCOD::get_option( $method_id . '_order_activity_rules', array() );
                foreach ( $rules as $rule ) {
                    if ( isset( $rule[ 'activities_trigger' ] ) && 'yes' == $rule[ 'enable' ] && !in_array( $rule[ 'activities_trigger' ], $trigger_types ) ) {
                        $trigger_types[] = $rule[ 'activities_trigger' ];
                    }
                }
            }

            set_transient( 'woopcd_partialcod_active_trigger_types', $trigger_types, HOUR_IN_SECONDS * 12 );
            return $trigger_types;
        }

    }

    WOOPCD_PartialCOD_Main::required_paths( dirname( __FILE__ ), array( 'order-activity-trigger-types.php' ) );
}
