<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Activity_Types' ) ) {
    WOOPCD_PartialCOD_Main::required_paths( dirname( __FILE__ ), array( 'order-activity-types.php' ) );

    class WOOPCD_PartialCOD_Activity_Types {

        public static function get_activities( $activities, $activities_args, $order_data ) {

            // go through each of the activity args and apply them
            foreach ( $activities_args as $activity_args ) {

                $activity = array(
                    'activity_type' => $activity_args[ 'activity_type' ],
                    'method_id' => $activity_args[ 'method_id' ],
                );

                $activity = apply_filters( 'woopcd_partialcod/get-' . $activity_args[ 'activity_type' ] . '-activities', $activity, $activity_args, $order_data );


                // allows other plugins to modify the activity
                if ( has_filter( 'woopcd_partialcod/gotten-activity' ) ) {
                    $activity = apply_filters( 'woopcd_partialcod/gotten-activity', $activity, $activity_args, $order_data );
                }


                $activities[ $activity_args[ 'activity_id' ] ] = $activity;
            }

            return $activities;
        }

    }

}

