<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Order_Conditions_GeoLocation' ) ) {

    class WOOPCD_PartialCOD_Order_Conditions_GeoLocation {

        public function __construct() {
            add_filter( 'woopcd_partialcod/validate-order-geo_countries-condition', array( $this, 'validate_countries' ), 10, 2 );
        }

        public function validate_countries( $condition, $order_data ) {

            if ( !isset( $condition[ 'countries' ] ) ) {
                return false;
            }

            $rule_countries = $condition[ 'countries' ];

            $rule_compare = $condition[ 'compare' ];

            if ( !is_array( $rule_countries ) ) {
                return false;
            }


            $ip_address = $order_data[ 'wc' ][ 'customer' ][ 'ip_address' ];

            $geo_location = WC_Geolocation::geolocate_ip( $ip_address );

            if ( !isset( $geo_location[ 'country' ] ) || empty( $geo_location[ 'country' ] ) ) {
                return false;
            }

            $country = $geo_location[ 'country' ];

            return WOOPCD_PartialCOD_Validation_Util::validate_value_list( $country, $rule_countries, $rule_compare );
        }

    }

    new WOOPCD_PartialCOD_Order_Conditions_GeoLocation();
}