<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Order_Total_Types_Coupon_Discounts' ) ) {

    class WOOPCD_PartialCOD_Order_Total_Types_Coupon_Discounts {

        public function calc_totals( $totals, $option, $order_data ) {

            $coupon_totals = $this->get_discounts( $order_data );

            if ( 'dicounts' == $option ) {
                $totals += $coupon_totals[ 'total' ];
            }

            if ( 'dicounts_taxes' == $option ) {
                $totals += $coupon_totals[ 'total_tax' ];
            }

            if ( 'n_dicounts' == $option ) {
                $totals -= $coupon_totals[ 'total' ];
            }

            if ( 'n_dicounts_taxes' == $option ) {
                $totals -= $coupon_totals[ 'total_tax' ];
            }

            return $totals;
        }

        private function get_discounts( $order_data ) {

            $coupon_totals = array(
                'total' => 0,
                'total_tax' => 0,
            );

            if ( !isset( $order_data[ 'wc' ][ 'totals' ][ 'discount_total' ] ) ) {
                return $coupon_totals;
            }

            $coupon_totals[ 'total' ] = $order_data[ 'wc' ][ 'totals' ][ 'discount_total' ];
            $coupon_totals[ 'total_tax' ] = $order_data[ 'wc' ][ 'totals' ][ 'discount_tax' ];

            return $coupon_totals;
        }

    }

}