<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Order_Total_Types_Fees' ) ) {

    class WOOPCD_PartialCOD_Order_Total_Types_Fees {

        public function calc_totals( $totals, $option, $order_data ) {
   
            $coupon_totals = $this->get_fees( $order_data );

            if ( 'fees' == $option ) {
                $totals += $coupon_totals[ 'total' ];
            }

            if ( 'fee_taxes' == $option ) {
                $totals += $coupon_totals[ 'total_tax' ];
            }

            return $totals;
        }

        private function get_fees( $order_data ) {

            $fee_totals = array(
                'total' => 0,
                'total_tax' => 0,
            );

            if ( !isset( $order_data[ 'wc' ][ 'fees' ] ) ) {
                return $fee_totals;
            }
     
            foreach ( $order_data[ 'wc' ][ 'fees' ] as $fee_data ) {
                $fee_totals[ 'total' ] += $fee_data[ 'total' ];
                $fee_totals[ 'total_tax' ] += $fee_data[ 'total_tax' ];
            }



            return $fee_totals;
        }

    }

}