<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Order_Total_Types_Refunds' ) ) {

    class WOOPCD_PartialCOD_Order_Total_Types_Refunds {

        public function calc_totals( $totals, $option, $order_data ) {

            $coupon_totals = $this->get_refunds( $order_data );

            if ( 'total_shipping_refunded' == $option ) {
                $totals += $coupon_totals[ 'total_shipping_refunded' ];
            }

            if ( 'total_refunded' == $option ) {
                $totals += $coupon_totals[ 'total_refunded' ];
            }
            
            if ( 'total_tax_refunded' == $option ) {
                $totals += $coupon_totals[ 'total_tax_refunded' ];
            }
            
            if ( 'n_total_shipping_refunded' == $option ) {
                $totals -= $coupon_totals[ 'total_shipping_refunded' ];
            }

            if ( 'n_total_refunded' == $option ) {
                $totals -= $coupon_totals[ 'total_refunded' ];
            }
            
            if ( 'n_total_tax_refunded' == $option ) {
                $totals -= $coupon_totals[ 'total_tax_refunded' ];
            }

            return $totals;
        }

        private function get_refunds( $order_data ) {

            $totals = array(
                'total_shipping_refunded' => 0,
                'total_refunded' => 0,
                'total_tax_refunded' => 0,
            );

            if ( !isset( $order_data[ 'wc' ][ 'totals' ][ 'total_shipping_refunded' ] ) ) {
                return $totals;
            }

            $totals[ 'total_shipping_refunded' ] = $order_data[ 'wc' ][ 'totals' ][ 'total_shipping_refunded' ];
            $totals[ 'total_refunded' ] = $order_data[ 'wc' ][ 'totals' ][ 'total_refunded' ];
            $totals[ 'total_tax_refunded' ] = $order_data[ 'wc' ][ 'totals' ][ 'total_tax_refunded' ];

            return $totals;
        }

    }

}