<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Order_Total_Types_Shipping_Cost' ) ) {

    class WOOPCD_PartialCOD_Order_Total_Types_Shipping_Cost {

        public function calc_totals( $totals, $option, $order_data ) {
   
            $coupon_totals = $this->get_shiiping_rates( $order_data );

            if ( 'shipping_cost' == $option ) {
                $totals += $coupon_totals[ 'total' ];
            }

            if ( 'shipping_cost_tax' == $option ) {
                $totals += $coupon_totals[ 'total_tax' ];
            }

            return $totals;
        }

        private function get_shiiping_rates( $order_data ) {

            $shipping_totals = array(
                'total' => 0,
                'total_tax' => 0,
            );

            if ( !isset( $order_data[ 'wc' ][ 'shipping_rates' ] ) ) {
                return $shipping_totals;
            }
     
            foreach ( $order_data[ 'wc' ][ 'shipping_rates' ] as $fee_data ) {
                $shipping_totals[ 'total' ] += $fee_data[ 'total' ];
                $shipping_totals[ 'total_tax' ] += $fee_data[ 'total_tax' ];
            }

            return $shipping_totals;
        }

    }

}