<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}


if ( !class_exists( 'WOOPCD_PartialCOD_Ajax' ) ) {

    class WOOPCD_PartialCOD_Ajax {

        public function __construct() {

            add_action( 'wp_ajax_partialcod_rfp', array( $this, 'set_risk_free' ) );
            add_action( 'wp_ajax_nopriv_partialcod_rfp', array( $this, 'set_risk_free' ) );

            add_action( 'woocommerce_before_cart_emptied', array( $this, 'clear_risk_free' ) );
        }

        public function set_risk_free() {
            
            ob_start();

            $method_id = sanitize_key( $_POST[ 'method_id' ] );

            WOOPCD_PartialCOD_Cart::set_session_data( 'rf_method_id', $method_id );

            $output = array(
                'status' => '200',
            );

            ob_clean();
            
            header( "Access-Control-Allow-Origin: *" );
            header( "Content-Type: application/json; charset=UTF-8" );
            
            echo json_encode( $output );
            
            wp_die();
        }

        public function clear_risk_free( $clear_persistent_cart ) {
            
            if( !class_exists( 'WOOPCD_PartialCOD_Cart')){
                
                return;
            }
            
            WOOPCD_PartialCOD_Cart::set_session_data( 'rf_method_id', '' );
        }

    }

    new WOOPCD_PartialCOD_Ajax();
}