<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}


if ( !class_exists( 'WOOPCD_PartialCOD_Email' ) ) {

    class WOOPCD_PartialCOD_Email {

        private $is_email = false;

        public function __construct() {
            $this->is_email = false;            
            add_action( 'woocommerce_email_header', array( $this, 'email_header' ), 999, 2 );
            add_action( 'woocommerce_email_footer', array( $this, 'email_footer' ), 999, 1 );
            add_filter( 'woopcd_partialcod/is_email', array( $this, 'get_is_email' ), 10, 1 );
        }

        public function email_header( $email_heading, $email ) {
            $this->is_email = true;
        }

        public function email_footer( $email ) {
            $this->is_email = false;
        }

        public function get_is_email( $is_email ) {
            return $this->is_email;
        }

        public static function is_email() {
            return apply_filters( 'woopcd_partialcod/is_email', false );
        }

    }

    new WOOPCD_PartialCOD_Email();
}
