<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( !class_exists( 'WOOPCD_PartialCOD_Payment_Amount_Type_Products' ) ) {

    class WOOPCD_PartialCOD_Payment_Amount_Type_Products {

        public function __construct() {
            add_filter( 'woopcd_partialcod/calculate-fixed_products-payment-amount', array( $this, 'calculate_fixed_products_amount' ), 10, 3 );
            add_filter( 'woopcd_partialcod/calculate-per_products-payment-amount', array( $this, 'calculate_per_products_amount' ), 10, 3 );
        }

        public function calculate_fixed_products_amount( $amount, $amount_args, $cart_data ) {

            $item_based_on = $amount_args[ 'item_based_on' ];

            $cart_items = $this->get_cart_items( $cart_data, $amount_args );

            $item_subtotals = $this->get_item_subtotals( $cart_items, $item_based_on );

            $amount = $item_subtotals;

            return $amount;
        }

        public function calculate_per_products_amount( $amount, $amount_args, $cart_data ) {

            if ( 0 >= $amount_args[ 'amount' ] ) {

                return $amount;
            }

            $item_based_on = $amount_args[ 'item_based_on' ];

            $cart_items = $this->get_cart_items( $cart_data, $amount_args );

            $item_subtotals = $this->get_item_subtotals( $cart_items, $item_based_on );

            $amount = ($amount_args[ 'amount' ] / 100) * $item_subtotals;

            return $amount;
        }

        private function get_item_subtotals( $cart_items, $item_based_on ) {
            $subtotal = 0;

            foreach ( $cart_items as $cart_item ) {

                switch ( $item_based_on ) {
                    case 'excl_tax':

                        $subtotal += $cart_item[ 'line_subtotal' ];
                        break;

                    case 'incl_tax_after':

                        $subtotal += $cart_item[ 'line_total' ];
                        $subtotal += $cart_item[ 'line_tax' ];
                        break;

                    case 'excl_tax_after':

                        $subtotal += $cart_item[ 'line_total' ];
                        break;

                    default:

                        $subtotal += $cart_item[ 'line_subtotal' ];
                        $subtotal += $cart_item[ 'line_subtotal_tax' ];
                        break;
                }
            }
            return $subtotal;
        }

        private function get_cart_items( $cart_data, $amount_args ) {

            $product_args = array();

            if ( isset( $amount_args[ 'products_args' ] ) && is_array( $amount_args[ 'products_args' ] ) ) {
                $product_args = $amount_args[ 'products_args' ];
            }

            return WOOPCD_PartialCOD_Product_Filter_Types::get_cart_items( $cart_data, $product_args );
        }

    }

    new WOOPCD_PartialCOD_Payment_Amount_Type_Products();
}
