<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}


if ( !class_exists( 'WOOPCD_PartialCOD_Product_Filter_Type_Prices' ) ) {

    class WOOPCD_PartialCOD_Product_Filter_Type_Prices {

        public function __construct() {

            add_filter( 'woopcd_partialcod/validate-item_price-filter', array( $this, 'validate_prices' ), 1, 2 );
            add_filter( 'woopcd_partialcod/validate-item_price_ex_tax-filter', array( $this, 'validate_prices' ), 1, 2 );
            add_filter( 'woopcd_partialcod/validate-item_d_price-filter', array( $this, 'validate_prices' ), 1, 2 );
            add_filter( 'woopcd_partialcod/validate-item_d_price_ex_tax-filter', array( $this, 'validate_prices' ), 1, 2 );
        }

        public function validate_prices( $filter_args, $cart_item ) {

            $filter_type = $filter_args[ 'filter_type' ];

            $filter_price = 0;

            if ( is_numeric( $filter_args[ 'price' ] ) ) {

                $filter_price = $filter_args[ 'price' ];
            }

            $filter_compare = $filter_args[ 'compare' ];

            $item_price = $this->get_item_price( $filter_type, $cart_item );

            return WOOPCD_PartialCOD_Validation_Util::validate_value( $filter_compare, $item_price, $filter_price, 'no' );
        }

        private function get_item_price( $filter_type, $cart_item ) {

            switch ( $filter_type ) {

                case 'item_price_ex_tax':

                    return $cart_item[ 'line_price' ];

                case 'item_d_price':

                    return $cart_item[ 'line_total_price' ] + $cart_item[ 'line_total_price_tax' ];

                case 'item_d_price_ex_tax':

                    return $cart_item[ 'line_total_price' ];

                default:

                    return $cart_item[ 'line_price' ] + $cart_item[ 'line_price_tax' ];
            }
        }

    }

    new WOOPCD_PartialCOD_Product_Filter_Type_Prices();
}