<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}


if ( !class_exists( 'WOOPCD_PartialCOD_Product_Filter_Type_Subtotals' ) ) {

    class WOOPCD_PartialCOD_Product_Filter_Type_Subtotals {

        public function __construct() {

            add_filter( 'woopcd_partialcod/validate-item_subtotal-filter', array( $this, 'validate_subtotals' ), 1, 2 );
            add_filter( 'woopcd_partialcod/validate-item_subtotal_ex_tax-filter', array( $this, 'validate_subtotals' ), 1, 2 );
            add_filter( 'woopcd_partialcod/validate-item_d_subtotal-filter', array( $this, 'validate_subtotals' ), 1, 2 );
            add_filter( 'woopcd_partialcod/validate-item_d_subtotal_ex_tax-filter', array( $this, 'validate_subtotals' ), 1, 2 );
        }

        public function validate_subtotals( $filter_args, $cart_item ) {

            $filter_type = $filter_args[ 'filter_type' ];

            $filter_subtotal = 0;

            if ( is_numeric( $filter_args[ 'subtotal' ] ) ) {

                $filter_subtotal = $filter_args[ 'subtotal' ];
            }

            $filter_compare = $filter_args[ 'compare' ];

            $item_subtotal = $this->get_item_subtotal( $filter_type, $cart_item );

            return WOOPCD_PartialCOD_Validation_Util::validate_value( $filter_compare, $item_subtotal, $filter_subtotal, 'no' );
        }

        private function get_item_subtotal( $filter_type, $cart_item ) {

            switch ( $filter_type ) {

                case 'item_subtotal_ex_tax':

                    return $cart_item[ 'line_subtotal' ];

                case 'item_d_subtotal':

                    return $cart_item[ 'line_total' ] + $cart_item[ 'line_tax' ];

                case 'item_d_subtotal_ex_tax':

                    return $cart_item[ 'line_total' ];

                default:

                    return $cart_item[ 'line_subtotal' ] + $cart_item[ 'line_subtotal_tax' ];
            }
        }

    }

    new WOOPCD_PartialCOD_Product_Filter_Type_Subtotals();
}