<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}


if ( !class_exists( 'WOOPCD_PartialCOD_Order_Customer_Util' ) ) {

    class WOOPCD_PartialCOD_Order_Customer_Util {

        private static $users = array();

        public static function get_user_email( $order_data ) {

            $user = self::get_user_by_order( $order_data );

            if ( !$user ) {
                return '';
            }

            return $user->user_email;
        }

        public static function get_user_roles( $order_data ) {

            $user = self::get_user_by_order( $order_data );

            if ( !$user ) {
                return array();
            }

            return $user->roles;
        }

        public static function get_user_caps( $order_data ) {

            $user_caps = array();

            $user = self::get_user_by_order( $order_data );

            if ( !$user ) {
                return $user_caps;
            }

            foreach ( $user->allcaps as $key => $user_cap ) {

                if ( $user_cap == true ) {
                    $user_caps[] = $key;
                }
            }

            return $user_caps;
        }

        public static function get_user_meta( $meta_key, $order_data, $default = array() ) {

            if ( !isset( $order_data[ 'wc' ][ 'customer' ][ 'id' ] ) ) {
                return $default;
            }

            $user_id = $order_data[ 'wc' ][ 'customer' ][ 'id' ];

            if ( 0 >= $user_id ) {
                return $default;
            }

            return self::get_meta( $user_id, $meta_key, $default );
        }

        private static function get_user_by_order( $order_data ) {

            if ( !isset( $order_data[ 'wc' ][ 'customer' ][ 'id' ] ) ) {
                return false;
            }

            $user_id = $order_data[ 'wc' ][ 'customer' ][ 'id' ];

            if ( isset( self::$users[ $user_id ] ) ) {

                return self::$users[ $user_id ];
            }

            $user = get_user_by( 'id', $user_id );

            if ( $user ) {
                self::$users[ $user_id ] = $user;
            }

            return $user;
        }

        
        
    }

}