<?php

/**
 * @package    TGM-Plugin-Activation
 * @subpackage TGM-Plugin-Activation
 * @version    2.6.1 for plugin WooCommerce Partial COD - Payment Gateway Restrictions & Fees
 * @author     Thomas Griffin, Gary Jones, Juliette Reinders Folmer
 * @copyright  Copyright (c) 2011, Thomas Griffin
 * @license    http://opensource.org/licenses/gpl-2.0.php GPL v2 or later
 * @link       https://github.com/TGMPA/TGM-Plugin-Activation
 */
/**
 * Include the TGM_Plugin_Activation class.
 */
require_once dirname( __FILE__ ) . '/class-tgm-plugin-activation.php';

if ( !class_exists( 'WOOPCD_PartialCOD_TGMPA' ) ) {

    class WOOPCD_PartialCOD_TGMPA {

        public function __construct() {

            add_action( 'tgmpa_register', array( $this, 'register_required_plugins' ) );
        }

        public function register_required_plugins() {

            $plugins = array(
                // WooCommerce Partial COD - Payment Gateway Restrictions & Fees - https://wordpress.org/plugins/partial-cod-payment-gateway-restrictions-fees/
                array(
                    'name' => esc_html__( 'WooCommerce Partial COD - Payment Gateway Restrictions & Fees', 'woopcd-partialcod-pro' ),
                    'slug' => 'partial-cod-payment-gateway-restrictions-fees',
                    'required' => true,
                    'version' => '1.0',
                    'force_activation' => false,
                    'force_deactivation' => false,
                ),
            );

            /*
             * Array of configuration settings. Amend each line as needed.
             */
            $config = array(
                'id' => 'woopcd-partialcod-tgmpa',
                'menu' => 'woopcd-partialcod-tgmpa-install',
                'parent_slug' => 'plugins.php',
                'capability' => 'manage_options',
                'has_notices' => true,
                'dismissable' => true,
                'dismiss_msg' => '',
                'is_automatic' => true,
                'message' => '',
                'strings' => array(
                    'page_title' => esc_html__( 'Install Required Plugins', 'woopcd-partialcod-pro' ),
                    'menu_title' => esc_html__( 'Install Plugins', 'woopcd-partialcod-pro' ),
                    'notice_can_install_required' => _n_noop(
                            /* translators: 1: plugin name */
                            esc_html__( '"WooCommerce Partial COD - Premium (Add-On)" requires the following plugin: %1$s.', 'woopcd-partialcod-pro' ),
                            /* translators: 1: plugin name */
                            esc_html__( '"WooCommerce Partial COD - Premium (Add-On)" requires the following plugins: %1$s.', 'woopcd-partialcod-pro' ),
                            'woopcd-partialcod-pro'
                    ),
                ),
            );

            tgmpa( $plugins, $config );
        }

    }

}
